﻿

namespace Masterpiece.Animations
{
  public class GridLengthAnimation:System.Windows.Media.Animation.AnimationTimeline
    {


        public System.Windows.GridLength From
        {
            get { return (System.Windows.GridLength)GetValue(FromProperty); }
            set { SetValue(FromProperty, value); }
        }

        // Using a DependencyProperty as the backing store for From.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty FromProperty =
            System.Windows.DependencyProperty.Register("From", typeof(System.Windows.GridLength), typeof(GridLengthAnimation));



        public System.Windows.GridLength To
        {
            get { return (System.Windows.GridLength)GetValue(ToProperty); }
            set { SetValue(ToProperty, value); }
        }

        // Using a DependencyProperty as the backing store for To.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ToProperty =
            System.Windows.DependencyProperty.Register("To", typeof(System.Windows.GridLength), typeof(GridLengthAnimation));

        protected override System.Windows.Freezable CreateInstanceCore()
        {
            return new Animations.GridLengthAnimation();
        }
        public override System.Type TargetPropertyType
        {
            get { return typeof(System.Windows.GridLength); }
        }

        public override object GetCurrentValue(object defaultOriginValue, object defaultDestinationValue, System.Windows.Media.Animation.AnimationClock animationClock)
        {
            double from = ((System.Windows.GridLength)this.GetValue(GridLengthAnimation.FromProperty)).Value;
            double to = ((System.Windows.GridLength)this.GetValue(GridLengthAnimation.ToProperty)).Value;

            if (from > to)
            {
                return new System.Windows.GridLength((1 - animationClock.CurrentProgress.Value) * (from - to) + to, this.To.IsStar ? System.Windows.GridUnitType.Star : System.Windows.GridUnitType.Pixel);
            }
            else 
            {
                return new System.Windows.GridLength(animationClock.CurrentProgress.Value * (to - from) + from, this.From.IsStar ? System.Windows.GridUnitType.Star : System.Windows.GridUnitType.Pixel);
            }
        }
        
    }
}
