﻿
namespace Masterpiece.Common
{
    internal static class PopupService
    {
        internal static bool IsRibbonQAInitialized = false;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="Popup"></param>
        /// <param name="Sender"></param>
        /// <param name="durationSeconds"></param>
        internal static void ClosePopup(System.Windows.Controls.Primitives.Popup Popup, Controls.Primitives.ButtonBase Sender, double durationSeconds=0.0)
        {
            //if (IsPopupShared(Popup, Sender)) 
            //{
            //    return;
            //}
            //System.Windows.FrameworkElement elt = Popup.Child as System.Windows.FrameworkElement;
            //if (elt != null)
            //{
            //    System.Windows.Media.Animation.Storyboard sb = BuildStoryboard(0.0, 1.0, Popup);
                
            //    System.EventHandler handler = null;

            //    handler = delegate
            //    {
            //        sb.Completed -= handler;
            //        elt.Opacity = 0;
            //        Popup.IsOpen = false;
            //        sb = null;
            //        if (elt is Controls.DropShadowChrome) 
            //        {
            //            Controls.DropShadowChrome shadow = elt as Controls.DropShadowChrome;
            //            if (shadow.Content != null&&shadow.Content is Controls.Ribbon2010.RibbonPopupMenu) 
            //            {
            //                Controls.Ribbon2010.RibbonPopupMenu menu = shadow.Content as Controls.Ribbon2010.RibbonPopupMenu;
            //                menu.ClearValue(Controls.Ribbon2010.RibbonPopupMenu.LastNavigatedItemProperty);
            //                menu.NavigatedItemIndex = -1;
            //                menu.NavigatedCollectionIndex = -1;
            //                menu.navigaionHeight = 0;
            //            }
            //        }
            //    };

            //    sb.Completed += handler;

            //    sb.Begin();
            //}
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="Popup"></param>
        /// <param name="Sender"></param>
        /// <param name="shouldClosePrevPopup"></param>
        /// <param name="durationSeconds"></param>
        internal static void OpenPopup(System.Windows.Controls.Primitives.Popup Popup, Masterpiece.Controls.Primitives.ButtonBase Sender, bool shouldClosePrevPopup = true, double durationSeconds = 0.35)
        {
            if (!shouldClosePrevPopup) 
            {
                _ParentPopup = _currentPopup;
                _ParenUI = _currentSender;
            }
            if (_currentPopup != null && _currentPopup.IsOpen && shouldClosePrevPopup)
            {
                ClosePopup();
            }
            Popup.IsOpen = true;
            _currentPopup = Popup;
            _currentSender = Sender;
            System.Windows.FrameworkElement elt = Popup.Child as System.Windows.FrameworkElement;
            System.Windows.Media.Animation.Storyboard sb = BuildStoryboard(1.0, 0.0, Popup);
            System.EventHandler handler = null;
            handler = delegate
            {
                sb.Completed -= handler;
                elt.Opacity = 1.0;
                sb = null;
                if (elt is Controls.DropShadowChrome)
                {
                    Controls.DropShadowChrome shadow = elt as Controls.DropShadowChrome;
                    if (shadow.Content != null && shadow.Content is Controls.Ribbon2010.RibbonPopupMenu)
                    {
                        Controls.Ribbon2010.RibbonPopupMenu menu = shadow.Content as Controls.Ribbon2010.RibbonPopupMenu;
                        System.Windows.Input.Keyboard.Focus(menu);
                    }
                }
            };

            sb.Completed += handler;

            if (Sender == null)
            {
                System.Windows.FrameworkElement e = _ContextOwner as System.Windows.FrameworkElement;
                if (e != null)
                {
                    sb.Begin(e, true);
                }
                else 
                {
                    sb.Begin(elt, true);
                }
            }
            else
            {
                sb.Begin(Sender, true);
            }
        }

       
        /// <summary>
        /// Gets a root window by providing dispatcher of any contained element.
        /// </summary>
        /// <param name="dispatcher"></param>
        /// <returns></returns>
        internal static System.Windows.Window GetWindow(System.Windows.Threading.Dispatcher dispatcher)
        {
            foreach (System.Windows.Window w in System.Windows.Application.Current.Windows)
            {
                if (w.Dispatcher == dispatcher)
                {
                    return w;
                }
            }

            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="visual"></param>
        /// <returns></returns>
        internal static System.Windows.Window GetWindow(System.Windows.Media.Visual visual) 
        {
            
            System.Windows.Interop.HwndSource source = (System.Windows.Interop.HwndSource)System.Windows.PresentationSource.FromVisual(visual);
            System.IntPtr handle = source.Handle;
            foreach (System.Windows.Window wind in System.Windows.Application.Current.Windows)
            {
                source = (System.Windows.Interop.HwndSource)System.Windows.PresentationSource.FromVisual(wind);
                if (source.Handle == handle)
                {
                    return wind;
                }
            }
            return null;
        }
        
        /// <summary>
        /// 
        /// </summary>
        /// <param name="popupedelt"></param>
        /// <returns></returns>
        internal static System.Windows.Controls.Primitives.Popup PopupBuilder(System.Windows.FrameworkElement popupedelt)
        {
            System.Windows.Controls.Primitives.Popup popup = new System.Windows.Controls.Primitives.Popup();
            popup.AllowsTransparency = true;
            popup.StaysOpen = false;
            popup.PopupAnimation = System.Windows.Controls.Primitives.PopupAnimation.Fade;
            popup.Placement = System.Windows.Controls.Primitives.PlacementMode.Bottom;
            Controls.DropShadowChrome dropShadow = new Controls.DropShadowChrome();
            dropShadow.SnapsToDevicePixels = true;
            dropShadow.Focusable = false;
           // dropShadow.Opacity = 0.0;
            dropShadow.Content = popupedelt;
            popup.Child = dropShadow;
            return popup;
        }

        /// <summary>
        /// 
        /// </summary>
        internal static void ClosePopup()
        {
            if (_currentPopup != null && _currentSender != null)
            {
                //closing popup
                ClosePopup(_currentPopup, _currentSender);
                //unchecking any toggle button
                if (_currentSender is Controls.Primitives.ToggleButton)
                {
                    ((Controls.Primitives.ToggleButton)_currentSender).IsChecked = false;
                }
                else if (_currentSender is Controls.Ribbon2010.RibbonToggleButton)
                {
                    ((Controls.Ribbon2010.RibbonToggleButton)_currentSender).IsChecked = false;
                }
            }
            /*
             if another popup is open we need to close it. for example minimized ribbon group 
             * and its child ribbon gallery.
             */
            if (_ParentPopup != null && _ParenUI != null)
            {
                if (_ParentPopup.IsOpen)
                {
                    ClosePopup(_ParentPopup, _ParenUI);

                    if (_ParenUI is Controls.Primitives.ToggleButton)
                    {
                        ((Controls.Primitives.ToggleButton)_ParenUI).IsChecked = false;
                    }
                    else if (_ParenUI is Controls.Ribbon2010.RibbonToggleButton)
                    {
                        ((Controls.Ribbon2010.RibbonToggleButton)_ParenUI).IsChecked = false;
                    }
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        internal static void DissmisPopupEventRaised(System.Object sender, System.Windows.RoutedEventArgs e) 
        {
            if (System.Windows.Input.Mouse.Captured != null)
            {
                System.Windows.FrameworkElement element = System.Windows.Input.Mouse.Captured as System.Windows.FrameworkElement;
                if (element != null)
                {
                    element.ReleaseMouseCapture();
                }
            }
            Masterpiece.Controls.Ribbon2010.RibbonPopupMenu popupMenu = sender as Masterpiece.Controls.Ribbon2010.RibbonPopupMenu;
            if (popupMenu != null)
            {
                popupMenu.IsDropDownOpen = false;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        internal static System.Windows.Controls.Primitives.Popup _currentPopup, _ParentPopup, _ContextPopup;
        
        /// <summary>
        /// 
        /// </summary>
        internal static Controls.Primitives.ButtonBase _currentSender, _ParenUI;
        internal static Controls.Ribbon2010.Interfaces.IRibbonControl _ContextOwner;
        internal static Controls.Ribbon2010.RibbonPopupMenuItem _addItem;
        internal static Controls.Ribbon2010.RibbonPopupMenuItem _removeItem;
        internal static Controls.Ribbon2010.RibbonBar RibbonBar;
        internal static Masterpiece.Controls.Ribbon2010.Interfaces.IRibbonControl OpeningRibbonControl;
        internal static bool RibbonControlOpening;
        internal static Controls.Ribbon2010.RibbonWindow RibbonWindow;
        /// <summary>
        /// 
        /// </summary>
        internal static void CloseContextPopup(Controls.Ribbon2010.Interfaces.IRibbonControl owner, System.Boolean shouldOpen = false)
        {
            System.Windows.FrameworkElement elt = _ContextPopup.Child as System.Windows.FrameworkElement;
            if (elt != null)
            {
                _ContextPopup.IsOpen = false;
                if (shouldOpen)
                {
                    _OpenContextMenu(owner);
                }
            }
        }

        internal static void CloseContextPopup() 
        {
            if (_ContextOwner != null && _ContextPopup != null && _ContextPopup.IsOpen) 
            {
                CloseContextPopup(_ContextOwner);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="owner"></param>
        internal static void OpenContextMenu(Controls.Ribbon2010.Interfaces.IRibbonControl owner)
        {
            if (_ContextPopup != null)
            {
                if (_ContextPopup.IsOpen) 
                {
                    CloseContextPopup(owner, true);
                }
                else 
                {
                    _OpenContextMenu(owner);
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="owner"></param>
        private static void _OpenContextMenu(Controls.Ribbon2010.Interfaces.IRibbonControl owner) 
        {
            System.Windows.FrameworkElement elt = (System.Windows.FrameworkElement)owner;
            _ContextOwner = owner;
            _ContextPopup.IsOpen = true;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="To"></param>
        /// <param name="Popup"></param>
        /// <returns></returns>
        private static System.Windows.Media.Animation.Storyboard BuildStoryboard(System.Double To, System.Double From, System.Windows.Controls.Primitives.Popup Popup, double duration=0.35) 
        {
            System.Windows.FrameworkElement elt = Popup.Child as System.Windows.FrameworkElement;
            System.Windows.Media.Animation.Storyboard sb = new System.Windows.Media.Animation.Storyboard();
            System.Windows.Media.Animation.DoubleAnimation da = new System.Windows.Media.Animation.DoubleAnimation();
            System.Windows.Media.Animation.Storyboard.SetTarget(sb, elt);
            System.Windows.Media.Animation.Storyboard.SetTargetProperty(sb, new System.Windows.PropertyPath("Opacity"));
            da.Duration = new System.Windows.Duration(System.TimeSpan.FromSeconds(duration));
            da.To = To;
            da.From = From;
            sb.Children.Add(da);
            return sb;
        }
        
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        //private static bool IsPopupShared(System.Windows.Controls.Primitives.Popup Popup, Controls.Primitives.ButtonBase Sender) 
        //{
        //    if (Sender is Controls.Ribbon2010.RibbonToggleButton) 
        //    {
        //        Controls.Ribbon2010.RibbonToggleButton toggleButton = Sender as Controls.Ribbon2010.RibbonToggleButton;
        //        if (toggleButton.TemplatedParent == null)
        //        {
        //            if (toggleButton.IsCloned)
        //            {
        //                if (toggleButton.ClonedChild != null && IsMouseOverElement(toggleButton.ClonedChild))
        //                {
        //                    Popup.IsOpen = false;
        //                    Popup.PlacementTarget = toggleButton.ClonedChild;
        //                    Popup.IsOpen = true;
        //                    _currentPopup = Popup;
        //                    _currentSender = toggleButton.ClonedChild;
        //                    if ((bool)toggleButton.IsChecked)
        //                    {
        //                        toggleButton.IsChecked = false;
        //                    }
        //                    return true;
        //                }
        //            }
        //            else if (toggleButton.ParentUI != null)
        //            {
        //                if (IsMouseOverElement(toggleButton.ParentUI))
        //                {
        //                    Popup.IsOpen = false;
        //                    Popup.PlacementTarget = toggleButton.ParentUI;
        //                    Popup.IsOpen = true;
        //                    _currentPopup = Popup;
        //                    _currentSender = toggleButton.ParentUI;
        //                    if ((bool)toggleButton.IsChecked)
        //                    {
        //                        toggleButton.IsChecked = false;
        //                    }
        //                    return true;
        //                }
        //            }
        //        }
        //        else 
        //        {
        //            if (toggleButton.TemplatedParent is Controls.Ribbon2010.RibbonGallery) 
        //            {
        //                Controls.Ribbon2010.RibbonGallery gallery = toggleButton.TemplatedParent as Controls.Ribbon2010.RibbonGallery;
                        
        //                if (gallery.ParentUI != null) 
        //                {
        //                    if (!IsMouseOverElement(gallery.ParentUI.scroller.button)) 
        //                    {
        //                        return false;
        //                    }
        //                    if ((bool)toggleButton.IsChecked)
        //                    {
        //                        toggleButton.IsChecked = false;
        //                    }
        //                    Popup.IsOpen = false;
        //                    Popup.PlacementTarget = gallery.ParentUI;
        //                    Popup.VerticalOffset = -65;
        //                    //Popup.HorizontalOffset = gallery.ParentUI._PART_Panel.WrapBy * (-72) - 6;
        //                    _currentPopup = Popup;
        //                    _currentSender = gallery.ParentUI.scroller.button;
        //                    Popup.IsOpen = true;
        //                }
        //                return true;
        //            }
        //        }
        //    }
        //    else if (Sender is Controls.Primitives.ToggleButton)
        //    {
        //        if (Sender.TemplatedParent != null && Sender.TemplatedParent is Controls.Ribbon2010.RibbonSplitButton)
        //        {
        //            Controls.Ribbon2010.RibbonSplitButton splitButton = Sender.TemplatedParent as Controls.Ribbon2010.RibbonSplitButton;
        //            if (splitButton.IsCloned)
        //            {
        //                if (splitButton.ClonedChild != null && IsMouseOverElement(splitButton.ClonedChild.toggleButton))
        //                {
        //                    Popup.IsOpen = false;
        //                    Popup.PlacementTarget = splitButton.ClonedChild;
        //                    Popup.IsOpen = true;
        //                    _currentPopup = Popup;
        //                    _currentSender = splitButton.ClonedChild.toggleButton;
        //                    if ((bool)splitButton.toggleButton.IsChecked)
        //                    {
        //                        splitButton.toggleButton.IsChecked = false;
        //                    }
        //                    return true;
        //                }
        //            }
        //            else if (splitButton.ParentUI != null)
        //            {
        //                if (IsMouseOverElement(splitButton.ParentUI.toggleButton))
        //                {
        //                    Popup.IsOpen = false;
        //                    Popup.PlacementTarget = splitButton.ParentUI;
        //                    Popup.IsOpen = true;
        //                    _currentPopup = Popup;
        //                    _currentSender = splitButton.ParentUI.toggleButton;
        //                    if ((bool)splitButton.toggleButton.IsChecked)
        //                    {
        //                        splitButton.toggleButton.IsChecked = false;
        //                    }
        //                    return true;
        //                }
        //            }
        //        }
        //    }
        //    else if (Sender is Controls.Button) 
        //    {
        //        Controls.Button btn = Sender as Controls.Button;
        //        if (btn.TemplatedParent != null && btn.TemplatedParent is Controls.Ribbon2010.RibbonScrollViewer) 
        //        {
        //            Controls.Ribbon2010.RibbonScrollViewer scroller = btn.TemplatedParent as Controls.Ribbon2010.RibbonScrollViewer;
        //            if (scroller.TemplatedParent != null && scroller.TemplatedParent is Controls.Ribbon2010.RibbonGallery) 
        //            {
        //                Controls.Ribbon2010.RibbonGallery gallery = scroller.TemplatedParent as Controls.Ribbon2010.RibbonGallery;
        //                if (gallery.ClonedChild != null) 
        //                {
        //                    if (IsMouseOverElement(gallery.ClonedChild)) 
        //                    {

        //                        return true;
        //                    }
        //                }
        //            }
        //        }
        //    }
        //    return false;
        //}

        internal static bool IsMouseOverElement()
        {
            System.Windows.Point point = System.Windows.Input.Mouse.GetPosition(Common.PopupService._currentSender);
            return point.X >= 0 && point.X <= Common.PopupService._currentSender.ActualWidth && point.Y >= 0 && point.Y <= Common.PopupService._currentSender.ActualHeight;
        }
        internal static bool IsMouseOverElement(System.Windows.FrameworkElement elt)
        {
            System.Windows.Point point = System.Windows.Input.Mouse.GetPosition(elt);
            return point.X >= 0 && point.X <= elt.ActualWidth && point.Y >= 0 && point.Y <= elt.ActualHeight;
        }

        internal static void EnableRemovalButton() 
        {
            if (_addItem != null && _removeItem != null) 
            {
                _removeItem.Visibility = System.Windows.Visibility.Visible;
                _addItem.Visibility = System.Windows.Visibility.Collapsed;
            }
        }
        
        internal static void DisableRemovalButton()
        {
            if (_addItem != null && _removeItem != null)
            {
                _removeItem.Visibility = System.Windows.Visibility.Collapsed;
                _addItem.Visibility = System.Windows.Visibility.Visible;
            }
            
        }

        private static System.EventArgs eventArgs = new System.EventArgs();

        internal static event System.EventHandler PopupDismissedEvent;

        internal static void RaisePopupDismissedEvent(object sender) 
        {
            if (Common.PopupService.PopupDismissedEvent != null) 
            {
                Common.PopupService.PopupDismissedEvent(sender, PopupService.eventArgs);
            }
        }

        internal static event System.EventHandler MenuDropDownOpenedEvent;

        internal static void RaiseMenuDropDownOpenedEvent(object sender)
        {
            if (Common.PopupService.MenuDropDownOpenedEvent != null)
            {
                Common.PopupService.MenuDropDownOpenedEvent(sender, PopupService.eventArgs);
            }
        }
        internal static event System.EventHandler RibbonHeaderedExpanderItemSelectedEvent;

        internal static void RaiseRibbonHeaderedExpanderItemSelectedEvent(object sender)
        {
            if (Common.PopupService.RibbonHeaderedExpanderItemSelectedEvent != null)
            {
                Common.PopupService.RibbonHeaderedExpanderItemSelectedEvent(sender, PopupService.eventArgs);
            }
        }

        internal static event System.EventHandler RibbonGalleryItemSelectedEvent;

        internal static void RaiseRibbonGalleryItemSelectedEvent(object sender) 
        {
            if (Common.PopupService.RibbonGalleryItemSelectedEvent != null) 
            {
                Common.PopupService.RibbonGalleryItemSelectedEvent(sender, PopupService.eventArgs);
            }
        }
        
    }

    
}
