﻿
namespace Masterpiece.Common
{
    public static class Utilities
    {
     
    }

    internal static class NativeMethods
    {
        [System.Runtime.InteropServices.DllImport("gdi32.dll", SetLastError = true)]
        public static extern System.IntPtr CreateRectRgn(int left, int top, int right, int bottom);

        [System.Runtime.InteropServices.DllImport("user32.dll")]
        public static extern int SetWindowRgn(System.IntPtr hWnd, System.IntPtr hRgn, [System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.Bool)] bool bRedraw);

        [return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.Bool)]
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        public static extern bool GetWindowRect(System.IntPtr hWnd, out RECT lpRect);

        [return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.Bool)]
        [System.Runtime.InteropServices.DllImport("user32.dll")]
        public static extern bool IsWindowVisible(System.IntPtr hwnd);

        [System.Runtime.InteropServices.DllImport("gdi32.dll")]
        public static extern System.IntPtr CreateRoundRectRgn(int x1, int y1, int x2, int y2, int cx, int cy);

        [System.Runtime.InteropServices.DllImport("gdi32.dll", SetLastError = true)]
        public static extern int CombineRgn(System.IntPtr hrgnDest, System.IntPtr hrgnSrc1, System.IntPtr hrgnSrc2, int fnCombineMode);

        [return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.Bool)]
        [System.Runtime.InteropServices.DllImport("user32.dll", SetLastError = true)]
        public static extern bool SetWindowPos(System.IntPtr hWnd, System.IntPtr hWndInsertAfter, int x, int y, int cx, int cy, SWP uFlags);

        [System.Runtime.InteropServices.DllImport("user32.dll", EntryPoint = "DefWindowProcW", CharSet = System.Runtime.InteropServices.CharSet.Unicode)]
        public static extern System.IntPtr DefWindowProc(System.IntPtr hWnd, WM Msg, System.IntPtr wParam, System.IntPtr lParam);


        [return: System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.Bool)]
        [System.Runtime.InteropServices.DllImport("dwmapi.dll")]
        public static extern bool DwmDefWindowProc(System.IntPtr hwnd, int msg, System.IntPtr wParam, System.IntPtr lParam, out System.IntPtr plResult);

        [System.Runtime.InteropServices.DllImport("dwmapi.dll", PreserveSig = false)]
        public static extern void DwmExtendFrameIntoClientArea(System.IntPtr hwnd, ref MARGINS pMarInset);

        [System.Runtime.InteropServices.DllImport("dwmapi.dll", PreserveSig = false)]
        public static extern bool DwmIsCompositionEnabled();

        [System.Runtime.InteropServices.DllImport("user32.dll", ExactSpelling = true, CharSet = System.Runtime.InteropServices.CharSet.Auto)]
        public static extern System.IntPtr GetCapture();

        public static int SignedLoWord(int i)
        {
            return (short)(i & 0xffff);
        }


        public static int SignedHiWord(int i)
        {
            return (short)(i >> 0x10);
        }


        public enum WM
        {
            ACTIVATE = 6,
            APP = 0x8000,
            CLOSE = 0x10,
            CREATE = 1,
            DESTROY = 2,
            DWMCOMPOSITIONCHANGED = 0x31e,
            ENABLE = 10,
            ERASEBKGND = 20,
            GETDLGCODE = 0x87,
            GETTEXT = 13,
            GETTEXTLENGTH = 14,
            KILLFOCUS = 8,
            MOVE = 3,
            NCACTIVATE = 0x86,
            NCCALCSIZE = 0x83,
            NCCREATE = 0x81,
            NCDESTROY = 130,
            NCHITTEST = 0x84,
            NCLBUTTONDBLCLK = 0xa3,
            NCLBUTTONDOWN = 0xa1,
            NCLBUTTONUP = 0xa2,
            NCMBUTTONDBLCLK = 0xa9,
            NCMBUTTONDOWN = 0xa7,
            NCMBUTTONUP = 0xa8,
            NCMOUSEMOVE = 160,
            NCPAINT = 0x85,
            NCRBUTTONDBLCLK = 0xa6,
            NCRBUTTONDOWN = 0xa4,
            NCRBUTTONUP = 0xa5,
            NULL = 0,
            PAINT = 15,
            QUERYENDSESSION = 0x11,
            QUERYOPEN = 0x13,
            QUIT = 0x12,
            SETFOCUS = 7,
            SETICON = 0x80,
            SETREDRAW = 11,
            SETTEXT = 12,
            SIZE = 5,
            SYNCPAINT = 0x88,
            SYSCHAR = 0x106,
            SYSCOLORCHANGE = 0x15,
            SYSCOMMAND = 0x112,
            SYSDEADCHAR = 0x107,
            SYSKEYDOWN = 260,
            SYSKEYUP = 0x105,
            USER = 0x400,
            WINDOWPOSCHANGED = 0x47,
            WINDOWPOSCHANGING = 0x46,
            MSG794 = 794,
            WM_MBUTTONDOWN = 0x0207
        }
        [System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
        public struct RECT
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;
            public int Width { get { return Right - Left; } }
            public int Height { get { return Bottom - Top; } }
        }

        [System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
        public struct WINDOWPOSPARAMS
        {
            public System.IntPtr hwnd;
            public System.IntPtr hwndInsertAfter;
            public int x;
            public int y;
            public int cx;
            public int cy;
            public int flags;
        }

        [System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
        public struct MARGINS
        {
            public int cxLeftWidth;
            public int cxRightWidth;
            public int cyTopHeight;
            public int cyBottomHeight;
        }

        [System.Flags]
        public enum SWP
        {
            ASYNCWINDOWPOS = 0x4000,
            DEFERERASE = 0x2000,
            DRAWFRAME = 0x20,
            FRAMECHANGED = 0x20,
            HIDEWINDOW = 0x80,
            NOACTIVATE = 0x10,
            NOCOPYBITS = 0x100,
            NOMOVE = 2,
            NOOWNERZORDER = 0x200,
            NOREDRAW = 8,
            NOREPOSITION = 0x200,
            NOSENDCHANGING = 0x400,
            NOSIZE = 1,
            NOZORDER = 4,
            SHOWWINDOW = 0x40
        }

        public enum HT
        {
            BORDER = 0x12,
            BOTTOM = 15,
            BOTTOMLEFT = 0x10,
            BOTTOMRIGHT = 0x11,
            CAPTION = 2,
            CLIENT = 1,
            CLOSE = 20,
            ERROR = -2,
            GROWBOX = 4,
            HELP = 0x15,
            HSCROLL = 6,
            LEFT = 10,
            MAXBUTTON = 9,
            MENU = 5,
            MINBUTTON = 8,
            NOWHERE = 0,
            OBJECT = 0x13,
            RIGHT = 11,
            SYSMENU = 3,
            TOP = 12,
            TOPLEFT = 13,
            TOPRIGHT = 14,
            TRANSPARENT = -1,
            VSCROLL = 7
        }
    }
}
