﻿
namespace Masterpiece.Controls
{
    [System.Windows.Markup.ContentProperty("Content")]
    public class DropShadowChrome:System.Windows.Controls.Control
    {
        #region Constructors

        static DropShadowChrome() 
        {
            System.Type ownerType = typeof(DropShadowChrome);
            DropShadowChrome.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));
        }

        #endregion

        #region Properties and Depenency Properties

        /// <summary>
        /// Gets or sets drop shadow's Content. This is a dependency property.
        /// </summary>
        public object Content
        {
            get { return (object)GetValue(ContentProperty); }
            set { SetValue(ContentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Content.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ContentProperty =
            System.Windows.DependencyProperty.Register("Content", typeof(object), typeof(DropShadowChrome), new System.Windows.PropertyMetadata(null));

        /// <summary>
        /// Gets or sets shadow's color. This is a dependency property.
        /// </summary>
        public System.Windows.Media.Color Color
        {
            get { return (System.Windows.Media.Color)GetValue(ColorProperty); }
            set { SetValue(ColorProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Color.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ColorProperty =
            System.Windows.DependencyProperty.Register("Color", typeof(System.Windows.Media.Color), typeof(DropShadowChrome), new System.Windows.PropertyMetadata(null));
        #endregion

        #region Depenency Property Changed Callbacks
        #endregion

        #region Overrides
        #endregion

        #region Private Utilities
        #endregion

        #region Event Handlers
        #endregion

        #region Fields
        #endregion
    }
}
