﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.OutlookBar
{
    public class OutlookBarItem:System.Windows.Controls.Primitives.ButtonBase
    {
        #region Constructors
        static OutlookBarItem()
        {
            System.Type ownerType = typeof(OutlookBarItem);

            OutlookBarItem.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));

        }
        public OutlookBarItem()
            : base()
        {
        
        }
        #endregion

        #region Properties and Depenency Properties

        /// <summary>
        /// Image source for small image
        /// </summary>
        public System.Windows.Media.ImageSource Image
        {
            get { return (System.Windows.Media.ImageSource)GetValue(ImageProperty); }
            set { SetValue(ImageProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SmallImage.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageProperty = Masterpiece.Controls.Ribbon2010.RibbonGroup.ImageProperty.AddOwner(typeof(OutlookBarItem));
        
        public System.String Title
        {
            get { return (System.String)GetValue(TitleProperty); }
            set { SetValue(TitleProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SmallImage.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TitleProperty = Masterpiece.Controls.Ribbon2010.RibbonGroup.TitleProperty.AddOwner(typeof(OutlookBarItem));

        public bool IsSelected
        {   
            get { return (bool)GetValue(IsSelectedProperty); }
        }

        // Using a DependencyProperty as the backing store for IsSelected.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyPropertyKey IsSelectedPropertyKey =
            System.Windows.DependencyProperty.RegisterReadOnly("IsSelected", typeof(bool), typeof(OutlookBarItem), new System.Windows.PropertyMetadata(false));
        internal static readonly System.Windows.DependencyProperty IsSelectedProperty = OutlookBarItem.IsSelectedPropertyKey.DependencyProperty;

        internal Masterpiece.Controls.Ribbon2010.RibbonControlSize Size
        {
            get { return (Masterpiece.Controls.Ribbon2010.RibbonControlSize)GetValue(SizeProperty); }
            set { SetValue(SizeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SmallImage.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty SizeProperty = Masterpiece.Controls.Ribbon2010.RibbonGroup.SizeProperty.AddOwner(typeof(OutlookBarItem));
        #endregion

        #region Depenency Property Changed Callbacks

        #endregion

        #region Overrides

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
        }

        protected override void OnClick()
        {
            OutlookBar.RaiseOutlookBarItemClicked(this);
            base.OnClick();
        }
        #endregion

        #region Private Utilities

        private void SetIsSelectedProperty() 
        {
        
        }
        #endregion

        #region Event Handlers
        #endregion

        #region Fields
        #endregion

        #region Events
        #endregion
    }
}
