﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Primitives
{
   public class DragStartedEventArgs:System.Windows.RoutedEventArgs
    {
       public DragStartedEventArgs(double hOffset, double vOffset)
           : base(Thumb.DragStartedEvent)
       {
           this._horizontalOffset = hOffset;
           this._verticalOffset = vOffset;
       }

       public double VerticalOffset 
       {
           get 
           {
               return this._verticalOffset;
           } 
       }
       public double HorizontalOffset 
       {
           get 
           {
               return this._horizontalOffset;
           } 
       }

       private double _horizontalOffset, _verticalOffset;
    }

    public delegate void DragStartedEventHandler(object sender, DragStartedEventArgs e);
}
