﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
   
    public class ApplicationMenuItem:System.Windows.Controls.Primitives.ButtonBase, Interfaces.IRibbonControl
    {
        #region Constructors

        static ApplicationMenuItem() 
        {
            DefaultStyleKeyProperty.OverrideMetadata
                (
                typeof(ApplicationMenuItem),
                new System.Windows.FrameworkPropertyMetadata(typeof(ApplicationMenuItem))
                );
        }

        #endregion

        #region Properties and Depenency Properties

        [System.ComponentModel.Bindable(true), System.ComponentModel.Browsable(false), System.ComponentModel.NotifyParentProperty(true)]
        public bool IsSelected
        {
            get { return (bool)GetValue(IsSelectedProperty); }
            set { SetValue(IsSelectedProperty, value); }
        }
        
        [System.ComponentModel.Bindable(true), System.ComponentModel.Browsable(true), System.ComponentModel.NotifyParentProperty(true)]
        public RibbonControlSize Size
        {
            get { return (RibbonControlSize)GetValue(SizeProperty); }
            set { SetValue(SizeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Size.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty SizeProperty =
            System.Windows.DependencyProperty.Register("Size", typeof(RibbonControlSize), typeof(ApplicationMenuItem), new System.Windows.PropertyMetadata(RibbonControlSize.Small));

        [System.ComponentModel.Bindable(true), System.ComponentModel.Browsable(true)]
        public System.Windows.Media.ImageSource ImageSource
        {
            get { return (System.Windows.Media.ImageSource)GetValue(ImageSourceProperty); }
            set { SetValue(ImageSourceProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageSource.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageSourceProperty =
            System.Windows.DependencyProperty.Register("ImageSource", typeof(System.Windows.Media.ImageSource), typeof(ApplicationMenuItem));

        
        // Using a DependencyProperty as the backing store for IsSelected.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsSelectedProperty =
            System.Windows.DependencyProperty.Register("IsSelected", typeof(bool), typeof(ApplicationMenuItem), new System.Windows.PropertyMetadata(false));

        public string Title
        {
            get { return (string)GetValue(TitleProperty); }
            set { SetValue(TitleProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TitleProperty =
            System.Windows.DependencyProperty.Register("Title", typeof(string), typeof(ApplicationMenuItem), new System.Windows.PropertyMetadata((string)null));

        #endregion

        #region Depenency Property Changed Callbacks

        #endregion

        #region Overrides
        
        protected override void OnClick()
        {
            base.OnClick();
            if (this.Size != Ribbon2010.RibbonControlSize.Large)
            {
                if (Common.PopupService.RibbonWindow != null)
                {
                    Common.PopupService.RibbonWindow.IsApplicationMenuOpen = false;
                }
            }
        }
        
        #endregion

        #region Private Utilities
        #endregion

        #region Event Handlers
        #endregion

        #region Fields
        #endregion

        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            throw new NotImplementedException();
        }


        public bool IsLarge
        {
            get { return false; }
        }


        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            throw new NotImplementedException();
        }
        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
    }
}
