﻿
namespace Masterpiece.Controls.Ribbon2010.Primitives
{
    public abstract class RibbonButtonBase : Controls.Primitives.ButtonBase/*, Interfaces.IRibbonControl*/
    {
        #region Constructors
        static RibbonButtonBase() 
        {
            System.Type ownerType = typeof(RibbonButtonBase);
            RibbonButtonBase.FocusableProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(false));
        }
        #endregion

        #region Properties and Depenency Properties
        
        /// <summary>
        /// Image source for large image
        /// </summary>
        public System.Windows.Media.ImageSource LargeImage
        {
            get { return (System.Windows.Media.ImageSource)GetValue(LargeImageProperty); }
            set { SetValue(LargeImageProperty, value); }
        }

        // Using a DependencyProperty as the backing store for LargeImage.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty LargeImageProperty =
            System.Windows.DependencyProperty.Register("LargeImage", typeof(System.Windows.Media.ImageSource), typeof(RibbonButtonBase), new System.Windows.PropertyMetadata(null));

        /// <summary>
        /// Image source for small image
        /// </summary>
        public System.Windows.Media.ImageSource SmallImage
        {
            get { return (System.Windows.Media.ImageSource)GetValue(SmallImageProperty); }
            set { SetValue(SmallImageProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SmallImage.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty SmallImageProperty =
            System.Windows.DependencyProperty.Register("SmallImage", typeof(System.Windows.Media.ImageSource), typeof(RibbonButtonBase), new System.Windows.PropertyMetadata(null));
        
        /// <summary>
        /// Represents title for a button
        /// </summary>
        public string Title
        {
            get { return (string)GetValue(TitleProperty); }
            set { SetValue(TitleProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TitleProperty =
            System.Windows.DependencyProperty.Register("Title", typeof(string), typeof(RibbonButtonBase), new System.Windows.PropertyMetadata(null));

        /// <summary>
        /// Gets or sets button size. Default value is Small
        /// </summary>
        public RibbonControlSize Size
        {
            get { return (RibbonControlSize)GetValue(SizeProperty); }
            set { SetValue(SizeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Size.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty SizeProperty =
            System.Windows.DependencyProperty.Register("Size", typeof(RibbonControlSize), typeof(RibbonButtonBase), new System.Windows.PropertyMetadata(RibbonControlSize.Small));

        [System.ComponentModel.Bindable(false),
        System.ComponentModel.Browsable(false),
        System.ComponentModel.ReadOnly(false)]
        public int? ItemID
        {
            get { return (int?)GetValue(ItemIDProperty); }
            set { SetValue(ItemIDProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ItemID.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ItemIDProperty =
            System.Windows.DependencyProperty.Register("ItemID", typeof(int?), typeof(RibbonButtonBase), new System.Windows.PropertyMetadata(null, new System.Windows.PropertyChangedCallback(RibbonButtonBase.OnItemIDPropertyChanged)));
        
        #endregion

        #region Depenency Property Changed Callbacks
        private static void OnFocusVisualStylePropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        { }

        private static System.Object CoerceFocusVisualStyleProperty(System.Windows.DependencyObject o, System.Object value)
        {
            return null;
        }

        private static void OnItemIDPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            int? id = (int?)e.NewValue;
            if (id.HasValue) 
            {
                RibbonControlCloningService.Add(d as Interfaces.IRibbonControl, id.Value);
            }
        }

        #endregion

        #region Overrides
        
        #endregion

        #region Private Utilities

        #endregion

        #region Event Handlers
        #endregion

        #region Fields

        #endregion

       
    }
}
