﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010.Primitives
{
   public class RibbonScrollBar:System.Windows.Controls.Primitives.ScrollBar, Interfaces.IRibbonControl
    {
        #region Constructors
      
        static RibbonScrollBar()
        {
           DefaultStyleKeyProperty.OverrideMetadata
               (
               typeof(RibbonScrollBar),
               new System.Windows.FrameworkPropertyMetadata(typeof(RibbonScrollBar))
               );
        }

        #endregion

       #region Properties and Depenency Properties

        public bool IsPopupScroller
        {
            get { return (bool)GetValue(IsPopupScrollerProperty); }
            set { SetValue(IsPopupScrollerProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsPopupScroller.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsPopupScrollerProperty =
            System.Windows.DependencyProperty.Register("IsPopupScroller", typeof(bool), typeof(RibbonScrollBar), new System.Windows.PropertyMetadata(false));



        public bool IsWindowContentScroller
        {
            get { return (bool)GetValue(IsWindowContentScrollerProperty); }
            set { SetValue(IsWindowContentScrollerProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsWindowContentScroller.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsWindowContentScrollerProperty =
            System.Windows.DependencyProperty.Register("IsWindowContentScroller", typeof(bool), typeof(Ribbon2010.Primitives.RibbonScrollBar), new System.Windows.PropertyMetadata(false));

        
       #endregion

       #region Depenency Property Changed Callbacks
       #endregion

       #region Overrides

       #endregion

       #region Private Utilities
       #endregion

       #region Event Handlers
       #endregion

       #region Fields
       #endregion
        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            throw new NotImplementedException();
        }

        public bool IsLarge
        {
            get { return false; }
        }

        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            
        }
       
        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion

    }
}
