﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
   public class QACommandItem:System.Windows.DependencyObject, Interfaces.IRibbonControl
   {
       #region Constructors

       public QACommandItem():base() 
       {
       
       }
       #endregion

       #region Properties and Depenency Properties


       public System.Windows.Media.ImageSource Image
       {
           get { return (System.Windows.Media.ImageSource)GetValue(ImageProperty); }
           set { SetValue(ImageProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Image.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageProperty = RibbonGroup.ImageProperty.AddOwner(typeof(QACommandItem), new System.Windows.PropertyMetadata((System.Windows.Media.ImageSource)null));

       [System.ComponentModel.Bindable(true),
       System.ComponentModel.Browsable(false),
       System.ComponentModel.ReadOnly(false)]
       public System.Windows.Input.ICommand Command
       {
           get { return (System.Windows.Input.ICommand)GetValue(CommandProperty); }
           set { SetValue(CommandProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Command.  This enables animation, styling, binding, etc...

       public static readonly System.Windows.DependencyProperty CommandProperty =
           System.Windows.DependencyProperty.Register("Command", typeof(System.Windows.Input.ICommand), typeof(QACommandItem), new System.Windows.PropertyMetadata((System.Windows.Input.ICommand)null));

       [System.ComponentModel.Bindable(true),
       System.ComponentModel.Browsable(false),
       System.ComponentModel.ReadOnly(false)]
       public string Title
       {
           get { return (string)GetValue(TitleProperty); }
           set { SetValue(TitleProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty TitleProperty = RibbonButton.TitleProperty.AddOwner(typeof(QACommandItem));


       [System.ComponentModel.Bindable(true),
       System.ComponentModel.Browsable(false),
       System.ComponentModel.ReadOnly(false)]
       public bool VisibleOnStartup
       {
           get { return (bool)GetValue(VisibleOnStartupProperty); }
           set { SetValue(VisibleOnStartupProperty, value); }
       }

       // Using a DependencyProperty as the backing store for VisibleOnStartup.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty VisibleOnStartupProperty =
           System.Windows.DependencyProperty.Register("VisibleOnStartup", typeof(bool), typeof(QACommandItem), new System.Windows.PropertyMetadata(false));
       
       #endregion

       #region Depenency Property Changed Callbacks
       
       #endregion

       #region Overrides

       #endregion

       #region Private Utilities

       private void SetBindings() 
       {
           if (this.ClonedChild == null) 
           {
               return;
           }

           System.Windows.Data.BindingOperations.SetBinding
               (
                this.ClonedChild,
                RibbonButton.SmallImageProperty,
                new System.Windows.Data.Binding("Image") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
               );

           System.Windows.Data.BindingOperations.SetBinding
               (
                this.ClonedChild,
                RibbonButton.CommandProperty,
                new System.Windows.Data.Binding("Command") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
               );
       }

       #endregion

       #region Event Handlers
       #endregion

       #region Fields
       internal RibbonButton ClonedChild;
       #endregion

       #region Events
       #endregion

       #region IRibbonControl Implementation

       public Interfaces.IRibbonControl Clone()
       {
           RibbonButton clonedChild = null;
           if (this.ClonedChild == null)
           {
               clonedChild = new RibbonButton();
               clonedChild.isClonedItem = true;
               clonedChild.ParentUI = this;
               this.ClonedChild = clonedChild;
               this.SetBindings();
           }
           return clonedChild;
       }

       public bool IsLarge
       {
           get { return false; }
       }

       public bool IsClonedItem
       {
           get { return false; }
       }

       public bool IsCloneable
       {
           get { return true; }
       }

       public void DisposeControl()
       {
           if (this.ClonedChild != null) 
           {
               System.Windows.Data.BindingOperations.ClearAllBindings(this.ClonedChild);
               this.ClonedChild = null;
               System.GC.Collect();
           }
       }

       public Interfaces.IRibbonControl ParentControl
       {
           get { return null; }
       }
       #endregion

   }
}
