﻿


namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.TemplatePart(Name = PART_ItemsControl, Type = typeof(System.Windows.Controls.ItemsControl))]
    [System.Windows.TemplatePart(Name = _partBarHeight, Type = typeof(System.Windows.Controls.RowDefinition))]
    [System.Windows.TemplatePart(Name = _PART_Root, Type = typeof(System.Windows.Controls.Grid))]
    [System.Windows.TemplatePart(Name = PART_TabItemsScroller, Type = typeof(RibbonScrollViewer))]
    [System.Windows.TemplatePart(Name = PART_Expander, Type = typeof(System.Windows.Controls.Button))]
    [System.Windows.TemplatePart(Name = PART_Panel, Type = typeof(RibbonStackPanel))]
    [System.Windows.Markup.ContentProperty("RibbonTabItemsCollection")]
    public sealed partial class RibbonBar : System.Windows.Controls.Control, Interfaces.IRibbonControl
    {
        #region Constructors
        static RibbonBar()
        {
            System.Type ownerType = typeof(RibbonBar);
            RibbonBar.DefaultStyleKeyProperty.OverrideMetadata(ownerType,
                new System.Windows.FrameworkPropertyMetadata(ownerType));

        }
        public RibbonBar()
            : base()
        {
            this.RibbonTabItemsCollection = new RibbonTabItemsCollection();
            this.CommandBindings.Add(new System.Windows.Input.CommandBinding(ExpandCommand, new System.Windows.Input.ExecutedRoutedEventHandler(this.ExpandBar)));
        }
        #endregion

        #region Properties and Depenency Properties

        public bool IsExpanded
        {
            get { return (bool)GetValue(IsExpandedProperty); }
            set { SetValue(IsExpandedProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsExpanded.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsExpandedProperty =
            System.Windows.DependencyProperty.Register("IsExpanded", typeof(bool), typeof(RibbonBar), new System.Windows.PropertyMetadata(true));

        public double WorkAreaWidth
        {
            get { return (double)GetValue(WorkAreaWidthProperty); }
            set { SetValue(WorkAreaWidthProperty, value); }
        }

        // Using a DependencyProperty as the backing store for WorkAreaWidth.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty WorkAreaWidthProperty =
            System.Windows.DependencyProperty.Register("WorkAreaWidth", typeof(double), typeof(RibbonBar), new System.Windows.PropertyMetadata(System.Windows.SystemParameters.WorkArea.Width));


        public static bool GetIsExpander(System.Windows.DependencyObject obj)
        {
            return (bool)obj.GetValue(IsExpanderProperty);
        }

        public static void SetIsExpander(System.Windows.DependencyObject obj, bool value)
        {
            obj.SetValue(IsExpanderProperty, value);
        }

        // Using a DependencyProperty as the backing store for IsExpander.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsExpanderProperty =
            System.Windows.DependencyProperty.RegisterAttached("IsExpander", typeof(bool), typeof(RibbonBar));

        public RibbonApplicationMenu ApplicationMenu
        {
            get { return (RibbonApplicationMenu)GetValue(ApplicationMenuProperty); }
            set { SetValue(ApplicationMenuProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ApplicationMenu.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ApplicationMenuProperty =
            System.Windows.DependencyProperty.Register("ApplicationMenu", typeof(RibbonApplicationMenu), typeof(RibbonBar), new System.Windows.PropertyMetadata(null, OnApplicationMenuPropertyChanged));

        public bool IsApplicationMenuOpen
        {
            get { return (bool)GetValue(IsApplicationMenuOpenProperty); }
            set { SetValue(IsApplicationMenuOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsApplicationMenuoOpen.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsApplicationMenuOpenProperty =
            System.Windows.DependencyProperty.Register("IsApplicationMenuOpen", typeof(bool), typeof(RibbonBar), new System.Windows.PropertyMetadata(false, OnIsApplicationMenuOpenPropertyChanged));

        public RibbonTabItemsCollection RibbonTabItemsCollection
        {
            get { return (RibbonTabItemsCollection)GetValue(RibbonTabItemsCollectionProperty); }
            set { SetValue(RibbonTabItemsCollectionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RibbonTabItemsCollection.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty RibbonTabItemsCollectionProperty =
            System.Windows.DependencyProperty.Register("RibbonTabItemsCollection", typeof(RibbonTabItemsCollection), typeof(RibbonBar));

        public RibbonTabItem SelectedItem
        {
            get { return (RibbonTabItem)GetValue(SelectedItemProperty); }
            set { SetValue(SelectedItemProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SelectedItem.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty SelectedItemProperty =
            System.Windows.DependencyProperty.Register("SelectedItem", typeof(RibbonTabItem), typeof(RibbonBar));

        public int SelectedIndex
        {
            get { return (int)GetValue(SelectedIndexProperty); }
            set { SetValue(SelectedIndexProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SelectedIndex.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty SelectedIndexProperty =
            System.Windows.DependencyProperty.Register("SelectedIndex", typeof(int), typeof(RibbonBar), new System.Windows.UIPropertyMetadata(-1));

        internal bool IsGlassEnabled
        {
            get { return (bool)GetValue(IsGlassEnabledProperty); }
            set { SetValue(IsGlassEnabledProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsGlassEnabled.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsGlassEnabledProperty =
            System.Windows.DependencyProperty.Register("IsGlassEnabled", typeof(bool), typeof(RibbonBar), new System.Windows.FrameworkPropertyMetadata(false, System.Windows.FrameworkPropertyMetadataOptions.BindsTwoWayByDefault));

        [System.ComponentModel.Bindable(true)]
        internal bool IsBackgroundMode
        {
            get { return (bool)GetValue(IsBackgroundModeProperty); }
            set { SetValue(IsBackgroundModeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsBackgroundMode.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsBackgroundModeProperty =
            System.Windows.DependencyProperty.Register("IsBackgroundMode", typeof(bool), typeof(RibbonBar), new System.Windows.FrameworkPropertyMetadata(
                false,
                new System.Windows.PropertyChangedCallback(RibbonBar.OnIsBackgroundModePropertyChanged)));

        internal bool IsDropDownOpen
        {
            get { return (bool)GetValue(IsDropDownOpenProperty); }
            set { SetValue(IsDropDownOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsDropDownOpen.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsDropDownOpenProperty =
            System.Windows.DependencyProperty.Register("IsDropDownOpen", typeof(bool), typeof(RibbonBar), new System.Windows.FrameworkPropertyMetadata(false, new System.Windows.PropertyChangedCallback(RibbonBar.OnIsDropDownOpenPropertyChanged), new System.Windows.CoerceValueCallback(RibbonBar.CoerceIsDropDownOpenProperty)));

        #endregion

        #region Depenency Property Changed Callbacks

        private static System.Object CoerceIsDropDownOpenProperty(System.Windows.DependencyObject o, System.Object value)
        {
            RibbonBar bar = (RibbonBar)o;
            bool newValue = (bool)value;
            if (newValue)
            {
                System.Windows.Controls.Grid itemsHolder = bar.GetTemplateChild("PART_TabItemPlaceHolder") as System.Windows.Controls.Grid;
                double val = bar.barRow.Height.Value;
                if (val == 90.0D)
                {
                    bar.AnimateGridLength(true);
                }
                double width = itemsHolder.ActualWidth + RibbonWindowParameters.BorderWidth;
                if (bar.MainWindow != null) 
                {
                    width = bar.MainWindow.ActualWidth - RibbonWindowParameters.ContentMargin.Left - RibbonWindowParameters.ContentMargin.Right-2;
                    if (width <= 0) 
                    {
                        width = itemsHolder.ActualWidth + RibbonWindowParameters.BorderWidth;
                    }
                }
                bar.PopupGrid.Width = width;

            }
            return value;
        }

        private static void OnIsApplicationMenuOpenPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            RibbonBar bar = o as RibbonBar;
            bool IsOpen = (bool)e.NewValue;

            if (bar.IsDropDownOpen)
            {
                bar.IsDropDownOpen = false;
            }

            if (IsOpen)
            {
                RibbonTabItem item = bar.GetValue(RibbonBar.SelectedItemProperty) as RibbonTabItem;
                if (item != null)
                {
                    item.SetValue(RibbonTabItem.IsSelectedProperty, false);
                }
                bar.Expander.IsEnabled = false;
                //here was an unexpected error. should be reviewed 03.03.2013
                bar.MainWindow.Content = bar.ApplicationMenu.Border;
            }
            else
            {
                if (!bar.IsBackgroundMode)
                {
                    int index = (int)bar.GetValue(RibbonBar.SelectedIndexProperty);
                    RibbonTabItem item = null;
                    if (index >= 0)
                    {
                        item = bar.RibbonTabItemsCollection[index] as RibbonTabItem;
                        if (item != null)
                        {
                            if (bar.IsExpanded)
                            {
                                item.SetValue(RibbonTabItem.IsSelectedProperty, true);
                            }
                        }
                    }
                }
                bar.Expander.IsEnabled = true;
                bar.MainWindow.Content = bar.ApplicationMenu.WindowContent;
            }
        }

        private static void OnApplicationMenuPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            RibbonBar bar = o as RibbonBar;
            if (e.OldValue == null && e.NewValue != null)
            {
                RibbonApplicationMenu menu = (RibbonApplicationMenu)e.NewValue;

                if (menu != null)
                {
                    menu.RibbonBar = bar;
                }
            }
        }

        private static void OnIsBackgroundModePropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            bool newValue = (bool)e.NewValue, oldValue = !newValue;
            RibbonBar bar = (RibbonBar)o;
            if (newValue)
            {
                bar.SetBackgroundMode();
            }
            else
            {
                bar.UnsetBackgroundMode();
            }

        }

        private static void OnIsDropDownOpenPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            RibbonBar bar = (RibbonBar)o;
            bool newValue = (bool)e.NewValue;
            if (!newValue)
            {
                RibbonTabItem tabItem = bar.GetValue(RibbonBar.SelectedItemProperty) as RibbonTabItem;
                if (tabItem != null)
                {
                    if (tabItem.IsSelected)
                    {
                        tabItem.IsSelected = false;
                    }
                }
                bar.ClearValue(RibbonBar.SelectedItemProperty);
                if (bar.IsMouseCaptured)
                {
                    bar.ReleaseMouseCapture();
                }
                
                Common.PopupService.RaisePopupDismissedEvent(bar);
            }
            else
            {
                if (!bar.IsMouseCaptured)
                {
                    System.Windows.Input.Mouse.Capture(bar, System.Windows.Input.CaptureMode.SubTree);
                }
            }
        }
        #endregion

        #region Overrieds
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            if (this._panel != null)
            {
                this._panel.Children.Clear();
                this._panel = null;
            }
            this._panel = this.GetTemplateChild(PART_Panel) as RibbonStackPanel;
            for (int i = 0; i < this.RibbonTabItemsCollection.Count; i++)
            {
                RibbonTabItem item = this.RibbonTabItemsCollection[i];

                System.Windows.Data.BindingOperations.SetBinding
                    (
                         item,
                         RibbonTabItem.IsRibbonBarOnBackgroundModeProperty,
                         new System.Windows.Data.Binding("IsBackgroundMode") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                    );

                if (item.IsSelected)
                {
                    this.ClearValue(RibbonBar.SelectedItemProperty);
                    this.SetValue(RibbonBar.SelectedItemProperty, item);
                    this.SetValue(RibbonBar.SelectedIndexProperty, i);
                    if (!this.IsExpanded)
                    {
                        this.AnimateGridLength();
                    }
                }
                this._panel.Children.Add(item);
                this.RibbonTabItemsCollection.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(this.RibbonTabItemsCollection_CollectionChanged);
            }
            if (this._rootGrid == null)
            {
                this._rootGrid = this.GetTemplateChild(_PART_Root) as System.Windows.Controls.Grid;
                if (this._rootGrid != null)
                {
                    this.barRow = this._rootGrid.RowDefinitions[1] as System.Windows.Controls.RowDefinition;
                }
            }
            if (this.SelectedItem == null)
            {
                this.AnimateGridLength();
            }
            this.TabItemsScroller = this.GetTemplateChild(PART_TabItemsScroller) as RibbonScrollViewer;
            this.Expander = this.GetTemplateChild(PART_Expander) as System.Windows.Controls.Button;
            this.RibbonChrome = this.GetTemplateChild("PART_RibbonItemsContainer") as RibbonChrome;
            this.ShadowChrome = this.GetTemplateChild("PART_ShadowChrome") as Microsoft.Windows.Themes.SystemDropShadowChrome;
            this._ItemsControl = this.GetTemplateChild(PART_ItemsControl) as System.Windows.Controls.ItemsControl;
        }

        #endregion

        #region Private Utilities
        [System.Security.SecurityCritical, System.Security.SecuritySafeCritical]
        internal void AnimateGridLength(bool shoulShutdown = false)
        {
            if (this.barRow != null)
            {
                if (this.StoryBoard == null)
                {
                    this.GridLengthAnimation = new Animations.GridLengthAnimation();
                    this.GridLengthAnimation.Duration = new System.Windows.Duration(System.TimeSpan.FromSeconds(0.11));
                    this.StoryBoard = new System.Windows.Media.Animation.Storyboard();
                    System.Windows.Media.Animation.Storyboard.SetTargetProperty(this.GridLengthAnimation, new System.Windows.PropertyPath("Height"));
                    System.Windows.Media.Animation.Storyboard.SetTarget(this.GridLengthAnimation, this.barRow);
                    this.StoryBoard.Children.Add(this.GridLengthAnimation);
                }
                if (shoulShutdown)
                {
                    this.GridLengthAnimation.From = new System.Windows.GridLength(90.0D);
                    this.GridLengthAnimation.To = new System.Windows.GridLength(0.0D);
                    this.StoryBoard.Completed += this.AnimationCompleted_Collapsed;
                    this.StoryBoard.Begin(this, true);
                    return;
                }
                double val = this.barRow.Height.Value;
                if (val != 0.0D)
                {
                    this.GridLengthAnimation.From = new System.Windows.GridLength(90.0D);
                    this.GridLengthAnimation.To = new System.Windows.GridLength(0.0D);
                    this.StoryBoard.Completed += this.AnimationCompleted_Collapsed;
                    this.StoryBoard.Begin(this, true);
                }
                else
                {
                    this.GridLengthAnimation.From = new System.Windows.GridLength(0.0D);
                    this.GridLengthAnimation.To = new System.Windows.GridLength(90.0D);
                    this.StoryBoard.Completed += this.AnimationComplete_Expanded;
                    this.StoryBoard.Begin(this, true);
                }
            }
        }

        [System.Security.SecurityCritical, System.Security.SecuritySafeCritical]
        private void AnimationCompleted_Collapsed(object sender, System.EventArgs e)
        {
            RibbonTabItem item = this.GetValue(RibbonBar.SelectedItemProperty) as RibbonTabItem;
            if (item != null)
            {
                item.SetValue(RibbonTabItem.IsSelectedProperty, false);
            }
            this.StoryBoard.Completed -= this.AnimationCompleted_Collapsed;

            this.IsExpanded = false;
        }

        [System.Security.SecurityCritical, System.Security.SecuritySafeCritical]
        private void AnimationComplete_Expanded(object sender, System.EventArgs e)
        {
            int index = (int)this.GetValue(RibbonBar.SelectedIndexProperty);
            if (index >= 0)
            {
                RibbonTabItem item = this.RibbonTabItemsCollection[index] as RibbonTabItem;
                item.SetValue(RibbonTabItem.IsSelectedProperty, true);
                this.ClearValue(RibbonBar.SelectedItemProperty);
                this.SetValue(RibbonBar.SelectedItemProperty, item);

            }
            else
            {
                if (this.RibbonTabItemsCollection.Count > 0)
                {
                    RibbonTabItem item = this.RibbonTabItemsCollection[0] as RibbonTabItem;
                    item.SetValue(RibbonTabItem.IsSelectedProperty, true);
                    this.ClearValue(RibbonBar.SelectedItemProperty);
                    this.SetValue(RibbonBar.SelectedItemProperty, item);
                    this.SetValue(RibbonBar.SelectedIndexProperty, 0);
                }
            }
            this.StoryBoard.Completed -= AnimationComplete_Expanded;
            this.IsExpanded = true;
        }

        private void SetBackgroundMode()
        {
            if (this.Popup == null)
            {
                this.Popup = new System.Windows.Controls.Primitives.Popup();
                this.Popup.AllowsTransparency = true;
                this.Popup.PopupAnimation = System.Windows.Controls.Primitives.PopupAnimation.Fade;
                this.Popup.Placement = System.Windows.Controls.Primitives.PlacementMode.Bottom;
                System.Windows.Controls.Grid itemsHolder = this.GetTemplateChild("PART_TabItemPlaceHolder") as System.Windows.Controls.Grid;
                this.Popup.PlacementTarget = itemsHolder;
                this.PopupGrid = new System.Windows.Controls.Grid();

                this.Popup.Child = this.PopupGrid;
                System.Windows.Data.BindingOperations.SetBinding
                    (
                         this.Popup,
                         System.Windows.Controls.Primitives.Popup.IsOpenProperty,
                         new System.Windows.Data.Binding("IsDropDownOpen") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                    );
            }
            this._rootGrid.Children.Remove(this.RibbonChrome);
            this._rootGrid.Children.Remove(this.ShadowChrome);
            this.RibbonChrome.Margin = new System.Windows.Thickness(0.0D);
            //this.ShadowChrome.Margin = new System.Windows.Thickness(0.0D, 0.0D, 0.0D, 2.5D);
            this.ShadowChrome.Opacity = 0.5;
            this.ShadowChrome.Margin = new System.Windows.Thickness(0.0D, 77.0D, 0.0D, 0.0D);
            this.PopupGrid.Children.Add(this.ShadowChrome);
            this.PopupGrid.Children.Add(this.RibbonChrome);
            System.Windows.Input.Mouse.AddPreviewMouseDownOutsideCapturedElementHandler(this, new System.Windows.Input.MouseButtonEventHandler(this.OutSideMouseClicked));
            /*Here should be binding in xaml*/

            this.AnimateGridLength(true);
            RibbonTabItem tab = this.GetValue(RibbonBar.SelectedItemProperty) as RibbonTabItem;
            if (tab != null)
            {
                tab.SetValue(RibbonTabItem.IsSelectedProperty, false);
            }
            this.ClearValue(RibbonBar.SelectedItemProperty);

            Common.PopupService.PopupDismissedEvent += new System.EventHandler(this.PopupDissmissedEventRaised);
        }

        private void UnsetBackgroundMode()
        {
            this.CloseDropDown();

            this.PopupGrid.Children.Remove(this.ShadowChrome);
            this.PopupGrid.Children.Remove(this.RibbonChrome);
            this.ShadowChrome.VerticalAlignment = System.Windows.VerticalAlignment.Bottom;
            this.ShadowChrome.Opacity = 1.0D;

            this.ShadowChrome.Margin = new System.Windows.Thickness(0.0D, 0.0D, 0.0D, 2.5D);

            this._rootGrid.Children.Add(this.ShadowChrome);
            this.RibbonChrome.Margin = new System.Windows.Thickness(0.0D, -1.0D, 0.0D, 0.0D);
            this._rootGrid.Children.Add(this.RibbonChrome);
            System.Windows.Controls.Grid itemsHolder = this.GetTemplateChild("PART_TabItemPlaceHolder") as System.Windows.Controls.Grid;
            this._rootGrid.Children.Remove(itemsHolder);
            this._rootGrid.Children.Add(itemsHolder);
            /*Here should be binding in xaml*/
            this.AnimateGridLength();
            System.Windows.Input.Mouse.RemovePreviewMouseDownOutsideCapturedElementHandler(this, this.OutSideMouseClicked);

            Common.PopupService.PopupDismissedEvent -= this.PopupDissmissedEventRaised;
        }

        internal void OpenDropDown()
        {
            if (!this.IsDropDownOpen)
            {
                this.IsDropDownOpen = true;
            }
        }

        internal void CloseDropDown()
        {
            if (this.IsDropDownOpen)
            {
                this.IsDropDownOpen = false;
            }
        }

        internal void TrySetScrollViewer() 
        {
            if (this._ItemsControl != null) 
            {
                RibbonStackPanel panel = this._ItemsControl.Template.FindName("PART_ItemsPanel", this._ItemsControl) as RibbonStackPanel;
                if (panel != null) 
                {
                    RibbonScrollViewer scrollViewer = panel.ScrollOwner as RibbonScrollViewer;
                    if (scrollViewer != null) 
                    {
                        this.ManuallyInvalidate(panel, scrollViewer);
                        
                    }
                }
            }
        
        }

        private void ManuallyInvalidate(RibbonStackPanel panel, RibbonScrollViewer scrollViewer)
        {
            double offset = panel.HorizontalOffset;
            if (panel.ViewportWidth >= panel.ExtentWidth)
            {
                scrollViewer.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, false);
                scrollViewer.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, false);
            }
            if (offset <= 1)
            {
                offset = 0;
                scrollViewer.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, false);
                scrollViewer.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, true);

            }
            else
            {
                if (offset + 1 >= panel.ExtentWidth - panel.ViewportWidth)
                {
                    offset = panel.ExtentWidth - panel.ViewportWidth;
                    scrollViewer.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, true);
                    scrollViewer.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, false);
                }
                else
                {

                    scrollViewer.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, true);
                    scrollViewer.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, true);
                }

            }
        }
        #endregion

        #region Event Handlers

        private void PopupDissmissedEventRaised(object sender, System.EventArgs e)
        {
            this.CloseDropDown();
        }
        //private void CapturedElementLostMouseCapture(object sender, System.Windows.Input.MouseEventArgs e) 
        //{
        //    System.Windows.UIElement elt = sender as System.Windows.UIElement;
        //    elt.LostMouseCapture -= this.CapturedElementLostMouseCapture;
        //    bool isArrowedToggleButton = false, isRibbonGroup = this.IsTemplatedParentRibbonGroup(elt);
        //    if (elt is RibbonToggleButton)
        //    {
        //        RibbonToggleButton toggle = elt as RibbonToggleButton;
        //        if (toggle.HasArrow)
        //        {
        //            isArrowedToggleButton = true;
        //        }
        //    }
        //    if (!(this.IsElementsParentRibbonGallery(elt) || 
        //        this.IsTemplatedParentRibbonBar(elt) || 
        //        isArrowedToggleButton || 
        //        isRibbonGroup))
        //    {
        //        this.CloseDropDown();
        //    }
        //    else
        //    {
        //        System.Windows.Input.Mouse.Capture(this, System.Windows.Input.CaptureMode.SubTree);
        //    }
        //}

        private void OutSideMouseClicked(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            if (this.IsBackgroundMode)
            {
                Common.PopupService.RaisePopupDismissedEvent(this);
                e.Handled = true;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RibbonTabItemsCollection_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            switch (e.Action)
            {
                case System.Collections.Specialized.NotifyCollectionChangedAction.Add:
                    foreach (RibbonTabItem item in e.NewItems)
                    {
                        this._panel.Children.Add(item);
                    }
                    break;
                case System.Collections.Specialized.NotifyCollectionChangedAction.Remove:
                    foreach (RibbonTabItem item in e.OldItems)
                    {
                        this._panel.Children.Remove(item);
                    }
                    break;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExpandBar(object sender, System.Windows.Input.ExecutedRoutedEventArgs e)
        {
            if (this.IsBackgroundMode)
            {
                this.IsBackgroundMode = false;
            }
            else
            {
                this.AnimateGridLength();
            }
            e.Handled = true;
        }



        #endregion

        public Interfaces.IRibbonControl Clone()
        {
            return new RibbonBar();
        }
        #region Fields

        private const string PART_ItemsControl = "PART_ItemsControl";
        private const string _partPopup = "PART_Popup";
        private const string _partBarHeight = "PART_BarHeight";
        private const string _PART_Root = "PART_Root";
        private const string PART_TabItemsScroller = "PART_TabItemsScroller";
        private const string PART_Expander = "PART_Expander";
        private const string PART_Panel = "PART_Panel";
        internal System.Windows.Controls.RowDefinition barRow;
        private System.Windows.Controls.Grid _rootGrid;
        internal RibbonScrollViewer TabItemsScroller;
        internal RibbonWindow MainWindow { get; set; }
        private System.Windows.Controls.Button Expander;
        private RibbonStackPanel _panel;
        private System.Windows.Media.Animation.Storyboard StoryBoard;
        private Animations.GridLengthAnimation GridLengthAnimation;
        private RibbonChrome RibbonChrome;
        private Microsoft.Windows.Themes.SystemDropShadowChrome ShadowChrome;
        internal System.Windows.Controls.Primitives.Popup Popup;
        private System.Windows.Controls.Grid PopupGrid;
        internal System.Windows.Controls.ItemsControl _ItemsControl;
        #endregion
        #region IRibbonControl Implementation
        public bool IsLarge
        {
            get { return true; }
        }


        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            throw new System.NotImplementedException();
        }
        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
              
    }
}
