﻿

namespace Masterpiece.Controls.Ribbon2010
{
    public sealed class RibbonButton : Ribbon2010.Primitives.RibbonButtonBase, Interfaces.IRibbonControl
    {
        #region Constructors
        static RibbonButton()
        {
            System.Type ownerType=typeof(RibbonButton);
            DefaultStyleKeyProperty.OverrideMetadata
                (
                ownerType,
                new System.Windows.FrameworkPropertyMetadata(ownerType)
                );
            
            //RibbonButton.WidthProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(0.0, new System.Windows.CoerceValueCallback(OnWidthPropertyCoerced)));
        }

        #endregion

        #region Properties and Depenency Properties
        public bool IsLarge
        {
            get
            {
                return this.Size != RibbonControlSize.Small;
            }
        }
        
        #endregion

        #region Depenency Property Changed Callbacks
        
        #endregion

        #region Overrieds

        protected override void OnPreviewMouseRightButtonUp(System.Windows.Input.MouseButtonEventArgs e)
        {
            if (Common.PopupService.IsRibbonQAInitialized)
            {
                if (this.ParentUI != null)
                {
                    try
                    {
                        Common.PopupService.EnableRemovalButton();
                    }
                    catch { }
                }
                else
                {
                    Common.PopupService.DisableRemovalButton();
                }
                Common.PopupService._addItem.IsEnabled = this.IsCloneable;

                Common.PopupService.OpenContextMenu(this);
            }
            base.OnPreviewMouseRightButtonUp(e);
            e.Handled = true;
        }

        protected override void OnClick()
        {
            if (!this.IsClonedItem || (this.IsClonedItem && this.ParentUI != null && this.ParentUI is QACommandItem))
            {
                base.OnClick();
            }
            else
            {
                if (this.ParentUI != null && this.ParentUI is RibbonButton)
                {
                    (this.ParentUI as RibbonButton).OnClick();
                }
            }
            Common.PopupService.RaisePopupDismissedEvent(this);
        }
        #endregion

        #region Private Utilities
        #endregion

        #region Event Handlers
        #endregion

        #region Fields
        internal bool IsCloned = false;
        internal Interfaces.IRibbonControl ParentUI, ClonedChild;
        internal bool isCloneable = true, isClonedItem = false;
        #endregion

        #region IRibbonControl Implementation

        public Interfaces.IRibbonControl Clone()
        {
            RibbonButton clonedButton = null;
            if (this.ClonedChild == null)
            {
                clonedButton = new RibbonButton();
                if (this.SmallImage != null)
                {
                    System.Windows.Data.BindingOperations.SetBinding
                              (
                                 clonedButton,
                                 RibbonButton.SmallImageProperty,
                                 new System.Windows.Data.Binding("SmallImage") { Source = this }
                              );
                }
                else if (this.LargeImage != null)
                {
                    System.Windows.Data.BindingOperations.SetBinding
                              (
                                 clonedButton,
                                 RibbonButton.SmallImageProperty,
                                 new System.Windows.Data.Binding("LargeImage") { Source = this }
                              );
                }
                clonedButton.isClonedItem = true;
                clonedButton.isCloneable = false;
                clonedButton.ParentUI = this;
                this.ClonedChild = clonedButton;
            }
            return clonedButton;
        }
        
        public bool IsClonedItem
        {
            get { return this.isClonedItem; }
        }

        public bool IsCloneable
        {
            get
            {
                return !(this.ClonedChild != null || !RibbonControlCloningService.CheckIfItemIsCloneable(this)) && this.isCloneable;
            }
            internal set { this.isCloneable = value; }
        }
        public void DisposeControl()
        {
            if (this.ClonedChild != null)
            {
                System.Windows.Data.BindingOperations.ClearAllBindings(this.ClonedChild as RibbonButton);
                this.ClonedChild = null;
                System.GC.Collect();
            }
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return this.ParentUI; }
        }
        #endregion
    }
}
