﻿
namespace Masterpiece.Controls.Ribbon2010
{
    public class RibbonComboBoxItem : System.Windows.Controls.ComboBoxItem, Interfaces.IRibbonControl
    {
        #region Constructors

        static RibbonComboBoxItem() 
        {
            System.Type ownerType=typeof(RibbonComboBoxItem);

            RibbonComboBoxItem.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));
        }

        #endregion

        #region Properties and Depenency Properties

        public System.Windows.Media.ImageSource ImageSource
        {
            get { return (System.Windows.Media.ImageSource)GetValue(ImageSourceProperty); }
            set { SetValue(ImageSourceProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageSource.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageSourceProperty =
            System.Windows.DependencyProperty.Register("ImageSource", typeof(System.Windows.Media.ImageSource), typeof(RibbonComboBoxItem));

        #endregion

        #region Depenency Property Changed Callbacks

        #endregion

        #region Overrides

        protected override void OnMouseLeftButtonDown(System.Windows.Input.MouseButtonEventArgs e)
        {
            if (this.VisualParent != null)
            {
                System.Windows.FrameworkElement elt = this.VisualParent as System.Windows.FrameworkElement;
                if (elt.TemplatedParent is RibbonHeaderedExpander) 
                {
                    e.Handled = true;
                    RibbonHeaderedExpander expander = elt.TemplatedParent as RibbonHeaderedExpander;
                    if(expander.Parent!=null)
                    {
                        System.Windows.FrameworkElement parent = expander.Parent as System.Windows.FrameworkElement;
                        if (parent != null) 
                        {
                            if (parent.TemplatedParent is RibbonComboBox) 
                            {
                                RibbonComboBox combo = parent.TemplatedParent as RibbonComboBox;
                                if (this.DataContext != null)
                                {
                                    int index = combo.Items.IndexOf(this.DataContext);
                                    if (index != -1)
                                    {
                                        combo.SelectedIndex = index;
                                    }
                                    else
                                    {
                                        combo.SelectedItem = this.DataContext;
                                        combo.SelectedIndex = -1;
                                    }
                                }
                                else 
                                {
                                    if (this.Content is string) 
                                    {
                                        if (combo.IsEditable)
                                        {
                                            combo.Text = this.Content as string;
                                        }
                                        else 
                                        {
                                            combo.SelectedItem = this.Content;
                                        }
                                    }
                                   
                                }
                                combo.IsDropDownOpen = false;
                            }

                        }
                    }                    
                    return;
                }
            }
            base.OnMouseLeftButtonDown(e);
        }
        #endregion

        #region Private Utilities
        #endregion

        #region Event Handlers
        #endregion

        #region Fields
        #endregion
        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            throw new System.NotImplementedException();
        }

        public bool IsLarge
        {
            get { return false; }
        }


        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            throw new System.NotImplementedException();
        }
        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
       
        #endregion
    }
}
