﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
    public partial class RibbonContentScroller : System.Windows.Controls.ContentControl, Interfaces.IRibbonControl
    {
        #region Constructors

        static RibbonContentScroller()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(RibbonContentScroller), new System.Windows.FrameworkPropertyMetadata(typeof(RibbonContentScroller)));
        }

        public RibbonContentScroller()
        {
           
        }

        #endregion

        #region Properties and Depenency Properties

        public double ScrollBy
        {
            get { return (double)GetValue(ScrollByProperty); }
            set { SetValue(ScrollByProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ScrollBy.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ScrollByProperty =
            System.Windows.DependencyProperty.Register("ScrollBy", typeof(double), typeof(RibbonContentScroller), new System.Windows.PropertyMetadata(3.0D));

        public bool AnimatedScroll
        {
            get { return (bool)GetValue(AnimatedScrollProperty); }
            set { SetValue(AnimatedScrollProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AnimatedScroll.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty AnimatedScrollProperty =
            System.Windows.DependencyProperty.Register("AnimatedScroll", typeof(bool), typeof(RibbonContentScroller), new System.Windows.PropertyMetadata(true));



        public System.Windows.Controls.ScrollBarVisibility HorizontalScrollBarVisibility
        {
            get { return (System.Windows.Controls.ScrollBarVisibility)GetValue(HorizontalScrollBarVisibilityProperty); }
            set { SetValue(HorizontalScrollBarVisibilityProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HorizontalScrollBarVisibility.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty HorizontalScrollBarVisibilityProperty =
            System.Windows.DependencyProperty.Register("HorizontalScrollBarVisibility", typeof(System.Windows.Controls.ScrollBarVisibility), typeof(RibbonContentScroller), new System.Windows.PropertyMetadata(System.Windows.Controls.ScrollBarVisibility.Disabled));

        public System.Windows.Controls.ScrollBarVisibility VerticalScrollBarVisibility
        {
            get { return (System.Windows.Controls.ScrollBarVisibility)GetValue(VerticalScrollBarVisibilityProperty); }
            set { SetValue(VerticalScrollBarVisibilityProperty, value); }
        }

        // Using a DependencyProperty as the backing store for VerticalScrollBarVisibility.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty VerticalScrollBarVisibilityProperty =
            System.Windows.DependencyProperty.Register("VerticalScrollBarVisibility", typeof(System.Windows.Controls.ScrollBarVisibility), typeof(RibbonContentScroller), new System.Windows.PropertyMetadata(System.Windows.Controls.ScrollBarVisibility.Disabled));



        public System.Windows.CornerRadius CornerRadius
        {
            get { return (System.Windows.CornerRadius )GetValue(CornerRadiusProperty); }
            set { SetValue(CornerRadiusProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CornerRadius.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty CornerRadiusProperty =
            System.Windows.DependencyProperty.Register("CornerRadius", typeof(System.Windows.CornerRadius ), typeof(RibbonContentScroller), new System.Windows.PropertyMetadata(new System.Windows.CornerRadius(0, 0, 0, 0)));

        
        #endregion

        #region IRibbonControl Implementation

        public Interfaces.IRibbonControl Clone()
        {
            throw new NotImplementedException();
        }


        public bool IsLarge
        {
            get { return false; }
        }


        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            throw new NotImplementedException();
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
    }
}
