﻿

namespace Masterpiece.Controls.Ribbon2010
{
    using System.Linq;
   internal static class RibbonControlCloningService
    {
       private static System.Collections.ObjectModel.ObservableCollection<System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl>> Items = null;

       internal static void Add(Interfaces.IRibbonControl owner, int ID) 
       {
           if (RibbonControlCloningService.Items != null) 
           {
               System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl> kv = (from k in RibbonControlCloningService.Items
                                                                                             where k.Key == ID || k.Value == owner
                                                                                             select k).FirstOrDefault();
               if (kv.Value != null)
               {
                   throw new System.InvalidOperationException("Specified ItemID already belongs to another control");
               }

               RibbonControlCloningService.Items.Add(new System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl>(ID, owner));
               
           }
       }

       private static Interfaces.IRibbonControl GetControlById(int ID) 
       {
           System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl> kv = (from k in RibbonControlCloningService.Items
                                                                                         where k.Key == ID
                                                                                         select k).FirstOrDefault();
           return kv.Value;
       }
       internal static void Remove(int ID) 
       {
           System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl> kv = (from k in RibbonControlCloningService.Items
                                                                                         where k.Key == ID
                                                                                         select k).FirstOrDefault();
           RibbonControlCloningService.Items.Remove(kv);
       }

       internal static void ClearItems() 
       {
           RibbonControlCloningService.Items.Clear();
       }
       
       internal static void InitializeCloningService() 
       {
           RibbonControlCloningService.Items = new System.Collections.ObjectModel.ObservableCollection<System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl>>();
           RibbonControlCloningService.Items.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(RibbonControlCloningService.CollectionChanged);
       }

       internal static bool CheckIfItemIsCloneable(Interfaces.IRibbonControl control) 
       {
           if (RibbonControlCloningService.Items == null) 
           {
               return false;
           }
           System.Collections.Generic.KeyValuePair<int, Interfaces.IRibbonControl> kv = (from k in RibbonControlCloningService.Items
                                                                                         where k.Value == control
                                                                                         select k).FirstOrDefault();
           return kv.Value != null;
       }
      
       private static void CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) 
       {
       
       }

       internal static  System.Collections.Generic.IEnumerable<Interfaces.IRibbonControl> GetItems(System.Collections.Generic.IEnumerable<int> items) 
       {
           System.Collections.Generic.List<Interfaces.IRibbonControl> controls = new System.Collections.Generic.List<Interfaces.IRibbonControl>();
           foreach (int item in items)
           {
               Interfaces.IRibbonControl control = RibbonControlCloningService.GetControlById(item);
               if (control != null) 
               {
                   controls.Add(control);
               }
           }
           return controls;
       }

       internal static event System.EventHandler CommandItemRemovedEvent;

       internal static void RaiseCommandItemRemovedEvent(object sender) 
       {
           if (RibbonControlCloningService.CommandItemRemovedEvent != null) 
           {
               RibbonControlCloningService.CommandItemRemovedEvent(sender, new System.EventArgs());
           }
       }
    }
}
