﻿
namespace Masterpiece.Controls.Ribbon2010
{
   public class RibbonGalleryItem:System.Windows.Controls.ContentControl, Interfaces.IRibbonControl
   {
       #region Constructors

       static RibbonGalleryItem() 
       {
           System.Type ownerType=typeof(RibbonGalleryItem);

           RibbonGalleryItem.DefaultStyleKeyProperty.OverrideMetadata
               (
                ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType)
               );

       }

       #endregion

       #region Properties and Depenency Properties

       public System.Windows.Media.ImageSource Image
       {
           get { return (System.Windows.Media.ImageSource)GetValue(ImageProperty); }
           set { SetValue(ImageProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Image.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageProperty =
           System.Windows.DependencyProperty.Register("Image", typeof(System.Windows.Media.ImageSource), typeof(RibbonGalleryItem), new System.Windows.PropertyMetadata(null));

       public bool IsSelected
       {
           get { return (bool)GetValue(IsSelectedProperty); }
           set { SetValue(IsSelectedProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsSelected.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty IsSelectedProperty =
           System.Windows.DependencyProperty.Register("IsSelected", typeof(bool), typeof(RibbonGalleryItem), new System.Windows.FrameworkPropertyMetadata(false, System.Windows.FrameworkPropertyMetadataOptions.BindsTwoWayByDefault));

       #endregion

       #region Depenency Property Changed Callbacks

       #endregion

       #region Overrides
       protected override void OnPreviewMouseLeftButtonDown(System.Windows.Input.MouseButtonEventArgs e)
       {
           base.OnPreviewMouseLeftButtonDown(e);
           Common.PopupService.RaiseRibbonGalleryItemSelectedEvent(this);
       }


       public virtual RibbonGalleryItem Clone() 
       {
           return new RibbonGalleryItem() {Image=this.Image };
       }
     
       #endregion

       #region Private Utilities
       #endregion

       #region Event Handlers
       #endregion

       #region Fields
       #endregion

       #region Events
       #endregion

       public bool IsLarge
       {
           get { return true; }
       }

       Interfaces.IRibbonControl Interfaces.IRibbonControl.Clone()
       {
           throw new System.NotImplementedException();
       }


       public bool IsClonedItem
       {
           get { return false; }
       }

       public bool IsCloneable
       {
           get { return false; }
       }


       public void DisposeControl()
       {
           throw new System.NotImplementedException();
       }


       public Interfaces.IRibbonControl ParentControl
       {
           get { return null; }
       }
   }
}
