﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
    internal class RibbonGroupPanel : System.Windows.Controls.Panel, Interfaces.IRibbonControl
    {
        #region Overrieds
        protected override System.Windows.Size ArrangeOverride(System.Windows.Size finalSize)
        {
            double max_y = 0, max_x = 0, y = 0, x = 0;
            System.Windows.Size size = new System.Windows.Size();
            System.Windows.UIElement e = null;
                foreach (int index in this.largeItems)
                {
                    e = this.InternalChildren[index];
                    e.Arrange(new System.Windows.Rect(x, 0, e.DesiredSize.Width, e.DesiredSize.Height));
                    x += e.DesiredSize.Width + 0.7;
                    size.Width += e.DesiredSize.Width + 0.7;
                    size.Height = System.Math.Max(size.Height, e.DesiredSize.Height);
                }

                    for (int i = 0; i < this.smalItems.Count; i++)
                    {
                        if (i != 0 && i % 3 == 0)
                        {
                            size.Width += max_x;
                            x = size.Width;
                            max_y = System.Math.Max(max_y, y);
                            max_x = 0;
                            y = 0;
                        }
                        e = this.InternalChildren[this.smalItems[i]];
                        e.Arrange(new System.Windows.Rect(x, y, e.DesiredSize.Width, e.DesiredSize.Height));
                        y += e.DesiredSize.Height;
                        max_x = System.Math.Max(max_x, e.DesiredSize.Width);
                    }
                    size.Width += max_x;
                    max_y = System.Math.Max(max_y, y);
                    size.Height = System.Math.Max(size.Height, max_y);
            return size;

        }
        protected override System.Windows.Size MeasureOverride(System.Windows.Size availableSize)
        {
            System.Windows.Size infiniteSize = new System.Windows.Size(double.PositiveInfinity, double.PositiveInfinity);
            if (this.smalItems == null && this.largeItems == null)
            {
                this.largeItems = new System.Collections.Generic.List<int>();
                this.smalItems = new System.Collections.Generic.List<int>();
                for (int i = 0; i < this.InternalChildren.Count; i++)
                {
                    Ribbon2010.Interfaces.IRibbonControl btn = this.InternalChildren[i] as Ribbon2010.Interfaces.IRibbonControl;
                    if (btn != null)
                    {
                        if (btn.IsLarge)
                        {
                            this.largeItems.Add(i);
                        }
                        else
                        {
                            this.smalItems.Add(i);
                        }
                    }

                }
            }
            foreach (System.Windows.UIElement elt in this.InternalChildren)
            {
                elt.Measure(infiniteSize);
            }
            System.Windows.Size size = this.CalculateExtent();
            if (!double.IsInfinity(availableSize.Height))
            {
                size.Height = System.Math.Max(size.Height, availableSize.Height);
            }

            return size;
        }
        #endregion

        #region Private Utilities
        private System.Windows.Size CalculateExtent()
        {
            double max_y = 0, max_x = 0, y = 0;
            System.Windows.UIElement e = null;
            System.Windows.Size size = new System.Windows.Size();
            
                foreach (int index in this.largeItems)
                {
                    e = this.InternalChildren[index];
                    size.Width += e.DesiredSize.Width + 0.7;
                    size.Height = System.Math.Max(size.Height, e.DesiredSize.Height);
                }
                
                  for (int i = 0; i < this.smalItems.Count; i++)
                    {
                        if (i != 0 && i % 3 == 0)
                        {
                            size.Width += max_x;
                            max_y = System.Math.Max(max_y, y);
                            max_x = 0;
                            y = 0;
                        }
                        e = this.InternalChildren[this.smalItems[i]];
                        y += e.DesiredSize.Height + 0.7;
                        max_x = System.Math.Max(max_x, e.DesiredSize.Width);
                    }
                    size.Width += max_x;
                    max_y = System.Math.Max(max_y, y);
                    size.Height = System.Math.Max(size.Height, max_y);
            
            return size;
        }
        #endregion
        #region Fields
        private System.Collections.Generic.List<int> smalItems = null;
        private System.Collections.Generic.List<int> largeItems = null;
        #endregion

        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            throw new NotImplementedException();
        }

        public bool IsLarge
        {
            get { throw new NotImplementedException(); }
        }

        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            throw new NotImplementedException();
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { throw new System.NotImplementedException(); }
        }
        #endregion
    }
}
