﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
   [System.Windows.TemplatePart(Name=PART_Toggle, Type=typeof(Controls.Primitives.ToggleButton))]
   [System.Windows.TemplatePart(Name=PART_Panel, Type=typeof(RibbonWrapPanel))]
   [System.Windows.StyleTypedProperty(Property = "ItemContainerStyle", StyleTargetType = typeof(RibbonHeaderedExpanderItem))]
   public class RibbonHeaderedExpander:System.Windows.Controls.Primitives.Selector, Interfaces.IRibbonControl
   {
       #region Constructors

       /// <summary>
       /// 
       /// </summary>
       static RibbonHeaderedExpander() 
       {
           System.Type ownerType = typeof(RibbonHeaderedExpander);
           RibbonHeaderedExpander.DefaultStyleKeyProperty.OverrideMetadata
               (
               ownerType,
               new System.Windows.FrameworkPropertyMetadata(ownerType)
               );
           

       }

       /// <summary>
       /// 
       /// </summary>
       public RibbonHeaderedExpander() 
       {
           //this.Children = new ButtonBaseCollection(this);
       }
       #endregion

       #region Properties and Depenency Properties
      
       /// <summary>
       /// 
       /// </summary>
       public int WrapBy
       {
           get { return (int)GetValue(WrapByProperty); }
           set { SetValue(WrapByProperty, value); }
       }

       // Using a DependencyProperty as the backing store for WrapBy.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty WrapByProperty =
           System.Windows.DependencyProperty.Register("WrapBy", typeof(int), typeof(RibbonHeaderedExpander), new System.Windows.FrameworkPropertyMetadata(3, new System.Windows.PropertyChangedCallback(OnWrapByPropertyChanged), new System.Windows.CoerceValueCallback(OnCoerceWrapByProperty)));

       public Masterpiece.Controls.Ribbon2010.ItemAlignment ItemAlignment
       {
           get { return (Masterpiece.Controls.Ribbon2010.ItemAlignment)GetValue(ItemAlignmentProperty); }
           set { SetValue(ItemAlignmentProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Stretch.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ItemAlignmentProperty =
           System.Windows.DependencyProperty.Register("ItemAlignment", typeof(Masterpiece.Controls.Ribbon2010.ItemAlignment), typeof(RibbonHeaderedExpander), new System.Windows.FrameworkPropertyMetadata(Masterpiece.Controls.Ribbon2010.ItemAlignment.None, new System.Windows.PropertyChangedCallback(RibbonHeaderedExpander.OnItemAlignmentPropertyChanged)));
       
       /// <summary>
       /// 
       /// </summary>
       public string Header
       {
           get { return (string)GetValue(HeaderProperty); }
           set { SetValue(HeaderProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Header.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty HeaderProperty =
           System.Windows.DependencyProperty.Register("Header", typeof(string), typeof(RibbonHeaderedExpander), new System.Windows.FrameworkPropertyMetadata(null, new System.Windows.PropertyChangedCallback(OnHeaderPropertyChanged)));

       public static readonly System.Windows.DependencyPropertyKey HasHeaderPropertyKey = System.Windows.DependencyProperty.RegisterReadOnly
           (
           "HasHeader",
           typeof(bool),
           typeof(RibbonGallery),
           new System.Windows.PropertyMetadata(false)
           );

       /// <summary>
       /// 
       /// </summary>
       public bool HasHeader
       {
           get { return (bool)GetValue(HasHeaderProperty); }
           private set { SetValue(HasHeaderPropertyKey, value); }
       }

       public static readonly System.Windows.DependencyProperty HasHeaderProperty = HasHeaderPropertyKey.DependencyProperty;

       /// <summary>
       /// 
       /// </summary>

       /// <summary>
       /// Gets or sets the value indicating whether RibbonHeaderedExpanderControl can be expanded. This is a dependency property.
       /// </summary>
       [System.ComponentModel.Browsable(true),
       System.ComponentModel.Category("Appearence"),
       System.ComponentModel.Bindable(true),
       System.ComponentModel.ReadOnly(false)]
       public bool IsExpandable
       {
           get { return (bool)GetValue(IsExpandableProperty); }
           set { SetValue(IsExpandableProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsExpandable.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty IsExpandableProperty =
           System.Windows.DependencyProperty.Register("IsExpandable", typeof(bool), typeof(RibbonHeaderedExpander), new System.Windows.PropertyMetadata(true));



       internal int PreviousSelectedIndex
       {
           get { return (int)GetValue(PreviousSelectedIndexProperty); }
           set { SetValue(PreviousSelectedIndexProperty, value); }
       }

       // Using a DependencyProperty as the backing store for PreviousSelectedIndex.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyProperty PreviousSelectedIndexProperty =
           System.Windows.DependencyProperty.Register("PreviousSelectedIndex", typeof(int), typeof(RibbonHeaderedExpander), new System.Windows.PropertyMetadata(-1, new System.Windows.PropertyChangedCallback(RibbonHeaderedExpander.OnPreviousSelectedIndexPropertyChanged)));
       
       #endregion

       #region Depenency Property Changed Callbacks

       private static void OnPreviousSelectedIndexPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           int previousIndex = (int)e.NewValue;
           RibbonHeaderedExpander expander = (RibbonHeaderedExpander)d;
           if (previousIndex >= 0 && previousIndex != expander.SelectedIndex)
           {
               System.Windows.Controls.ItemContainerGenerator generator = expander.ItemContainerGenerator;

               RibbonGalleryItem item = generator.ContainerFromIndex(previousIndex) as RibbonGalleryItem;

               if (item != null)
               {
                   if (item.IsSelected)
                   {
                       item.IsSelected = false;
                   }
               }
           }
       }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="o"></param>
       /// <param name="e"></param>
       private static void OnHeaderPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
       {
           if (e.NewValue != null)
           {
               RibbonHeaderedExpander gal = o as RibbonHeaderedExpander;
               o.SetValue(RibbonHeaderedExpander.HasHeaderPropertyKey, true);
           }
           else
           {
               o.SetValue(RibbonHeaderedExpander.HasHeaderPropertyKey, false);
           }
       }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="o"></param>
       /// <param name="e"></param>
       private static void OnWrapByPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           int newValue = (int)e.NewValue;
       }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="o"></param>
       /// <param name="argument"></param>
       /// <returns></returns>
       private static object OnCoerceWrapByProperty(System.Windows.DependencyObject o, object argument) 
       {
           int arg = (int)argument;
           RibbonHeaderedExpander expander = o as RibbonHeaderedExpander;
           if (expander.ItemAlignment == ItemAlignment.Stretch) 
           {
              return 1;
           }
           if (arg <= 0) 
           {
               return 3;
           }
           return argument;
       }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="o"></param>
       /// <param name="e"></param>
       private static void OnItemAlignmentPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           Masterpiece.Controls.Ribbon2010.ItemAlignment newValue = (Masterpiece.Controls.Ribbon2010.ItemAlignment)e.NewValue;
           if (newValue == ItemAlignment.Stretch) 
           {
               o.SetValue(RibbonHeaderedExpander.WrapByProperty, 1);
           }
       }
       #endregion

       #region Overrides
       
       /// <summary>
       /// 
       /// </summary>
       public override void OnApplyTemplate()
       {
           base.OnApplyTemplate();
           this.Panel = this.GetTemplateChild(PART_Panel) as RibbonWrapPanel;
           /**/
           if (this._toggle != null)
           {
               this._toggle.Checked -= this.Toggle_Checked;
               this._toggle.UnChecked -= this.Toggle_UnChecked;
           }
           
           this._toggle = (Controls.Primitives.ToggleButton)this.GetTemplateChild(PART_Toggle);
           
           if (this._toggle != null) 
           {
               this._toggle.Checked += new System.Windows.RoutedEventHandler(this.Toggle_Checked);
               this._toggle.UnChecked += new System.Windows.RoutedEventHandler(this.Toggle_UnChecked);
           }

           if (this.Parent != null)
           {
               if (this.Parent is System.Windows.Controls.StackPanel)
               {
                   System.Windows.Controls.StackPanel panel = this.Parent as System.Windows.Controls.StackPanel;
                   if (panel.TemplatedParent is RibbonComboBox)
                   {
                       this.IsParentRibbonComboBox = true;
                   }
               }
           }
           
           System.Windows.Controls.Grid grid = this.GetTemplateChild("PART_Grid") as System.Windows.Controls.Grid;
           if (grid != null) 
           {
               this._row = grid.RowDefinitions[1];
           }
           Common.PopupService.RibbonHeaderedExpanderItemSelectedEvent += new EventHandler(this.RibbonHeaderExpanderSelected);
       }

       protected override System.Windows.DependencyObject GetContainerForItemOverride()
       {
           if (this.IsParentRibbonComboBox)
           {
               return new RibbonComboBoxItem();
           }
           
           else
           {
               return new RibbonHeaderedExpanderItem();
           }
       }

       protected override bool IsItemItsOwnContainerOverride(object item)
       {
           if (this.IsParentRibbonComboBox)
           {
               return item is RibbonComboBoxItem;
           }
           
           else
           {
               return item is RibbonHeaderedExpanderItem;
           }
       }

       protected override void OnSelectionChanged(System.Windows.Controls.SelectionChangedEventArgs e)
       {
           base.OnSelectionChanged(e);
           this.DeselectItem();
           this.SelectItem();
       }

       #endregion

       #region Private Utilities

       private void SelectItem()
       {
           if (this.ItemsSource != null)
           {
               if (this.SelectedIndex >= 0)
               {
                   RibbonHeaderedExpanderItem selectedItem = this.ItemContainerGenerator.ContainerFromIndex(this.SelectedIndex) as RibbonHeaderedExpanderItem;
                   if (selectedItem != null)
                   {
                       selectedItem.IsSelected = true;
                   }
               }
           }
           else
           {
               if (this.SelectedIndex >= 0)
               {
                   RibbonHeaderedExpanderItem selectedItem = this.Items[this.SelectedIndex] as RibbonHeaderedExpanderItem;
                   if (selectedItem != null)
                   {
                       selectedItem.IsSelected = true;
                   }
               }
           }
       }

       private void DeselectItem()
       {
           if (this.ItemsSource != null)
           {
               if (this.PreviousSelectedIndex >= 0)
               {
                   RibbonHeaderedExpanderItem pItem = this.ItemContainerGenerator.ContainerFromIndex(this.PreviousSelectedIndex) as RibbonHeaderedExpanderItem;
                   if (pItem != null)
                   {
                       pItem.IsSelected = false;
                   }
               }
           }
           else
           {
               if (this.PreviousSelectedIndex >= 0)
               {
                   RibbonHeaderedExpanderItem selectedItem = this.Items[this.PreviousSelectedIndex] as RibbonHeaderedExpanderItem;
                   if (selectedItem != null)
                   {
                       selectedItem.IsSelected = false;
                   }
               }
           }
       }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="from"></param>
       /// <param name="to"></param>
       private void AnimateGridLength(double from, double to) 
       {
           if (this.Panel.IsMeasureValid)
           {
               Animations.GridLengthAnimation anim = new Animations.GridLengthAnimation();
               anim.From = new System.Windows.GridLength(from);
               anim.To = new System.Windows.GridLength(to);
               anim.Duration = new System.Windows.Duration(System.TimeSpan.FromSeconds(0.11));
               this._row.BeginAnimation(System.Windows.Controls.RowDefinition.HeightProperty, anim);
           }
       }
       #endregion

       #region Event Handlers

       private void RibbonHeaderExpanderSelected(object sender, System.EventArgs e)
       {
           if (sender == null || !(sender is RibbonHeaderedExpanderItem)) 
           {
               return;
           }
           this.PreviousSelectedIndex = this.SelectedIndex;
           RibbonHeaderedExpanderItem selectedItem = sender as RibbonHeaderedExpanderItem;
           object selectedObject = this.ItemsSource != null ? selectedItem.DataContext : sender;
           int index = this.Items.IndexOf(selectedObject);
           if (index >= 0)
           {
               this.SelectedIndex = index;
           }
       }
       private void Children_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) 
       {
           switch (e.Action) 
           {
               case System.Collections.Specialized.NotifyCollectionChangedAction.Add:
                   foreach (var item in e.NewItems)
                   {
                       this.Panel.Children.Add(item as System.Windows.UIElement);
                   }
                   break;
               case System.Collections.Specialized.NotifyCollectionChangedAction.Remove:
                   foreach (var item in e.OldItems)
                   {
                       this.Panel.Children.Add(item as System.Windows.UIElement);
                   }
                   break;
           }
       }

       private void Toggle_Checked(object sender, System.Windows.RoutedEventArgs e) 
       {
           if (this.rowHeight == -1) 
           {
               this.rowHeight = this.Panel.DesiredSize.Height;
           }
           this.AnimateGridLength(this.rowHeight, 0.0D);   
       }

       private void Toggle_UnChecked(object sender, System.Windows.RoutedEventArgs e)
       {
          this.AnimateGridLength(0.0D, this.rowHeight);
       }
       #endregion

       #region Fields
       private const string PART_Panel = "PART_Panel";
       private const string PART_Toggle = "PART_Toggle";
       private System.Windows.Controls.RowDefinition _row;
       internal Controls.Primitives.ToggleButton _toggle;
       internal RibbonWrapPanel Panel;
       private double rowHeight = -1;
       internal bool IsParentRibbonComboBox {get;set;}
       internal bool IsParentRibbonGallery { get; set; }
       private bool isCloneable = false, isClonedItem = false;
       #endregion

       public Interfaces.IRibbonControl Clone()
       {
           return null;
       }


       public bool IsLarge
       {
           get { return true; }
       }
       public bool IsClonedItem
       {
           get { return this.isClonedItem; }
       }

       public bool IsCloneable
       {
           get { return this.isCloneable; }
       }


       public void DisposeControl()
       {
       }

       public Interfaces.IRibbonControl ParentControl
       {
           get { return null; }
       }
   }
}
