﻿
namespace Masterpiece.Controls.Ribbon2010
{

    [System.Windows.TemplatePart(Name=PART_ExpanderItemsPanel, Type=typeof(RibbonStackPanel))]
    [System.Windows.TemplatePart(Name=PART_ScollViewer, Type=typeof(RibbonScrollViewer))]
    [System.Windows.TemplatePart(Name = PART_Thumb, Type = typeof(Masterpiece.Controls.Primitives.Thumb))]
    [System.Windows.TemplatePart(Name = PART_Grid, Type = typeof(System.Windows.Controls.Grid))]
    [System.Windows.Markup.ContentProperty("Items")]
    public class RibbonPopupMenu : System.Windows.Controls.Control, Interfaces.IRibbonControl
    {
        #region Constructors
        static RibbonPopupMenu() 
        {
            System.Type ownerType = typeof(RibbonPopupMenu);
            RibbonPopupMenu.DefaultStyleKeyProperty.OverrideMetadata
                (
                    ownerType,
                    new System.Windows.FrameworkPropertyMetadata(ownerType)
                );
            System.Windows.Input.KeyboardNavigation.DirectionalNavigationProperty.OverrideMetadata
                (
                    ownerType,
                    new System.Windows.FrameworkPropertyMetadata(System.Windows.Input.KeyboardNavigationMode.Cycle)
                );

            RibbonPopupMenu.MaxDropDownHeightProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(System.Windows.SystemParameters.PrimaryScreenHeight / 1.2D));
        }
        public RibbonPopupMenu() 
        {
            this.Items = new PopupMenuItemCollection();
            this.ExpanderItems = new ExpanderCollection();
           // System.Windows.Input.Mouse.AddPreviewMouseDownOutsideCapturedElementHandler(this, new System.Windows.Input.MouseButtonEventHandler(this.OutsideMouseCaptured));
        }
        #endregion
        
        #region Properties and Depenency Properties
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.ReadOnly(false)]
        public string  Header
        {
            get { return (string)GetValue(HeaderProperty); }
            set { SetValue(HeaderProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Header.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty HeaderProperty =
            System.Windows.DependencyProperty.Register("Header", typeof(string ), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata((string)null, new System.Windows.PropertyChangedCallback(RibbonPopupMenu.OnHeaderPropertyChanged)));

        public bool HasHeader
        {
            get { return (bool)GetValue(HasHeaderProperty); }
        }

        // Using a DependencyProperty as the backing store for HasHeader.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyPropertyKey HasHeaderPropertyKey =
            System.Windows.DependencyProperty.RegisterReadOnly("HasHeader", typeof(bool), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata(false));
        
        internal static readonly System.Windows.DependencyProperty HasHeaderProperty = RibbonPopupMenu.HasHeaderPropertyKey.DependencyProperty;

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(true), 
        System.ComponentModel.ReadOnly(false)]
        public System.Windows.Controls.ScrollBarVisibility HorizontalScrollBarVisibility
        {
            get { return (System.Windows.Controls.ScrollBarVisibility)GetValue(HorizontalScrollBarVisibilityProperty); }
            set { SetValue(HorizontalScrollBarVisibilityProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HorizontalScrollBarVisibility.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty HorizontalScrollBarVisibilityProperty =
            System.Windows.DependencyProperty.Register("HorizontalScrollBarVisibility", typeof(System.Windows.Controls.ScrollBarVisibility), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata(System.Windows.Controls.ScrollBarVisibility.Auto));
        
        [System.ComponentModel.Bindable(true), System.ComponentModel.Browsable(true), System.ComponentModel.ReadOnly(false)]
        public System.Windows.Controls.ScrollBarVisibility VerticalScrollBarVisibility
        {
            get { return (System.Windows.Controls.ScrollBarVisibility)GetValue(VerticalScrollBarVisibilityProperty); }
            set { SetValue(VerticalScrollBarVisibilityProperty, value); }
        }

        // Using a DependencyProperty as the backing store for VerticalScrollBarVisibility.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty VerticalScrollBarVisibilityProperty =
            System.Windows.DependencyProperty.Register("VerticalScrollBarVisibility", typeof(System.Windows.Controls.ScrollBarVisibility), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata(System.Windows.Controls.ScrollBarVisibility.Auto));
        
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        public PopupMenuItemCollection Items
        {
            get { return (PopupMenuItemCollection)GetValue(ItemsProperty); }
            set { SetValue(ItemsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Items.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ItemsProperty =
            System.Windows.DependencyProperty.Register("Items", typeof(PopupMenuItemCollection), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata((PopupMenuItemCollection)null));
        
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(true), 
        System.ComponentModel.ReadOnly(false)]
        public double DropDownHeight
        {
            get { return (double)GetValue(DropDownHeightProperty); }
            set { SetValue(DropDownHeightProperty, value); }
        }

        // Using a DependencyProperty as the backing store for DropDownHeight.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty DropDownHeightProperty =
            System.Windows.DependencyProperty.Register("DropDownHeight", typeof(double), typeof(RibbonPopupMenu));

        [System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public ExpanderCollection ExpanderItems
        {
            get { return (ExpanderCollection)GetValue(ExpanderItemsProperty); }
            set { SetValue(ExpanderItemsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentItems.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ExpanderItemsProperty =
            System.Windows.DependencyProperty.Register("ExpanderItems", typeof(ExpanderCollection), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata((ExpanderCollection)null));
        internal bool IsDropDownOpen
        {
            get { return (bool)GetValue(IsDropDownOpenProperty); }
            set { SetValue(IsDropDownOpenProperty, value); }
        }

        public bool HasExpanderItems
        {
            get { return (bool)GetValue(HasExpanderItemsProperty); }
        }

        // Using a DependencyProperty as the backing store for HasExpanderItems.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyPropertyKey HasExpanderItemsPropertyKey =
            System.Windows.DependencyProperty.RegisterReadOnly("HasExpanderItems", typeof(bool), typeof(RibbonPopupMenu), new System.Windows.PropertyMetadata(false));
        
        internal static readonly System.Windows.DependencyProperty HasExpanderItemsProperty = RibbonPopupMenu.HasExpanderItemsPropertyKey.DependencyProperty;
        
        // Using a DependencyProperty as the backing store for IsDropDownOpen.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsDropDownOpenProperty =
            System.Windows.DependencyProperty.Register("IsDropDownOpen", typeof(bool), typeof(RibbonPopupMenu), new System.Windows.FrameworkPropertyMetadata
                (false, 
                System.Windows.FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, 
                new System.Windows.PropertyChangedCallback(RibbonPopupMenu.OnIsDropDownPropertyChanged),
                new System.Windows.CoerceValueCallback(RibbonPopupMenu.CoerceOnIsDropDownProperty)));

        [System.ComponentModel.Bindable(true)]
        public bool CanResize
        {
            get { return (bool)GetValue(CanResizeProperty); }
            set { SetValue(CanResizeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CanResize.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty CanResizeProperty =
            System.Windows.DependencyProperty.Register("CanResize", typeof(bool), typeof(RibbonPopupMenu), new System.Windows.FrameworkPropertyMetadata
                (
                    true
                ));


        public double MaxDropDownHeight
        {
            get { return (double)GetValue(MaxDropDownHeightProperty); }
            set { SetValue(MaxDropDownHeightProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MaxDropDownHeight.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty MaxDropDownHeightProperty = RibbonComboBox.MaxDropDownHeightProperty.AddOwner(typeof(RibbonPopupMenu));
        #endregion

        #region Depenency Property Changed Callbacks

        private static void OnHeaderPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonPopupMenu menu = (RibbonPopupMenu)d;
            string newValue = (string)e.NewValue;
            menu.SetValue(RibbonPopupMenu.HasHeaderPropertyKey, !System.String.IsNullOrEmpty(newValue));
        }
        private static void OnCanResizePropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonPopupMenu popup = (RibbonPopupMenu)o;
            bool newValue = (bool)e.NewValue;
            bool oldValue = !newValue;
            popup.SetGridHeight(newValue);
        }

        private static void OnIsDropDownPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            bool newValue = (bool)e.NewValue, oldValue = (bool)e.OldValue;
            RibbonPopupMenu popup = (RibbonPopupMenu)o;
            double height = 0;
            System.Windows.Data.BindingExpression expression = popup.GetBindingExpression(RibbonPopupMenu.IsDropDownOpenProperty);
            if (newValue)
            {
                if (popup.CanResize)
                {
                    height = 7;
                }
                popup.SetHeight(height);

                if (expression != null)
                {
                    if (expression.DataItem is Interfaces.IRibbonControl)
                    {
                        if (Common.PopupService.OpeningRibbonControl == expression.DataItem)
                        {
                            Common.PopupService.RibbonControlOpening = false;
                        }
                    }
                }
            }
            else 
            {
                if (Common.PopupService.RibbonBar != null && Common.PopupService.RibbonBar.IsBackgroundMode)
                {
                    //System.Console.WriteLine(Common.PopupService.OpeningRibbonControl);
                    if (!Common.PopupService.RibbonControlOpening &&
                        expression != null &&
                        expression.DataItem == Common.PopupService.OpeningRibbonControl)
                    {
                        Common.PopupService.RaisePopupDismissedEvent(popup);
                    }
                }
            }
        }

        private static System.Object CoerceOnIsDropDownProperty(System.Windows.DependencyObject o, System.Object value)
        {
            return value is bool ? value : false;
        }
        #endregion

        #region Overrides
        
        //protected override void OnKeyDown(System.Windows.Input.KeyEventArgs e)
        //{
        //    base.OnKeyDown(e);
        //    if (e.Key == System.Windows.Input.Key.Down)
        //    {
        //        Controls.Primitives.ButtonBase lastNavigatedItem = null;
        //        lastNavigatedItem = this.GetValue(RibbonPopupMenu.LastNavigatedItemProperty) as Controls.Primitives.ButtonBase;
        //        if (lastNavigatedItem != null && lastNavigatedItem is RibbonPopupMenuItem)
        //        {
        //            this.NavigatedItemIndex++;
        //            if (this.NavigatedItemIndex >= this.Items.Count)
        //            {
        //                return;
        //            }
        //            lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, false);
        //            this.ClearValue(RibbonPopupMenu.LastNavigatedItemProperty);
        //            lastNavigatedItem = this.Items[this.NavigatedItemIndex];
        //            lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //            this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //        }
        //        if (this.NavigatedCollectionIndex == -1)
        //        {
        //            RibbonHeaderedExpander exp = this.ExpanderItems[0];
        //            this.ClearValue(RibbonPopupMenu.LastNavigatedItemProperty);
        //            lastNavigatedItem = exp.Children[0];
        //            lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //            this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //            this.NavigatedCollectionIndex = 0;
        //            this.NavigatedItemIndex = 0;
        //            this.navigaionHeight += 20;
        //            this.navigaionHeight += lastNavigatedItem.DesiredSize.Height;
        //            if ((bool)exp._toggle.IsChecked)
        //            {
        //                exp._toggle.IsChecked = false;
        //            }
        //        }
        //        else
        //        {
        //            lastNavigatedItem = this.GetValue(RibbonPopupMenu.LastNavigatedItemProperty) as Controls.Primitives.ButtonBase;
        //            if (lastNavigatedItem == null)
        //            {
        //                System.Diagnostics.Debug.WriteLine("Lost previously navigated item. Control name: RibbonPopupMenu;");
        //                return;
        //            }
        //            lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, false);
        //            this.ClearValue(RibbonPopupMenu.LastNavigatedItemProperty);
        //            if (lastNavigatedItem.Parent == null || !(lastNavigatedItem.Parent is RibbonWrapPanel))
        //            {
        //                return;
        //            }
        //            RibbonWrapPanel panel = lastNavigatedItem.Parent as RibbonWrapPanel;
        //            this.NavigatedItemIndex += panel.WrapBy;
        //            if (this.NavigatedItemIndex >= panel.Children.Count)
        //            {
        //                this.NavigatedCollectionIndex++;
        //                if (this.NavigatedCollectionIndex >= this.ExpanderItems.Count)
        //                {
        //                    if (this.Items.Count == 0)
        //                    {
        //                        this.ExpanderItemsPanel.SetVerticalOffset(this.ExpanderItemsPanel.VerticalOffset + this.ExpanderItemsPanel.ViewportHeight); ;
        //                    }
        //                    else
        //                    {
        //                        this.navigaionHeight = 0;
        //                        lastNavigatedItem = this.Items[0];
        //                        lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //                        this.NavigatedItemIndex = 0;
        //                        this.NavigatedCollectionIndex = 0;
        //                        this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);

        //                    }
        //                }
        //                else
        //                {
        //                    RibbonHeaderedExpander exp = this.ExpanderItems[this.NavigatedCollectionIndex];
        //                    this.NavigatedItemIndex = 0;
        //                    this.navigaionHeight += 20;
        //                    lastNavigatedItem = exp.Children[0];
        //                    lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //                    this.navigaionHeight += lastNavigatedItem.DesiredSize.Height;
        //                    this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //                    if ((bool)exp._toggle.IsChecked)
        //                    {
        //                        exp._toggle.IsChecked = false;
        //                    }
        //                    if (this.navigaionHeight > this.ExpanderItemsPanel.ViewportHeight)
        //                    {
        //                        this.ExpanderItemsPanel.SetVerticalOffset(this.navigaionHeight - this.ExpanderItemsPanel.ViewportHeight + 15);
        //                    }
        //                }
        //            }
        //            else
        //            {
        //                lastNavigatedItem = panel.Children[this.NavigatedItemIndex] as Controls.Primitives.ButtonBase;
        //                lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //                this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //                this.navigaionHeight += lastNavigatedItem.DesiredSize.Height;
        //                if (this.navigaionHeight > this.ExpanderItemsPanel.ViewportHeight)
        //                {
        //                    this.ExpanderItemsPanel.SetVerticalOffset(this.navigaionHeight - this.ExpanderItemsPanel.ViewportHeight + 15);
        //                }
        //            }
        //        }
        //        e.Handled = true;
        //    }
        //    else if (e.Key == System.Windows.Input.Key.Right)
        //    {
        //        RibbonHeaderedExpander exp = this.ExpanderItems[this.NavigatedCollectionIndex];
        //        this.NavigatedItemIndex++;
        //        this.NavigatedItemIndex %= exp.Children.Count;
        //        Controls.Primitives.ButtonBase item = this.GetValue(RibbonPopupMenu.LastNavigatedItemProperty) as Controls.Primitives.ButtonBase;
        //        if (item != null)
        //        {
        //            item.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, false);
        //        }
        //        item = exp.Children[this.NavigatedItemIndex];
        //        item.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //        this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, item);
        //    }
        //    else if (e.Key == System.Windows.Input.Key.Left)
        //    {
        //        RibbonHeaderedExpander exp = this.ExpanderItems[this.NavigatedCollectionIndex];
        //        this.NavigatedItemIndex--;
        //        if (this.NavigatedItemIndex < 0)
        //        {
        //            this.NavigatedItemIndex = exp.Children.Count - 1;
        //        }
        //        Controls.Primitives.ButtonBase item = this.GetValue(RibbonPopupMenu.LastNavigatedItemProperty) as Controls.Primitives.ButtonBase;
        //        if (item != null)
        //        {
        //            item.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, false);
        //        }
        //        item = exp.Children[this.NavigatedItemIndex];
        //        item.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //        this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, item);
        //    }
        //    else if (e.Key == System.Windows.Input.Key.Up)
        //    {
        //        Controls.Primitives.ButtonBase lastNavigatedItem = this.GetValue(RibbonPopupMenu.LastNavigatedItemProperty) as Controls.Primitives.ButtonBase;
        //        this.ClearValue(RibbonPopupMenu.LastNavigatedItemProperty);
        //        if (lastNavigatedItem == null)
        //        {
        //            if (this.Items.Count > 0)
        //            {
        //                lastNavigatedItem = this.Items[this.Items.Count - 1];
        //                this.NavigatedItemIndex = this.Items.Count - 1;
        //            }
        //            else
        //            {
        //                if (this.ExpanderItems.Count > 0)
        //                {
        //                    this.NavigatedCollectionIndex = this.ExpanderItems.Count - 1;
        //                    this.NavigatedItemIndex = this.ExpanderItems[this.NavigatedCollectionIndex].Children.Count - 1;
        //                }
        //                else
        //                {
        //                    return;
        //                }
        //            }
        //        }
        //        if (lastNavigatedItem == null) 
        //        {
        //            return;
        //        }
        //        lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, false);
        //        if (lastNavigatedItem is RibbonPopupMenuItem)
        //        {
        //            this.NavigatedItemIndex--;
        //            if (this.NavigatedItemIndex < 0)
        //            {
        //                if (this.ExpanderItems.Count > 0)
        //                {
        //                    this.NavigatedCollectionIndex = this.ExpanderItems.Count - 1;
        //                    this.NavigatedItemIndex = this.ExpanderItems[this.NavigatedCollectionIndex].Children.Count - 1;
        //                    RibbonHeaderedExpander exp = this.ExpanderItems[this.NavigatedCollectionIndex];
        //                    lastNavigatedItem = exp.Children[exp.Children.Count - 1];
        //                    this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //                    lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //                }
        //            }

        //        }
        //        else
        //        {
        //            RibbonWrapPanel panel = lastNavigatedItem.Parent as RibbonWrapPanel;
        //            this.NavigatedItemIndex -= panel.WrapBy;
        //            if (this.NavigatedItemIndex < 0)
        //            {
        //                this.NavigatedCollectionIndex--;
        //                if (this.NavigatedCollectionIndex < 0)
        //                {
        //                    this.NavigatedCollectionIndex = 0;
        //                }
        //                this.NavigatedItemIndex = this.ExpanderItems[this.NavigatedCollectionIndex].Children.Count - 1;
        //            }
        //            RibbonHeaderedExpander exp = this.ExpanderItems[this.NavigatedCollectionIndex];
        //            lastNavigatedItem = exp.Children[this.NavigatedItemIndex];
        //            lastNavigatedItem.SetValue(Controls.Primitives.ButtonBase.IsHighlightedProperty, true);
        //            this.SetValue(RibbonPopupMenu.LastNavigatedItemProperty, lastNavigatedItem);
        //        }

        //    }
        //    else
        //    {
        //        if (this.Tag != null && this.Tag is RibbonToggleButton)
        //        {
        //            RibbonToggleButton toggle = this.Tag as RibbonToggleButton;
        //            toggle.IsChecked = false;
        //        }
        //    }
        //    e.Handled = true;
        //}
       
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this.Panel = this.GetTemplateChild(PART_Panel) as RibbonStackPanel;
            System.ComponentModel.DependencyPropertyDescriptor desc = System.ComponentModel.DependencyPropertyDescriptor.FromProperty(RibbonStackPanel.MeasuredProperty, typeof(RibbonStackPanel));
            desc.AddValueChanged(this.Panel, new System.EventHandler(this.OnMeasuredPropertyChanged));
            if (this.Panel != null)
            {
                foreach (RibbonPopupMenuItem item in this.Items)
                {
                    this.Panel.Children.Add(item);
                }
               
            }
            /**/
            this.Items.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(this.Items_CollectionChanged);
            /**/
            this.ScrollViewer = this.GetTemplateChild(PART_ScollViewer) as RibbonScrollViewer;
            /**/
            this.ExpanderItemsPanel = this.GetTemplateChild(PART_ExpanderItemsPanel) as RibbonStackPanel;
            /**/
            if (this.ExpanderItemsPanel != null) 
            {
                foreach (RibbonHeaderedExpander item in this.ExpanderItems)
                {
                    this.ExpanderItemsPanel.Children.Add(item);
                }
                desc = System.ComponentModel.DependencyPropertyDescriptor.FromProperty(RibbonStackPanel.MeasuredProperty, typeof(RibbonStackPanel));
                desc.AddValueChanged(this.ExpanderItemsPanel, new System.EventHandler(this.OnMeasuredPropertyChanged));
            }
            /**/
            this.SetValue(RibbonPopupMenu.HasExpanderItemsPropertyKey, this.ExpanderItems.Count > 0 ? true : false);
            /**/
            this.ExpanderItems.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(this.ExpanderItems_CollectionChanged);
            if (this._Thumb != null) 
            {
                this._Thumb.DragDelta -= new Controls.Primitives.DragDeltaEventHandler(this.Thumb_DragDelta);
            }
            /**/
            this._Thumb = (Masterpiece.Controls.Primitives.Thumb)this.GetTemplateChild(PART_Thumb);
            /**/
            this._Grid = (System.Windows.Controls.Grid)this.GetTemplateChild(PART_Grid);
            /**/
            if (this._Thumb != null && this._Grid != null)
            {
                this._Thumb.DragDelta += new Controls.Primitives.DragDeltaEventHandler(this.Thumb_DragDelta);
                this._Thumb.DragCompeted += new Controls.Primitives.DragCompletedEventHandler(this.ThumbDragCompleted);
            }
        }

        #endregion

        #region Private Utilities

        private double CalculateScrollHeight(double thumbHeight) 
        {
            double height = this.DropDownHeight, h = 0;
            foreach (RibbonPopupMenuItem item in this.Panel.Children)
            {
                h += item.DesiredSize.Height + 0.7;
            }
            
            height = height - h;
            
            return height - thumbHeight > 0 ? height - thumbHeight : 0.0;
        }

        private void SetHeight(double thumbHeight=7) 
        {
            if (this._Grid != null)
            {
                this._Grid.SetValue(System.Windows.Controls.Grid.HeightProperty, !this.CanResize ? System.Double.NaN : this.DropDownHeight);
                double height = this.CanResize ? this.CalculateScrollHeight(thumbHeight) : System.Double.NaN;
                this.ScrollViewer.SetValue(RibbonScrollViewer.HeightProperty, height);
            }
        }

        private void SetGridHeight(bool value) 
        {
            if (this._Grid != null)
            {
                if (value)
                {
                    this._Grid.Height = this.DropDownHeight;
                }
                else
                {
                    this._Grid.Height = System.Double.NaN;
                }
            }
        }
        #endregion

        #region Event Handlers
        private void ThumbDragCompleted(object sender, Controls.Primitives.DragCompletedEventArgs e) 
        {
            //if (e.Canceled)
            //{
            //    System.Console.WriteLine(this.VisualParent);
            //    if (this.Parent != null)
            //    {
            //        if (this.Parent is RibbonToggleButton || this.Parent is RibbonSplitButton)
            //        {
            //            System.Windows.Input.Mouse.Capture(this, System.Windows.Input.CaptureMode.SubTree);
            //            if (this.IsMouseCaptured)
            //            {
            //                this.IsDropDownOpen = true;
            //            }
            //        }
            //    }
            //}
        }

        private void OnMeasuredPropertyChanged(object sender, System.EventArgs e) 
        {
            bool bothMeasured = false;
            if (sender == this.Panel) 
            {
                if (!firstPanel) 
                {
                    firstPanel = true;
                }
                bothMeasured = firstPanel && secondPanel;
            }
            else if (sender == this.ExpanderItemsPanel) 
            {
                if (!secondPanel)
                {
                    secondPanel = true;
                }
                bothMeasured = firstPanel && secondPanel;
            }

            if (bothMeasured) 
            {
                if (this._Grid != null) 
                {
                    if (this.CanResize)
                    {
                        this.SetHeight();
                    }
                    else 
                    {
                        this.SetHeight(0);
                    }
                }
            }
        }

        private void Thumb_DragDelta(object sender, Masterpiece.Controls.Primitives.DragDeltaEventArgs e) 
        {
            double height = this._Grid.Height;
            height += e.VerticalChange;
            double s = this.ScrollViewer.Height;
            s += e.VerticalChange;
            if (height >= this._Grid.MinHeight + 2 && s >= this._Grid.MinHeight + 2&&height<=this.MaxDropDownHeight)
            {
                this._Grid.SetValue(System.Windows.Controls.Grid.HeightProperty, height);
               // this._Grid.CoerceValue(System.Windows.Controls.Grid.HeightProperty);
                this.ScrollViewer.SetValue(RibbonScrollViewer.HeightProperty, s);
            }
            else
            {
                ((Controls.Primitives.Thumb)sender).CancelDrag();
            }
        }

        private void Items_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) 
        {
            switch (e.Action)
            {
                case System.Collections.Specialized.NotifyCollectionChangedAction.Add:
                    foreach (var item in e.NewItems)
                    {
                        this.Panel.Children.Add(item as System.Windows.UIElement);
                    }
                    break;
                case System.Collections.Specialized.NotifyCollectionChangedAction.Remove:
                    foreach (var item in e.OldItems)
                    {
                        this.Panel.Children.Remove(item as System.Windows.UIElement);
                    }
                    break;
            }
        }
     
        private void ExpanderItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            switch (e.Action)
            {
                case System.Collections.Specialized.NotifyCollectionChangedAction.Add:
                    foreach (var item in e.NewItems)
                    {
                        this.ExpanderItemsPanel.Children.Add(item as RibbonHeaderedExpander);
                    }
                    break;
                case System.Collections.Specialized.NotifyCollectionChangedAction.Remove:
                    foreach (var item in e.OldItems)
                    {
                        this.ExpanderItemsPanel.Children.Remove(item as RibbonHeaderedExpander);
                    }
                    break;
            }
            this.SetValue(RibbonPopupMenu.HasExpanderItemsPropertyKey, this.ExpanderItems.Count > 0 ? true : false);
        }

        #endregion

        #region Fields
        private const string PART_Panel = "PART_Panel";
        private const string PART_ExpanderItemsPanel = "PART_HeaderedItemsPanel";
        private const string PART_ScollViewer = "PART_ScollViewer";
        private const string PART_Thumb = "PART_Thumb";
        private const string PART_Grid = "PART_Grid";
        internal RibbonStackPanel Panel, ExpanderItemsPanel;
        private RibbonScrollViewer ScrollViewer;
        private Masterpiece.Controls.Primitives.Thumb _Thumb;
        internal System.Windows.Controls.Grid _Grid;
        private bool firstPanel = false, secondPanel = false;
        internal int NavigatedCollectionIndex = -1;
        internal int NavigatedItemIndex = -1;
        internal double navigaionHeight = 0;
        #endregion

        #region IRibbonControl Implementation
        public bool IsLarge
        {
            get { return true; }
        }

        public Interfaces.IRibbonControl Clone()
        {
            throw new System.NotImplementedException();
        }

        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
    }
}
