﻿
namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.Markup.ContentProperty("RibbonPopupMenu")]
    public sealed class RibbonPopupMenuItem : Controls.Primitives.ButtonBase, Interfaces.IRibbonControl
    {

       #region Constructors
       static RibbonPopupMenuItem()
       {
           DefaultStyleKeyProperty.OverrideMetadata
               (
               typeof(RibbonPopupMenuItem),
               new System.Windows.FrameworkPropertyMetadata(typeof(RibbonPopupMenuItem))
               );

           
       }

        #endregion

       #region Properties and Depenency Properties

       public bool IsSelected
       {
           get { return (bool)GetValue(IsSelectedProperty); }
           set { SetValue(IsSelectedProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsSelected.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty IsSelectedProperty =
           System.Windows.DependencyProperty.Register("IsSelected", typeof(bool), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata(false));
       public System.Windows.Media.ImageSource SmallImage
       {
           get { return (System.Windows.Media.ImageSource)GetValue(SmallImageProperty); }
           set { SetValue(SmallImageProperty, value); }
       }

       // Using a DependencyProperty as the backing store for SmallImage.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty SmallImageProperty =
           System.Windows.DependencyProperty.Register("SmallImage", typeof(System.Windows.Media.ImageSource), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata(null));

       public string Title
       {
           get { return (string)GetValue(TitleProperty); }
           set { SetValue(TitleProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty TitleProperty =
           System.Windows.DependencyProperty.Register("Title", typeof(string), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata(null));

       [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(false)]
       public RibbonPopupMenu RibbonPopupMenu
       {
           get { return (RibbonPopupMenu)GetValue(RibbonPopupMenuProperty); }
           set { SetValue(RibbonPopupMenuProperty, value); }
       }

       // Using a DependencyProperty as the backing store for RibbonPopupMenu.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty RibbonPopupMenuProperty =
           System.Windows.DependencyProperty.Register("RibbonPopupMenu", typeof(RibbonPopupMenu), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata((Ribbon2010.RibbonPopupMenu)null, new System.Windows.PropertyChangedCallback(RibbonPopupMenuItem.OnRibbonPopupMenuPropertyChanged)));
       internal bool IsAssociatedWithQAItem
       {
           get { return (bool)GetValue(IsAssociatedWithQAItemProperty); }
           set { SetValue(IsAssociatedWithQAItemProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsAssociatedWithQAItem.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyProperty IsAssociatedWithQAItemProperty =
           System.Windows.DependencyProperty.Register("IsAssociatedWithQAItem", typeof(bool), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata(false));

       internal bool CommandItemEnabledInQA
       {
           get { return (bool)GetValue(CommandItemEnabledInQAProperty); }
           set { SetValue(CommandItemEnabledInQAProperty, value); }
       }

       // Using a DependencyProperty as the backing store for CommandItemEnabledInQA.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyProperty CommandItemEnabledInQAProperty =
           System.Windows.DependencyProperty.Register("CommandItemEnabledInQA", typeof(bool), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata(false));



       internal QACommandItem AssociatedQACommandItem
       {
           get { return (QACommandItem)GetValue(AssociatedQACommandItemProperty); }
           set { SetValue(AssociatedQACommandItemProperty, value); }
       }

       // Using a DependencyProperty as the backing store for AssociatedQACommandItem.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyProperty AssociatedQACommandItemProperty =
           System.Windows.DependencyProperty.Register("AssociatedQACommandItem", typeof(QACommandItem), typeof(RibbonPopupMenuItem), new System.Windows.PropertyMetadata((QACommandItem)null, new System.Windows.PropertyChangedCallback(RibbonPopupMenuItem.OnAssociatedQACommandItemPropertyChanged)));

       public bool IsDropDownOpen
       {
           get { return (bool)GetValue(IsDropDownOpenProperty); }
           set { SetValue(IsDropDownOpenProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsDropDownOpen.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty IsDropDownOpenProperty =
           System.Windows.DependencyProperty.Register("IsDropDownOpen", typeof(bool), typeof(RibbonPopupMenuItem), new System.Windows.FrameworkPropertyMetadata(
               false, 
               System.Windows.FrameworkPropertyMetadataOptions.BindsTwoWayByDefault| System.Windows.FrameworkPropertyMetadataOptions.Journal,
               new System.Windows.PropertyChangedCallback(RibbonPopupMenuItem.OnIsDropDownOpenPropertyChanged)));
       
       #endregion

       #region Depenency Property Changed Callbacks

       private static void OnIsDropDownOpenPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           RibbonPopupMenuItem menuItem = (RibbonPopupMenuItem)d;
           bool newValue = (bool)e.NewValue;
           if (newValue) 
           {
               Common.PopupService.RaiseMenuDropDownOpenedEvent(menuItem);
           }
       }

       private static void OnRibbonPopupMenuPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           RibbonPopupMenuItem menuItem=(RibbonPopupMenuItem)d;
           if (e.NewValue != null)
           {
               menuItem.Popup = Common.PopupService.PopupBuilder(e.NewValue as System.Windows.FrameworkElement);
               menuItem.Popup.Placement = System.Windows.Controls.Primitives.PlacementMode.Right;
               menuItem.Popup.PlacementTarget = menuItem;
               System.Windows.Data.BindingOperations.SetBinding
                   (
                    menuItem.Popup,
                    System.Windows.Controls.Primitives.Popup.IsOpenProperty,
                    new System.Windows.Data.Binding("IsDropDownOpen") {Source=menuItem }
                   );

               menuItem.Popup.Opened += new System.EventHandler(menuItem.DropDownOpened);
              // menuItem.Popup.Closed += new System.EventHandler(menuItem.DropDownClosed);
           }
       }

       private static void OnAssociatedQACommandItemPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           QACommandItem newValue = (QACommandItem)e.NewValue, oldValue = (QACommandItem)e.OldValue;
           RibbonPopupMenuItem menuItem = (RibbonPopupMenuItem)d;
           if (e.OldValue != null) 
           {
               RibbonControlCloningService.CommandItemRemovedEvent -= new System.EventHandler(menuItem.CommandItemRemovedEventRaised);
           }
           if (e.NewValue != null) 
           {
               RibbonControlCloningService.CommandItemRemovedEvent += new System.EventHandler(menuItem.CommandItemRemovedEventRaised);
           }
       }
       #endregion

       #region Overrides

       public override void OnApplyTemplate()
       {
           base.OnApplyTemplate();
           Common.PopupService.MenuDropDownOpenedEvent += new System.EventHandler(this.OnMenuDropDownOpened);
       }
       protected override void OnMouseEnter(System.Windows.Input.MouseEventArgs e)
       {
           base.OnMouseEnter(e);
           if (this.RibbonPopupMenu != null)
           {
               this.StartTimer();
           }

       }

       protected override void OnMouseLeave(System.Windows.Input.MouseEventArgs e)
       {
           base.OnMouseLeave(e);
           if (this.Popup != null && !this.Popup.IsMouseOver && this.IsDropDownOpen)
           {
               this.IsDropDownOpen = false;
           }
       }
     
       protected override void OnClick()
       {
           base.OnClick();
           if (this.RibbonPopupMenu == null)
           {
               Common.PopupService.RaisePopupDismissedEvent(this);
           }
           else 
           {
               if (!this.IsDropDownOpen) 
               {
                   this.IsDropDownOpen = true;
               }
           }
           RibbonQuickAccessToolbar toolbar = this.GetCurrentParentQA();
          
           if (this.IsAssociatedWithQAItem &&
               toolbar!=null &&
               this.AssociatedQACommandItem != null)
           {
               this.CommandItemEnabledInQA = !this.CommandItemEnabledInQA;
               this.AssociatedQACommandItem.VisibleOnStartup = this.CommandItemEnabledInQA;
               if (this.CommandItemEnabledInQA)
               {
                   toolbar.AddItemToPanel(this.AssociatedQACommandItem);
               }
               else
               {
                   if (this.AssociatedQACommandItem.ClonedChild != null) 
                   {
                       toolbar.RemoveItemFromPanel(this.AssociatedQACommandItem.ClonedChild);
                   }
               }
           }
       }
       
       #endregion

       #region Private Utilities
       private void StartTimer()
       {
           if (this.timer == null)
           {
               this.timer = new System.Windows.Threading.DispatcherTimer();
               this.timer.Tick += new System.EventHandler(this.OnTimeOut);
           }
           else if (this.timer.IsEnabled)
           {
               return;
           }
           this.timer.Interval = System.TimeSpan.FromMilliseconds(900);
           this.timer.Start();
       }

       private void StopTimer()
       {
           if (this.timer != null)
           {
               this.timer.Stop();
           }
       }
       #endregion

       #region Event Handlers

       private void OnMenuDropDownOpened(object sender, System.EventArgs e) 
       {
           if (sender != this && this.IsDropDownOpen) 
           {
               this.IsDropDownOpen = false;
           }
       }
       private void DropDownOpened(object sender, System.EventArgs e) 
       {
           this.StopTimer();
       }

       private void OnTimeOut(object sender, System.EventArgs e)
       {
           if (this.IsMouseOver)
           {
               if (!this.IsDropDownOpen)
               {
                   this.IsDropDownOpen = true;
               }
           }
       }
       private void CommandItemRemovedEventRaised(object sender, System.EventArgs e) 
       {
           if (this.AssociatedQACommandItem != null && sender == this.AssociatedQACommandItem) 
           {
               this.CommandItemEnabledInQA = false;
           }
       }

       private RibbonQuickAccessToolbar GetCurrentParentQA() 
       {
           RibbonQuickAccessToolbar toolbar = null;
           foreach (System.Windows.Window window in System.Windows.Application.Current.Windows)
           {
               if (window is RibbonWindow) 
               {
                   RibbonWindow rwin = window as RibbonWindow;
                   if (rwin.RibbonQuickAccessToolbar != null) 
                   {
                       if (rwin.QACommandItems.Contains(this.AssociatedQACommandItem)) 
                       {
                           toolbar = rwin.RibbonQuickAccessToolbar;
                           return toolbar;
                       }
                   }
               }
           }
           return toolbar;
       }
       #endregion

       #region Fields
       private System.Windows.Threading.DispatcherTimer timer;
       private System.Windows.Controls.Primitives.Popup Popup;
       #endregion

       public Interfaces.IRibbonControl Clone()
       {
           return null;
       }
       public bool IsLarge
       {
           get { return false; }
       }


       public bool IsClonedItem
       {
           get { return false; }
       }

       public bool IsCloneable
       {
           get { return false; }
       }


       public void DisposeControl()
       {
           
       }

       public Interfaces.IRibbonControl ParentControl
       {
           get { return null; }
       }

    }
}
