﻿
namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.Markup.ContentProperty("Children")]
    public class RibbonQuickAccessToolbar : System.Windows.Controls.Control, Interfaces.IRibbonControl
    {
        #region Constructors
        
        static RibbonQuickAccessToolbar() 
        {
            System.Type ownerType=typeof(RibbonQuickAccessToolbar);
            RibbonQuickAccessToolbar.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));
        }

        public RibbonQuickAccessToolbar() : base() 
        {
            this.Children = new RibbonControlCollection();
            this.CommandItems = new QACommanItemCollection();
        }
        #endregion

        #region Properties and Depenency Properties


        public RibbonControlCollection Children
        {
            get { return (RibbonControlCollection)GetValue(ChildrenProperty); }
            set { SetValue(ChildrenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Children.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ChildrenProperty =
            System.Windows.DependencyProperty.Register("Children", typeof(RibbonControlCollection), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata((RibbonQuickAccessToolbar)null));

        internal bool HasItems
        {
            get { return (bool)GetValue(HasItemsProperty); }
        }

        // Using a DependencyProperty as the backing store for HasItems.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyPropertyKey HasItemsPropertyKey =
            System.Windows.DependencyProperty.RegisterReadOnly("HasItems", typeof(bool), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata(false));

        internal static readonly System.Windows.DependencyProperty HasItemsProperty = RibbonQuickAccessToolbar.HasItemsPropertyKey.DependencyProperty;

        internal bool HasHiddenItems
        {
            get { return (bool)GetValue(HasHiddenItemsProperty); }
            private set { SetValue(HasHiddenItemsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HasHiddenItems.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty HasHiddenItemsProperty =
            System.Windows.DependencyProperty.Register("HasHiddenItems", typeof(bool), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata(false));
        
        internal bool IsDropDownOpen
        {
            get { return (bool)GetValue(IsDropDownOpenProperty); }
            set { SetValue(IsDropDownOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsDropDownOpen.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsDropDownOpenProperty =
            System.Windows.DependencyProperty.Register("IsDropDownOpen", typeof(bool), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata(false, new System.Windows.PropertyChangedCallback(RibbonQuickAccessToolbar.OnIsDropDownOpenPropertyChanged)));

        internal bool IsHiddenDropDownOpen
        {
            get { return (bool)GetValue(IsHiddenDropDownOpenProperty); }
            set { SetValue(IsHiddenDropDownOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsHiddenDropDownOpen.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsHiddenDropDownOpenProperty =
            System.Windows.DependencyProperty.Register("IsHiddenDropDownOpen", typeof(bool), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata(false, new System.Windows.PropertyChangedCallback(RibbonQuickAccessToolbar.OnIsHiddenDropDownOpenPropertyChanged)));

        public QACommanItemCollection CommandItems
        {
            get { return (QACommanItemCollection)GetValue(CommandItemsProperty); }
            set { SetValue(CommandItemsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CommandItems.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty CommandItemsProperty =
            System.Windows.DependencyProperty.Register("CommandItems", typeof(QACommanItemCollection), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata(null));

        public string CustomizeQAHeader
        {
            get { return (string)GetValue(CustomizeQAHeaderProperty); }
            set { SetValue(CustomizeQAHeaderProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CustomizeQAHeader.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty CustomizeQAHeaderProperty =
            System.Windows.DependencyProperty.Register("CustomizeQAHeader", typeof(string), typeof(RibbonQuickAccessToolbar), new System.Windows.PropertyMetadata((string)null));
        #endregion

        #region Depenency Property Changed Callbacks

        private static void OnIsDropDownOpenPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonQuickAccessToolbar QA = (RibbonQuickAccessToolbar)d;
            bool newValue = (bool)e.NewValue;
            QA.SetPopupIsOpenProerty(newValue, false);
        }

        private static void OnIsHiddenDropDownOpenPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            RibbonQuickAccessToolbar QA = (RibbonQuickAccessToolbar)d;
            bool newValue = (bool)e.NewValue;
            QA.SetPopupIsOpenProerty(newValue, true);
        }

        private static void OnChildrenPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
        
        }
        private static object CoerceChildrenProperty(System.Windows.DependencyObject o, System.Object value) 
        {
            return value is RibbonControlCollection ? value : null;
        }

        #endregion

        #region Overrides

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            this.Panel = this.GetTemplateChild(PART_Panel) as System.Windows.Controls.StackPanel;
           
            if (this.Panel != null) 
            {
                foreach (System.Windows.FrameworkElement item in this.Children)
                {
                    this.Panel.Children.Add(item);
                }
                this.Children.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(this.Children_CollectionChanged);
            }
           
            this.HiddenItemsPanel = this.GetTemplateChild("PART_HiddenItemsPanel") as System.Windows.Controls.StackPanel;
            
            this.HiddenPopup = this.GetTemplateChild("PART_HiddenPopup") as System.Windows.Controls.Primitives.Popup;
           
            if (this.HiddenPopup != null) 
            {
                this.HiddenPopup.Closed += new System.EventHandler(this.PopupDissmissedEventRaised);
            }
            
            this.CommandItems.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(this.CommandItems_CollectionChanged);
            
            this.RibbonPopupMenu = new RibbonPopupMenu() { CanResize = false, DropDownHeight=System.Double.NaN };
            
            this.SetBindings(this.RibbonPopupMenu);
           
            if (this.CommandItems.Count > 0) 
            {
                foreach (QACommandItem item in this.CommandItems)
                {
                    this.RibbonPopupMenu.Items.Add(new RibbonPopupMenuItem() { Title = item.Title, AssociatedQACommandItem = item, IsAssociatedWithQAItem = true, CommandItemEnabledInQA = item.VisibleOnStartup });
                }
            }
            this.ArrowedToggle = this.GetTemplateChild("PART_QAArrowedToggle") as Controls.Primitives.ToggleButton;
            
            this.ArrowedToggle_1 = this.GetTemplateChild("PART_QAArrowedToggle_1") as Controls.Primitives.ToggleButton;
            
            if (this.ArrowedToggle != null)
            {
                this.Popup = Common.PopupService.PopupBuilder(this.RibbonPopupMenu);
                this.Popup.PlacementTarget = this.ArrowedToggle;
                this.Popup.Closed += new System.EventHandler(this.PopupDissmissedEventRaised);
            }
            this.HiddenToggle = this.GetTemplateChild("PART_HiddenToggle") as Controls.Primitives.ToggleButton;
           
            this.HiddenToggle.IsVisibleChanged += new System.Windows.DependencyPropertyChangedEventHandler(this.HiddenToggleIsVisibleChanged);
            
            Common.PopupService.PopupDismissedEvent += new System.EventHandler(this.PopupDissmissedEventRaised);
        }
        #endregion

        #region Private Utilities

        private void SetBindings(RibbonPopupMenu popupMenu) 
        {
            System.Windows.Data.BindingOperations.SetBinding
                (
                    popupMenu,
                    Ribbon2010.RibbonPopupMenu.HeaderProperty,
                    new System.Windows.Data.Binding("CustomizeQAHeader") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                );
        }
      
        private void SetPopupIsOpenProerty(bool value, bool isHiddenPopup=true) 
        {
            if (isHiddenPopup)
            {
                if (this.HiddenPopup != null)
                {
                    this.HiddenPopup.IsOpen = value;
                }
            }
            else 
            {
                if (this.Popup != null) 
                {
                    this.Popup.IsOpen = value;
                }
            }
        }

        internal void AddToHiddenPanel() 
        {
            if (this.Panel != null && this.HiddenItemsPanel != null) 
            {
                if (this.Panel.Children.Count > 0) 
                {
                    System.Windows.UIElement control = this.Panel.Children[this.Panel.Children.Count - 1] as System.Windows.UIElement;
                    if (control != null) 
                    {
                        this.Panel.Children.Remove(control);
                        this.HiddenItemsPanel.Children.Insert(0, control);
                    }
                }
                this.SetValue(RibbonQuickAccessToolbar.HasHiddenItemsProperty, this.HiddenItemsPanel.Children.Count>0);
            }
        }

        internal void RemoveFromHiddenPanel() 
        {
            if (this.Panel != null && this.HiddenItemsPanel != null)
            {
                if (this.HiddenItemsPanel.Children.Count > 0)
                {
                    System.Windows.UIElement control = this.HiddenItemsPanel.Children[this.HiddenItemsPanel.Children.Count - 1] as System.Windows.UIElement;
                    if (control != null)
                    {
                        this.HiddenItemsPanel.Children.Remove(control);
                        this.Panel.Children.Add(control);
                    }
                }
                this.SetValue(RibbonQuickAccessToolbar.HasHiddenItemsProperty, this.HiddenItemsPanel.Children.Count > 0);
            }
        }

        internal double GetLastItemWidth() 
        {
            if (this.HiddenItemsPanel == null || this.HiddenItemsPanel.Children.Count == 0) 
            {
                return 0.0D;
            }

            System.Windows.UIElement elt = this.HiddenItemsPanel.Children[this.HiddenItemsPanel.Children.Count - 1];
            
            return elt.DesiredSize.Width;
        }

        internal bool CanExpand 
        {
            get { return this.HiddenItemsPanel != null && this.HiddenItemsPanel.Children.Count > 0; }
        }

        internal void RemoveItemFromPanel(Interfaces.IRibbonControl control) 
        {
            if (control is RibbonGroup)
            {
                RibbonGroup group = control as RibbonGroup;

                group.Size = RibbonControlSize.Large;
                int? index = group.Tag as int?;
                bool exceptionThrown = true;
                if (index.HasValue)
                {
                    try
                    {
                        Common.PopupService.RibbonBar.SelectedItem.ItemsCollection.Insert(index.Value, group);
                        exceptionThrown = false;
                    }
                    catch
                    {
                        System.Diagnostics.Debug.WriteLine("Couldn't add RibbonGroup at specified index.");
                    }
                }
                if (exceptionThrown)
                {
                    Common.PopupService.RibbonBar.SelectedItem.ItemsCollection.Add(group);
                }
            }
            System.Windows.UIElement elt = control as System.Windows.UIElement;
            if (elt != null&&this.Panel!=null) 
            {
                if (this.Panel.Children.Contains(elt))
                {
                    this.Panel.Children.Remove(elt);
                }
                else if (this.HiddenItemsPanel != null && this.HiddenItemsPanel.Children.Contains(elt)) 
                {
                    this.HiddenItemsPanel.Children.Remove(elt);
                    this.SetValue(RibbonQuickAccessToolbar.HasHiddenItemsProperty, this.HiddenItemsPanel.Children.Count > 0);
                }
            }
            if (control.ParentControl != null)
            {
                control.ParentControl.DisposeControl();
                if (control.ParentControl is QACommandItem) 
                {
                    RibbonControlCloningService.RaiseCommandItemRemovedEvent(control.ParentControl);
                }
            }
            this.Panel.InvalidateMeasure();
        }

        internal void AddItemToPanel(Interfaces.IRibbonControl control) 
        {
            if (this.Children != null)
            {
                Interfaces.IRibbonControl clonedItem = control.Clone();
                this.Children.Add(clonedItem);
                
            }
        }

        internal void AddRange(System.Collections.Generic.IEnumerable<int> items) 
        {
            System.Collections.Generic.IEnumerable<Interfaces.IRibbonControl> controls = RibbonControlCloningService.GetItems(items);
            
            this.AddRange(controls);
        }

        internal void AddRange(System.Collections.Generic.IEnumerable<Interfaces.IRibbonControl> controls) 
        {
            if (controls != null) 
            {
                foreach (Interfaces.IRibbonControl control in controls)
                {
                    this.AddItemToPanel(control);
                }
            }
        }

        internal void ClearItems() 
        {
            if (this.Panel == null) 
            {
                return;
            }
            System.Collections.Generic.List<Interfaces.IRibbonControl> controls = new System.Collections.Generic.List<Interfaces.IRibbonControl>();
            foreach (System.Windows.UIElement item in this.Panel.Children)
            {
                Interfaces.IRibbonControl control = item as Interfaces.IRibbonControl;
                if (control != null) 
                {
                    controls.Add(control);
                }
            }

            for (int i = 0; i < controls.Count; i++)
            {
                Interfaces.IRibbonControl control = controls[i];
                this.RemoveItemFromPanel(control);
            }
        }

        internal bool CanShorten 
        {
            get 
            {
                return this.Panel != null && this.Panel.Children.Count > 1;
            }
        }
        #endregion

        #region Event Handlers

        private void HiddenToggleIsVisibleChanged(object sender, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            bool newValue = (bool)e.NewValue;
            if (newValue && this.ArrowedToggle_1!=null)
            {
                this.Popup.PlacementTarget = this.ArrowedToggle_1;
            }
            else if(this.ArrowedToggle!=null)
            {
                this.Popup.PlacementTarget = this.ArrowedToggle;
            }
        }
        private void PopupDissmissedEventRaised(object sender, System.EventArgs e) 
        {
            if (this.IsDropDownOpen) 
            {
                this.IsDropDownOpen = false;
            }
            if (this.IsHiddenDropDownOpen) 
            {
                this.IsHiddenDropDownOpen = false;
            }
        }
        private void Children_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) 
        {
            System.Windows.UIElement ui;
            switch (e.Action)
            {
                case System.Collections.Specialized.NotifyCollectionChangedAction.Add:
                    foreach (Interfaces.IRibbonControl item in e.NewItems)
                    {
                        ui = item as System.Windows.UIElement;
                        if (ui != null)
                        {
                            this.Panel.Children.Add(ui);
                            if (this.Panel.Children.Count == 1)
                            {
                                ui.Measure(this.infiniteSize);
                                double width = ui.IsMeasureValid ? ui.DesiredSize.Width : 0.0D;
                                this.SetValue(RibbonQuickAccessToolbar.MinWidthProperty, width + 26);
                            }
                        }
                    }
                    break;
                case System.Collections.Specialized.NotifyCollectionChangedAction.Remove:
                    foreach (Interfaces.IRibbonControl item in e.OldItems)
                    {
                        ui = item as System.Windows.UIElement;
                        if (ui != null)
                        {
                            this.Panel.Children.Remove(ui);
                        }
                    }
                    break;
            }
        }

        private void CommandItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) 
        {
        
        }
        #endregion

        #region Fields
        private const string PART_Panel = "PART_Panel";
        internal System.Windows.Controls.StackPanel Panel, HiddenItemsPanel;
        private System.Windows.Controls.Primitives.Popup HiddenPopup, Popup;
        private System.Windows.Size infiniteSize = new System.Windows.Size(System.Double.PositiveInfinity, System.Double.PositiveInfinity);
        private RibbonPopupMenu RibbonPopupMenu;
        private Controls.Primitives.ToggleButton ArrowedToggle, ArrowedToggle_1, HiddenToggle;
        #endregion

        #region Events
        #endregion

        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            return null;
        }


        public bool IsLarge
        {
            get { return true; }
        }


        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
            
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
    }
}
