﻿

namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.TemplatePart(Name = PART_ThirdButton, Type = typeof(Controls.Button))]
    public class RibbonScrollViewer : System.Windows.Controls.ScrollViewer, Interfaces.IRibbonControl
    {
      
       #region Constructors
       static RibbonScrollViewer()
       {
           System.Type ownerType = typeof(RibbonScrollViewer);
           RibbonScrollViewer.DefaultStyleKeyProperty.OverrideMetadata(ownerType,
               new System.Windows.FrameworkPropertyMetadata(ownerType));
         //  RibbonScrollViewer.VerticalScrollBarVisibilityProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(new System.Windows.PropertyChangedCallback(RibbonScrollViewer.OnVerticalScrollBarVisibilityPropertyChanged)));
       }

       #endregion

       #region Properties and Depenency Properties

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Appearance"), System.ComponentModel.ReadOnly(false)]
       public bool SidedScroller
       {
           get { return (bool)GetValue(SidedScrollerProperty); }
           set { SetValue(SidedScrollerProperty, value); }
       }

       // Using a DependencyProperty as the backing store for SidedScroller.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty SidedScrollerProperty =
           System.Windows.DependencyProperty.Register("SidedScroller", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(false));

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Appearance"), System.ComponentModel.ReadOnly(false)]
       public bool IsWindowContentScroller
       {
           get { return (bool)GetValue(IsWindowContentScrollerProperty); }
           set { SetValue(IsWindowContentScrollerProperty, value); }
       }

       // Using a DependencyProperty as the backing store for IsWindowContentScroller.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty IsWindowContentScrollerProperty =
           System.Windows.DependencyProperty.Register("IsWindowContentScroller", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(false));

       public RibbonGallery Gallery { get; set; }
       internal System.Windows.Controls.Primitives.Popup Popup { get; set; }

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Behavior"), System.ComponentModel.ReadOnly(true)]
       public bool CanLineUp
       {
           get { return (bool)GetValue(CanLineUpProperty); }
       }

       // Using a DependencyProperty as the backing store for CanLineUp.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyPropertyKey CanLineUpPropertyKey =
           System.Windows.DependencyProperty.RegisterReadOnly("CanLineUp", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(false));

       public static readonly System.Windows.DependencyProperty CanLineUpProperty = CanLineUpPropertyKey.DependencyProperty;

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Behavior"), System.ComponentModel.ReadOnly(true)]
       public bool CanLineDown
       {
           get { return (bool)GetValue(CanLineDownProperty); }
       }

       // Using a DependencyProperty as the backing store for LineDownEnabled.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyPropertyKey CanLineDownPropertyKey =
           System.Windows.DependencyProperty.RegisterReadOnly("CanLineDown", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(false));

       public static readonly System.Windows.DependencyProperty CanLineDownProperty = CanLineDownPropertyKey.DependencyProperty;

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Behavior"), System.ComponentModel.ReadOnly(true)]
       public bool CanLineLeft
       {
           get { return (bool)GetValue(CanLineLeftProperty); }
       }

       // Using a DependencyProperty as the backing store for LineLeftEnabled.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyPropertyKey CanLineLeftPropertyKey =
           System.Windows.DependencyProperty.RegisterReadOnly("CanLineLeft", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(false));

       internal static readonly System.Windows.DependencyProperty CanLineLeftProperty = CanLineDownPropertyKey.DependencyProperty;

       [System.ComponentModel.Bindable(true), System.ComponentModel.Category("Behavior"), System.ComponentModel.ReadOnly(true)]
       public bool CanLineRight
       {
           get { return (bool)GetValue(CanLineRightProperty); }
       }

       // Using a DependencyProperty as the backing store for LineRightEnabled.  This enables animation, styling, binding, etc...
       internal static readonly System.Windows.DependencyPropertyKey CanLineRightPropertyKey =
           System.Windows.DependencyProperty.RegisterReadOnly("CanLineRight", typeof(bool), typeof(RibbonScrollViewer), new System.Windows.PropertyMetadata(true));

       internal static readonly System.Windows.DependencyProperty CanLineRightProperty = CanLineRightPropertyKey.DependencyProperty;
       
       #endregion

       #region Depenency Property Changed Callbacks

       private static void OnVerticalScrollBarVisibilityPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
       {
           System.Windows.Controls.ScrollBarVisibility newValue = (System.Windows.Controls.ScrollBarVisibility)e.NewValue;
           RibbonScrollViewer scrollViewer = (RibbonScrollViewer)d;
       }
       #endregion

       #region Overrides

       public override void OnApplyTemplate()
       {
           base.OnApplyTemplate();
           
           this.isTemplatedParenRibbonGallery = this.TemplatedParent != null && this.TemplatedParent is RibbonGallery;
           RibbonGallery gallery = null;
           if (this.button != null) 
           {
               if (this.isTemplatedParenRibbonGallery) 
               {
                   gallery = this.TemplatedParent as RibbonGallery;
                   gallery.DetachClickEventHandler();
               }
           }
           this.button = (Controls.Button)this.GetTemplateChild(PART_ThirdButton);
           if (this.button != null) 
           {
               if (isTemplatedParenRibbonGallery) 
               {
                   gallery = this.TemplatedParent as RibbonGallery;
                   gallery.OnScrollViewewInitialized();
               }
           }
           //if (this.button != null)
           //{
           //    if (this.Popup != null)
           //    {
           //        this.Popup.PlacementTarget = this.button;
           //        this.Popup.VerticalOffset = -65;
           //        this.button.Click+=new RoutedEventHandler(this.Button_Click);
           //    }
           //}
           this.IsVerticalScrollVisibilityAuto = this.VerticalScrollBarVisibility == System.Windows.Controls.ScrollBarVisibility.Auto;
           System.ComponentModel.DependencyPropertyDescriptor desc = System.ComponentModel.DependencyPropertyDescriptor.FromProperty
               (
                RibbonScrollViewer.ViewportHeightProperty,
                typeof(RibbonScrollViewer)
               );
           desc.AddValueChanged(this, new System.EventHandler(this.OnViewportHeightPropertyChanged));
       }
      
       #endregion

       #region Private Utilities
       
      
       #endregion

       #region Event Handlers

       private void OnViewportHeightPropertyChanged(object sender, System.EventArgs e) 
       {
           if (this.IsVerticalScrollVisibilityAuto)
           {
               if (this.ExtentHeight > this.ViewportHeight && !MS.Internal.DoubleUtil.AreClose(this.ExtentHeight, this.ViewportHeight))
               {
                   this.VerticalScrollBarVisibility = System.Windows.Controls.ScrollBarVisibility.Visible;
               }
               else if (this.ExtentHeight > 0)
               {
                   this.VerticalScrollBarVisibility = System.Windows.Controls.ScrollBarVisibility.Hidden;
               }
           }
       }

       #endregion

       #region Fields
       internal Controls.Button button;
       private const string PART_ThirdButton = "PART_ThirdButton";
       internal System.Windows.Controls.Primitives.Popup ParentPopup;
       internal Controls.Primitives.ButtonBase ParentUI;
       internal bool isTemplatedParenRibbonGallery=false;
       private bool IsVerticalScrollVisibilityAuto = false;
       #endregion

       public Interfaces.IRibbonControl Clone()
       {
           throw new System.NotImplementedException();
       }
       
       public bool IsLarge
       {
           get { return true; }
       }

       public bool IsClonedItem
       {
           get { return false; }
       }

       public bool IsCloneable
       {
           get { return false; }
       }

       public void DisposeControl()
       {
           
       }

       public Interfaces.IRibbonControl ParentControl
       {
           get { return null; }
       }
    }
}
