﻿

namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.TemplatePart(Name = _popup, Type = typeof(System.Windows.Controls.Primitives.Popup))]
    [System.Windows.TemplatePart(Name = _up, Type = typeof(RibbonButton))]
    [System.Windows.TemplatePart(Name = _toggle, Type = typeof(Controls.Primitives.ToggleButton))]
    [System.Windows.Markup.ContentProperty("RibbonPopupMenu")]
    public sealed class RibbonSplitButton : Primitives.RibbonButtonBase, Interfaces.IRibbonControl
    {
        #region Constructors
        static RibbonSplitButton() 
        {
           System.Type ownerType = typeof(RibbonSplitButton);
           RibbonSplitButton.DefaultStyleKeyProperty.OverrideMetadata
                (
                    ownerType,
                    new System.Windows.FrameworkPropertyMetadata(ownerType)
                );
           RibbonSplitButton.RibbonPopupMenuProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(
               (RibbonPopupMenu)null, 
               new System.Windows.PropertyChangedCallback(RibbonSplitButton.OnRibbonPopupMenuPropertyChanged)));
        }
       
        #endregion

        #region Properties and Depenency Properties


        [System.ComponentModel.Browsable(false),
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Input.ICommand UpButtonCommand
        {
            get { return (System.Windows.Input.ICommand)GetValue(UpButtonCommandProperty); }
            set { SetValue(UpButtonCommandProperty, value); }
        }

        // Using a DependencyProperty as the backing store for UpButtonCommand.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty UpButtonCommandProperty =
            System.Windows.DependencyProperty.Register("UpButtonCommand", typeof(System.Windows.Input.ICommand), typeof(RibbonSplitButton), new System.Windows.PropertyMetadata((System.Windows.Input.ICommand)null));

        internal bool HasContentInternal
        {
            get { return (bool)GetValue(HasContentInternalProperty); }
            set { SetValue(HasContentInternalProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HasContentInternal.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty HasContentInternalProperty =
            System.Windows.DependencyProperty.Register("HasContentInternal", typeof(bool), typeof(RibbonSplitButton), new System.Windows.PropertyMetadata(false));

        public RibbonPopupMenu RibbonPopupMenu
        {
            get { return (RibbonPopupMenu)GetValue(RibbonPopupMenuProperty); }
            set { SetValue(RibbonPopupMenuProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RibbonPopupMenu.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty RibbonPopupMenuProperty = RibbonToggleButton.RibbonPopupMenuProperty.AddOwner(typeof(RibbonSplitButton));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true),
        System.ComponentModel.ReadOnly(false)]
        public bool IsDropDownOpen
        {
            get { return (bool)GetValue(IsDropDownOpenProperty); }
            set { SetValue(IsDropDownOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsDropDownOpen.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsDropDownOpenProperty = RibbonComboBox.IsDropDownOpenProperty.AddOwner(typeof(RibbonSplitButton), new System.Windows.PropertyMetadata(
            false, 
            new System.Windows.PropertyChangedCallback(RibbonSplitButton.OnIsDropDownOpenPropertyChanged),
            new System.Windows.CoerceValueCallback(RibbonSplitButton.CoerceIsDropDownOpenProperty)));

        public bool IsLarge
        {
            get
            {
                return this.Size != RibbonControlSize.Small;
            }
        }

        #endregion
      
        #region Depenency Property Changed Callbacks

        private static void OnIsDropDownOpenPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            bool newValue = (bool)e.NewValue, oldValue = !newValue;
            RibbonSplitButton splitButton = (RibbonSplitButton)o;
            splitButton.SetPopupIsOpenValue(newValue);
            //if (!newValue) 
            //{
            //    System.Windows.Media.Animation.Storyboard sb = new System.Windows.Media.Animation.Storyboard();
            //    System.Windows.Media.Animation.DoubleAnimation da = new System.Windows.Media.Animation.DoubleAnimation();

            //    System.Windows.Media.Animation.Storyboard.SetTarget(da, splitButton.Popup.Child);
            //    System.Windows.Media.Animation.Storyboard.SetTargetProperty(da, new System.Windows.PropertyPath("Opacity"));
            //    da.To = 0.0D;
            //    da.Duration = new System.Windows.Duration(System.TimeSpan.FromSeconds(0.5));
            //    sb.Completed += new System.EventHandler(splitButton.AnimationCompleted);
            //    sb.Children.Add(da);
            //    sb.Begin();
            //}
            /* */
            splitButton.SetPopupIsOpenValue(newValue);
        }

        //private void AnimationCompleted(object sender, System.EventArgs e) 
        //{
        //    this.SetPopupIsOpenValue(this.IsDropDownOpen);
        //}
        private static System.Object CoerceIsDropDownOpenProperty(System.Windows.DependencyObject d, System.Object value) 
        {
            bool newValue = (bool)value;
            RibbonSplitButton splitButton = (RibbonSplitButton)d;
            if (newValue)
            {
                Common.PopupService.RibbonControlOpening = true;
                Common.PopupService.OpeningRibbonControl = splitButton;
            }
            return value;
        }
        private static void OnRibbonPopupMenuPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonSplitButton splitButton = (RibbonSplitButton)o;
            if (!splitButton.ShouldCreatePopup) 
            {
                splitButton.ClearValue(RibbonSplitButton.RibbonPopupMenuProperty);
                return;
            }
            if (e.OldValue != null) 
            {
                splitButton.ClearBindings(e.OldValue as RibbonPopupMenu);
            }
            if (e.NewValue != null)
            {
                splitButton.SetValue(RibbonSplitButton.HasContentInternalProperty, true);
                if (splitButton.Popup == null)
                {
                    splitButton.Popup = Common.PopupService.PopupBuilder(splitButton.RibbonPopupMenu);
                    
                    splitButton.Popup.Closed += new System.EventHandler(splitButton.DismissPopup);
                    splitButton.Popup.PlacementTarget = splitButton;
                    if (splitButton.toggleButton != null) 
                    {
                        splitButton.SetBindings();
                    }
                }
                else 
                {
                    splitButton.ClearBindings(e.OldValue as RibbonPopupMenu);
                    Masterpiece.Controls.DropShadowChrome shadowChrome = splitButton.Popup.Child as Masterpiece.Controls.DropShadowChrome;
                    shadowChrome.Content = e.NewValue;
                    splitButton.SetBindings();
                }
            }
            else 
            {
                splitButton.SetValue(RibbonSplitButton.HasContentInternalProperty, false);
            }
        }

        #endregion

        #region Overrides
        
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this.toggleButton = this.GetTemplateChild(_toggle) as Controls.Primitives.ToggleButton;
            if (this.btn != null) 
            {
                this.btn.Click -= this.UpButtonClicked;
                this.btn = null;
            }
            this.btn = this.GetTemplateChild(_up) as RibbonButton;
            this.btn.Click += this.UpButtonClicked;
            if (this.toggleButton != null) 
            {
                if (this.ShouldCreatePopup && this.RibbonPopupMenu != null)
                {
                    this.SetBindings();
                }
            }
            Common.PopupService.PopupDismissedEvent -= this.DismissPopup;
            Common.PopupService.PopupDismissedEvent += new System.EventHandler(this.DismissPopup);
            if (this.isClonedItem)
            {
                System.Windows.Data.BindingOperations.SetBinding
                    (
                        this.toggleButton,
                        Controls.Primitives.ToggleButton.IsCheckedProperty,
                        new System.Windows.Data.Binding("IsDropDownOpen") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                    );
            }
        }
        
        protected override void OnPreviewMouseRightButtonUp(System.Windows.Input.MouseButtonEventArgs e)
        {
            if (Common.PopupService.IsRibbonQAInitialized)
            {
                if (this.ParentUI != null)
                {
                    Common.PopupService.EnableRemovalButton();
                }
                else
                {
                    Common.PopupService.DisableRemovalButton();
                }

                Common.PopupService._addItem.IsEnabled = this.IsCloneable;
                Common.PopupService.OpenContextMenu(this);
            }
            base.OnPreviewMouseRightButtonUp(e);
            e.Handled = true;
        }

        #endregion

        #region Private Utilities
      
        private void SetBindings() 
        {
            this.RibbonPopupMenu.Tag = this;
            System.Windows.Data.BindingOperations.SetBinding
                       (
                           this.RibbonPopupMenu,
                           RibbonPopupMenu.IsDropDownOpenProperty,
                           new System.Windows.Data.Binding("IsDropDownOpen") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                       );
            System.Windows.Data.BindingOperations.SetBinding
                (
                    this.toggleButton,
                    Controls.Primitives.ToggleButton.IsCheckedProperty,
                    new System.Windows.Data.Binding("IsDropDownOpen") { Source = this, Mode = System.Windows.Data.BindingMode.TwoWay }
                );
        }
        
        private void ClearBindings(RibbonPopupMenu menu) 
        {
            System.Windows.Data.BindingExpression expression = menu.GetBindingExpression(RibbonPopupMenu.IsDropDownOpenProperty);
            if (expression != null && expression.DataItem == this) 
            {
                System.Windows.Data.BindingOperations.ClearBinding(menu, RibbonPopupMenu.IsDropDownOpenProperty);
            }

            if (this.toggleButton != null)
            {
                expression = this.toggleButton.GetBindingExpression(Controls.Primitives.ToggleButton.IsCheckedProperty);
                if (expression != null && expression.DataItem == this)
                {
                    System.Windows.Data.BindingOperations.ClearBinding(this.toggleButton, Controls.Primitives.ToggleButton.IsCheckedProperty);
                }
            }
        }
        
        private void CloseDropDown() 
        {
            if (this.IsDropDownOpen)
            {
                this.IsDropDownOpen = false;
            }
            if (this.ClonedChild != null && this.ClonedChild.IsDropDownOpen)
            {
                this.ClonedChild.CloseDropDown();
            }
        }

        private void SetPopupIsOpenValue(bool value) 
        {
            if (this.IsClonedItem) 
            {
                this.ParentUI.Popup.PlacementTarget = this;
                this.ParentUI.Popup.IsOpen = value;
                return;
            }
            if (this.Popup != null) 
            {
                this.Popup.PlacementTarget = this;
                this.Popup.IsOpen = value;
            }
        }
        #endregion

        #region Event Handlers

        private void DismissPopup(object sender, System.EventArgs e) 
        {
            this.CloseDropDown();
        }
        private void UpButtonClicked(object sender, System.Windows.RoutedEventArgs e) 
        {
            this.OnClick();
            e.Handled = true;
            Common.PopupService.RaisePopupDismissedEvent(sender);
        }

        #endregion

        #region Fields
        private const string _toggle = "PART_Toggle";
        private const string _popup = "PART_Popup";
        private const string _up = "PART_Up";
        internal Controls.Primitives.ToggleButton toggleButton;
        internal System.Windows.Controls.Primitives.Popup Popup;
        internal RibbonButton btn;
        internal RibbonSplitButton ParentUI, ClonedChild;
        internal bool IsCloned = false, ShouldCreatePopup = true;
        internal bool isCloneable = false, isClonedItem = false;
        #endregion

        #region Events
        #endregion
        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            RibbonSplitButton clonedItem = null;
            if (this.ClonedChild==null)
            {
                this.IsCloned = true;
                clonedItem = new RibbonSplitButton();
                clonedItem.ParentUI = this;
                clonedItem.ShouldCreatePopup = false;
                clonedItem.IsCloneable = false;
                clonedItem.IsClonedItem = true;
                if (this.SmallImage != null)
                {
                    System.Windows.Data.BindingOperations.SetBinding
                              (
                                 clonedItem,
                                 RibbonSplitButton.SmallImageProperty,
                                 new System.Windows.Data.Binding("SmallImage") { Source = this }
                              );
                }
                else if (this.LargeImage != null)
                {
                    System.Windows.Data.BindingOperations.SetBinding
                              (
                                 clonedItem,
                                 RibbonSplitButton.SmallImageProperty,
                                 new System.Windows.Data.Binding("LargeImage") { Source = this }
                              );
                }

                this.ClonedChild = clonedItem;
            }
            return clonedItem;
        }

        public bool IsClonedItem
        {
            get { return this.isClonedItem; }
            internal set 
            { 
                this.isClonedItem = value;
            }
        }

        public bool IsCloneable
        {
            get 
            {
                return !(this.ClonedChild != null || !RibbonControlCloningService.CheckIfItemIsCloneable(this));
            }
            internal set { this.isCloneable = value; }
        }


        public void DisposeControl()
        {
            if (this.ClonedChild != null) 
            {
                System.Windows.Data.BindingExpression expression = this.ClonedChild.GetBindingExpression(RibbonSplitButton.SmallImageProperty);
                if (expression != null) 
                {
                    System.Windows.Data.BindingOperations.ClearBinding(this.ClonedChild, RibbonSplitButton.SmallImageProperty);
                }
                if (this.ClonedChild.btn != null)
                {
                    this.ClonedChild.btn.Click -= this.UpButtonClicked;
                    this.ClonedChild.btn = null;
                }
                if (this.ClonedChild.toggleButton != null) 
                {
                    expression = this.ClonedChild.toggleButton.GetBindingExpression(Controls.Primitives.ToggleButton.IsCheckedProperty);
                    if (expression != null) 
                    {
                        System.Windows.Data.BindingOperations.ClearBinding(this.ClonedChild.toggleButton, Controls.Primitives.ToggleButton.IsCheckedProperty);
                    }
                    this.ClonedChild.toggleButton = null;
                }
                this.ClonedChild = null;
                System.GC.Collect();
            }
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return this.ParentUI; }
        }
        #endregion
    }
}
