﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
   public partial class RibbonStackPanel
    {
        #region IScrollInfo Implementaion
        
       /// <summary>
       /// 
       /// </summary>
       [System.ComponentModel.DefaultValue(false)] 
        public bool CanHorizontallyScroll
        {
            get
            {
                return this.canHScroll;
            }
            set
            {
                this.canHScroll = value;
            }
        }
       
       /// <summary>
       /// 
       /// </summary>
       [System.ComponentModel.DefaultValue(false)] 
        public bool CanVerticallyScroll
        {
            get
            {
                return this.canVScroll;
            }
            set
            {
                this.canVScroll = value;
            }
        }
       
       /// <summary>
       /// 
       /// </summary>
        public double ExtentHeight
        {
            get { return this._extent.Height; }
            set { this._extent.Height = value; }
        }

        public double ExtentWidth
        {
            get { return this._extent.Width; }
            set { this._extent.Width = value; }
        }

        public double HorizontalOffset
        {
            get { return this.offset.X; }
            set { this.offset.X = value; }
        }

        public double VerticalOffset
        {
            get { return this.offset.Y; }
            set { this.offset.Y = value; }
        }

        public double ViewportHeight
        {
            get { return this._viewport.Height; }
            set { this._viewport.Height = value; }
        }

        public double ViewportWidth
        {
            get { return this._viewport.Width; }
            set { this._viewport.Width = value; }
        }
        public void LineDown()
        {
            this.SetVerticalOffset(this.VerticalOffset + this.ScrollBy);
        }

        public void LineLeft()
        {
            this.SetHorizontalOffset(this.HorizontalOffset - this.ScrollBy);
        }

        public void LineRight()
        {
            this.SetHorizontalOffset(this.HorizontalOffset + this.ScrollBy);
        }

        public void LineUp()
        {
            this.SetVerticalOffset(this.VerticalOffset-this.ScrollBy);
        }

        public System.Windows.Rect MakeVisible(System.Windows.Media.Visual visual, System.Windows.Rect rectangle)
        {
            if (rectangle.IsEmpty || visual == null || visual == this || !base.IsAncestorOf(visual)) 
            {
                return System.Windows.Rect.Empty;
            }
            rectangle = visual.TransformToVisual(this).TransformBounds(rectangle);
            System.Windows.Rect viewRect = new System.Windows.Rect(this.HorizontalOffset, this.VerticalOffset, this.ViewportWidth, this.ViewportHeight);
            rectangle.X += viewRect.X;
            rectangle.Y += viewRect.Y;
            viewRect.X = this.CalculateNewScrollOffset(viewRect.Left, viewRect.Right, rectangle.Left, rectangle.Right);
            viewRect.Y = this.CalculateNewScrollOffset(viewRect.Top, viewRect.Bottom, rectangle.Top, rectangle.Bottom);
            this.SetHorizontalOffset(viewRect.X);
            this.SetVerticalOffset(viewRect.Y);
            rectangle.Intersect(viewRect);
            rectangle.X -= viewRect.X;
            rectangle.Y -= viewRect.Y;
            return rectangle;
        }


        public void MouseWheelDown()
        {
            this.SetVerticalOffset(this.VerticalOffset+this.ScrollBy);
        }

        public void MouseWheelLeft()
        {
            this.SetHorizontalOffset(this.HorizontalOffset-this.ScrollBy);
        }

        public void MouseWheelRight()
        {
            this.SetHorizontalOffset(this.HorizontalOffset + this.ScrollBy);
        }

        public void MouseWheelUp()
        {
            this.SetVerticalOffset(this.VerticalOffset - this.ScrollBy);
        }

        public void PageDown()
        {
            this.SetVerticalOffset(this.VerticalOffset+this.ViewportHeight);
        }

        public void PageLeft()
        {
            this.SetHorizontalOffset(this.HorizontalOffset-this.ViewportWidth);
        }

        public void PageRight()
        {
            this.SetHorizontalOffset(this.HorizontalOffset + this.ViewportWidth);
        }

        public void PageUp()
        {
            this.SetVerticalOffset(this.VerticalOffset - this.ViewportHeight);
        }

        public System.Windows.Controls.ScrollViewer ScrollOwner
        {
            get
            {
                return this.scrollViewer;
            }
            set
            {
                this.scrollViewer = value;
                if (this.scrollViewer != null)
                {
                    if (this.FitsToViewport)
                    {
                        this.scrollViewer.SizeChanged += new System.Windows.SizeChangedEventHandler(this.ScrollOwner_SizeChanged);
                    }
                }
            }
        }

        public void SetHorizontalOffset(double offset)
        {
            offset = this.ValidateHorizontalOffset(offset);
            if (!MS.Internal.DoubleUtil.AreClose(offset, this.offset.X))
            {
                this.offset.X = offset;

                if (this.ScrollOwner != null)
                {
                    this.ScrollOwner.InvalidateScrollInfo();
                    this.Scroll(this.HorizontalOffset, this.VerticalOffset);

                }
            }
        }

        public void SetVerticalOffset(double offset)
        {
            offset = this.ValidateVerticalOffset(offset);
            if (!MS.Internal.DoubleUtil.AreClose(offset, this.offset.Y))
            {
                this.offset.Y = offset;
                if (this.ScrollOwner != null)
                {
                    this.ScrollOwner.InvalidateScrollInfo();
                    this.Scroll(this.HorizontalOffset, this.VerticalOffset);
                }
            }
        }

        #endregion

       /// <summary>
       /// 
       /// </summary>
       /// <param name="offset"></param>
       /// <returns></returns>
       internal double ValidateHorizontalOffset(double offset)
        {
            RibbonScrollViewer scroller = this.ScrollOwner as RibbonScrollViewer;
            if (this.ViewportWidth >= this.ExtentWidth) 
            {
                scroller.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, false);
                scroller.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, false);
                return 0;
            }
            if (offset <= 1)
            {
                offset = 0;
                scroller.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, false);
                scroller.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, true);
                
            }
            else
            {
                if (offset + 1 >= this.ExtentWidth - this.ViewportWidth)
                {
                    offset = this.ExtentWidth - this.ViewportWidth;
                    scroller.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, true);
                    scroller.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, false);
                }
                else
                {
                    if (scroller != null)
                    {
                        scroller.SetValue(RibbonScrollViewer.CanLineLeftPropertyKey, true);
                        scroller.SetValue(RibbonScrollViewer.CanLineRightPropertyKey, true);
                    }
                }

            }
            return offset;
        }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="offset"></param>
       /// <returns></returns>
       internal double ValidateVerticalOffset(double offset)
        {
            RibbonScrollViewer scroller = this.ScrollOwner as RibbonScrollViewer;
            if (this.ViewportHeight >= this.ExtentHeight)
            {
                scroller.SetValue(RibbonScrollViewer.CanLineUpPropertyKey, false);
                scroller.SetValue(RibbonScrollViewer.CanLineDownPropertyKey, false);
                return 0;
            }
            if (scroller != null) 
            {
                if (scroller.Gallery != null&&scroller.Gallery.Items.Count<=3) 
                {
                    scroller.SetValue(RibbonScrollViewer.CanLineUpPropertyKey, false);
                    scroller.SetValue(RibbonScrollViewer.CanLineDownPropertyKey, false);
                    return 0;
                }
            }
            if (offset <= 1)
            {
                offset = 0;
                scroller.SetValue(RibbonScrollViewer.CanLineUpPropertyKey, false);
                scroller.SetValue(RibbonScrollViewer.CanLineDownPropertyKey, true);
            }
            else
            {
                if (this.ExtentHeight - this.ViewportHeight - offset <= 3)
                {
                    offset = this.ExtentHeight - this.ViewportHeight;
                    scroller.SetValue(RibbonScrollViewer.CanLineUpPropertyKey, true);
                    scroller.SetValue(RibbonScrollViewer.CanLineDownPropertyKey, false);
                }
                else
                {
                    if (scroller != null)
                    {
                        scroller.SetValue(RibbonScrollViewer.CanLineUpPropertyKey, true);
                        scroller.SetValue(RibbonScrollViewer.CanLineDownPropertyKey, true);
                    }
                }
            }
            return offset;
        }
       
       /// <summary>
       /// 
       /// </summary>
       /// <param name="xOffset"></param>
       /// <param name="yOffset"></param>
       private void Scroll(double xOffset, double yOffset)
        {
            if (this.AnimatedScroll)
            {
                System.Windows.Media.Animation.Storyboard sb = new System.Windows.Media.Animation.Storyboard();
                System.Windows.Media.Animation.DoubleAnimation anim = new System.Windows.Media.Animation.DoubleAnimation();
                if (this.Orientation == System.Windows.Controls.Orientation.Horizontal)
                {
                    System.Windows.Media.Animation.Storyboard.SetTargetProperty(anim, new System.Windows.PropertyPath("(0).(1)", RenderTransformProperty, System.Windows.Media.TranslateTransform.XProperty));
                    anim.To = (-1) * xOffset;
                }
                else
                {
                    System.Windows.Media.Animation.Storyboard.SetTargetProperty(anim, new System.Windows.PropertyPath("(0).(1)", RenderTransformProperty, System.Windows.Media.TranslateTransform.YProperty));
                    anim.To = (-1) * yOffset;
                }
                anim.Duration = new System.Windows.Duration(System.TimeSpan.FromMilliseconds(300));
                sb.Children.Add(anim);
                System.EventHandler handler = null;
                handler = delegate
                {
                    sb.Completed -= handler;
                    sb.Remove(this);
                    this._translate.X = (-1) * xOffset;
                    this._translate.Y = (-1) * yOffset;
                    this.InvalidateMeasure();

                };
                sb.Completed += handler;
                sb.Begin(this, true);
            }
            else
            {
                this._translate.X = -xOffset;
                this._translate.Y = -yOffset;
                this.InvalidateMeasure();

            }
        }
       
       /// <summary>
       /// 
       /// </summary>
       /// <param name="size"></param>
       internal void UpdateScrollInfo(System.Windows.Size size)
        {
            bool extentChanged = false, viewportChanged = false;
            double extent = this.CalculateExtent();
            if (this.Orientation == System.Windows.Controls.Orientation.Horizontal)
            {
                if (this._extent.Width != extent)
                {
                    this._extent.Width = extent;
                    extentChanged = true;
                }
                if (this._viewport.Width != size.Width)
                {
                    this._viewport.Width = size.Width;
                    viewportChanged = true;
                }

            }
            else 
            {
                if (this._extent.Height!= extent)
                {
                    this._extent.Height = extent;
                    extentChanged = true;
                }
                if (this._viewport.Height != size.Height)
                {
                    this._viewport.Height= size.Height;
                    viewportChanged = true;
                }

            }
            
            if ((extentChanged || viewportChanged) && this.ScrollOwner != null)
            {
                this.offset.X = this.ValidateHorizontalOffset(this.offset.X);
                this.offset.Y = this.ValidateVerticalOffset(this.offset.Y);
                this.ScrollOwner.InvalidateScrollInfo();
                this.Scroll(this.HorizontalOffset, this.VerticalOffset);
            }
        }
     
       /// <summary>
       /// 
       /// </summary>
       /// <returns></returns>
       private double CalculateExtent()
        {
            double size = 0;
            if (this.Orientation == System.Windows.Controls.Orientation.Horizontal)
            {
                foreach (System.Windows.UIElement item in this.InternalChildren)
                {
                        size += item.DesiredSize.Width + 1;
                }
            }
            else 
            {
                foreach (System.Windows.UIElement item in this.InternalChildren)
                {
                        size += item.DesiredSize.Height + 1;
                }
            }
            return size;
        }

       /// <summary>
       /// 
       /// </summary>
       /// <param name="offset"></param>
       internal void ScrollWithoutAnimation(double offset) 
        {
            offset = this.ValidateVerticalOffset(offset);
            this.offset.Y = offset;
            if (this.ScrollOwner != null)
            {
                this.ScrollOwner.InvalidateScrollInfo();
                this._translate.Y = -offset;
                this.InvalidateMeasure();
            }
            
        }
      
       private double CalculateNewScrollOffset(double topView, double bottomView, double topChild, double bottomChild)
        {
            bool offBottom = topChild < topView && bottomChild < bottomView;
            bool offTop = bottomChild > bottomView && topChild > topView;
            bool tooLarge = (bottomChild - topChild) > (bottomView - topView);

            if (!offBottom && !offTop)
            { return topView; } //Don't do anything, already in view

            if ((offBottom && !tooLarge) || (offTop && tooLarge))
            { return topChild; }

            return (bottomChild - (bottomView - topView));
        }
    }
}
