﻿
namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.TemplatePart(Name=partName, Type=typeof(System.Windows.Controls.TextBlock))]
    public class RibbonTextBlock:System.Windows.Controls.Control
    {
        #region Constructors
        static RibbonTextBlock() 
        {
            System.Type ownerType=typeof(RibbonTextBlock);
            RibbonTextBlock.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));
        }
        public RibbonTextBlock()
            : base()
        {

        }
        #endregion

        #region Properties and Depenency Properties
        
        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public double BaselineOffset
        {
            get { return (double)GetValue(BaselineOffsetProperty); }
            set { SetValue(BaselineOffsetProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BaselineOffset.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty BaselineOffsetProperty =
            System.Windows.DependencyProperty.Register("BaselineOffset", typeof(double), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Double.NaN));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Documents.TextPointer ContentEnd
        {
            get { return (System.Windows.Documents.TextPointer)GetValue(ContentEndProperty); }
            internal set { SetValue(ContentEndProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentEnd.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ContentEndProperty =
            System.Windows.DependencyProperty.Register("ContentEnd", typeof(System.Windows.Documents.TextPointer), typeof(RibbonTextBlock));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Documents.TextPointer ContentStart
        {
            get { return (System.Windows.Documents.TextPointer)GetValue(ContentStartProperty); }
            internal set { SetValue(ContentStartProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentStart.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ContentStartProperty =
            System.Windows.DependencyProperty.Register("ContentStart", typeof(System.Windows.Documents.TextPointer), typeof(RibbonTextBlock));

        [System.ComponentModel.Browsable(true),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Documents.InlineCollection Inlines
        {
            get { return (System.Windows.Documents.InlineCollection)GetValue(InlinesProperty); }
            internal set { SetValue(InlinesProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Inlines.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty InlinesProperty =
            System.Windows.DependencyProperty.Register("Inlines", typeof(System.Windows.Documents.InlineCollection), typeof(RibbonTextBlock));

        [System.ComponentModel.Browsable(true),
        System.ComponentModel.Bindable(true)]
        public bool IsHyphenationEnabled
        {
            get { return (bool)GetValue(IsHyphenationEnabledProperty); }
             set { SetValue(IsHyphenationEnabledProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsHyphenationEnabled.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsHyphenationEnabledProperty =
            System.Windows.DependencyProperty.Register("IsHyphenationEnabled", typeof(bool), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(false));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public double LineHeight
        {
            get { return (double)GetValue(LineHeightProperty); }
            set { SetValue(LineHeightProperty, value); }
        }

        // Using a DependencyProperty as the backing store for LineHeight.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty LineHeightProperty =
            System.Windows.DependencyProperty.Register("LineHeight", typeof(double), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Double.NaN));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.LineStackingStrategy LineStackingStrategy
        {
            get { return (System.Windows.LineStackingStrategy)GetValue(LineStackingStrategyProperty); }
            set { SetValue(LineStackingStrategyProperty, value); }
        }

        // Using a DependencyProperty as the backing store for LineStackingStrategy.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty LineStackingStrategyProperty =
            System.Windows.DependencyProperty.Register("LineStackingStrategy", typeof(System.Windows.LineStackingStrategy), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.LineStackingStrategy.MaxHeight));

        [System.ComponentModel.Browsable(true),
        System.ComponentModel.Bindable(true)]
        public string Text
        {
            get { return (string)GetValue(TextProperty); }
            set { SetValue(TextProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Text.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextProperty =
            System.Windows.DependencyProperty.Register("Text", typeof(string), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata((string)null));


        [System.ComponentModel.Browsable(true),
        System.ComponentModel.Bindable(true)]
        public System.Windows.TextAlignment TextAlignment
        {
            get { return (System.Windows.TextAlignment)GetValue(TextAlignmentProperty); }
            set { SetValue(TextAlignmentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextAlignment.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextAlignmentProperty =
            System.Windows.DependencyProperty.Register("TextAlignment", typeof(System.Windows.TextAlignment), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.TextAlignment.Left));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.TextDecorationCollection TextDecorations
        {
            get { return (System.Windows.TextDecorationCollection)GetValue(TextDecorationsProperty); }
            set { SetValue(TextDecorationsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextDecorations.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextDecorationsProperty =
            System.Windows.DependencyProperty.Register("TextDecorations", typeof(System.Windows.TextDecorationCollection), typeof(RibbonTextBlock));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.TextTrimming TextTrimming
        {
            get { return (System.Windows.TextTrimming)GetValue(TextTrimmingProperty); }
            set { SetValue(TextTrimmingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextTrimming.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextTrimmingProperty =
            System.Windows.DependencyProperty.Register("TextTrimming", typeof(System.Windows.TextTrimming), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.TextTrimming.None));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.TextWrapping TextWrapping
        {
            get { return (System.Windows.TextWrapping)GetValue(TextWrappingProperty); }
            set { SetValue(TextWrappingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextWrapping.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextWrappingProperty =
            System.Windows.DependencyProperty.Register("TextWrapping", typeof(System.Windows.TextWrapping), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.TextWrapping.NoWrap));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Documents.Typography Typography
        {
            get { return (System.Windows.Documents.Typography)GetValue(TypographyProperty); }
            internal set { SetValue(TypographyProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Typography.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TypographyProperty =
            System.Windows.DependencyProperty.Register("Typography", typeof(System.Windows.Documents.Typography), typeof(RibbonTextBlock));

        [System.ComponentModel.Browsable(true),
        System.ComponentModel.Bindable(true)]
        public System.Windows.Media.ImageSource Image
        {
            get { return (System.Windows.Media.ImageSource)GetValue(ImageProperty); }
            set { SetValue(ImageProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Image.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageProperty =
            System.Windows.DependencyProperty.Register("Image", typeof(System.Windows.Media.ImageSource), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata((System.Windows.Media.ImageSource)null));


        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.HorizontalAlignment ImageHorizontalAlignment
        {
            get { return (System.Windows.HorizontalAlignment)GetValue(ImageHorizontalAlignmentProperty); }
            set { SetValue(ImageHorizontalAlignmentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageHorizontalAlignment.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageHorizontalAlignmentProperty =
            System.Windows.DependencyProperty.Register("ImageHorizontalAlignment", typeof(System.Windows.HorizontalAlignment), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.HorizontalAlignment.Left));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.VerticalAlignment ImageVerticalAlignment
        {
            get { return (System.Windows.VerticalAlignment)GetValue(ImageVerticalAlignmentProperty); }
            set { SetValue(ImageVerticalAlignmentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageVerticalAlignment.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageVerticalAlignmentProperty =
            System.Windows.DependencyProperty.Register("ImageVerticalAlignment", typeof(System.Windows.VerticalAlignment), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.VerticalAlignment.Center));


        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.HorizontalAlignment TextHorizontalAlignment
        {
            get { return (System.Windows.HorizontalAlignment)GetValue(TextHorizontalAlignmentProperty); }
            set { SetValue(TextHorizontalAlignmentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextHorizontalAlignment.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextHorizontalAlignmentProperty =
            System.Windows.DependencyProperty.Register("TextHorizontalAlignment", typeof(System.Windows.HorizontalAlignment), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.HorizontalAlignment.Left));


        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public System.Windows.VerticalAlignment TextVerticalAlignment
        {
            get { return (System.Windows.VerticalAlignment)GetValue(TextVerticalAlignmentProperty); }
            set { SetValue(TextVerticalAlignmentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TextVerticalAlignment.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty TextVerticalAlignmentProperty =
            System.Windows.DependencyProperty.Register("TextVerticalAlignment", typeof(System.Windows.VerticalAlignment), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(System.Windows.VerticalAlignment.Center));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public double ImageWidth
        {   
            get { return (double)GetValue(ImageWidthProperty); }
            set { SetValue(ImageWidthProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageWidth.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageWidthProperty =
            System.Windows.DependencyProperty.Register("ImageWidth", typeof(double), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(16.0D));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true)]
        public double ImageHeight
        {
            get { return (double)GetValue(ImageHeightProperty); }
            set { SetValue(ImageHeightProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ImageHeight.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ImageHeightProperty =
            System.Windows.DependencyProperty.Register("ImageHeight", typeof(double), typeof(RibbonTextBlock), new System.Windows.PropertyMetadata(16.0D));

        #endregion

        #region Depenency Property Changed Callbacks
        #endregion

        #region Overrides

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this.TextBlock = this.GetTemplateChild(RibbonTextBlock.partName) as System.Windows.Controls.TextBlock;
            if (this.TextBlock != null) 
            {
                this.Inlines = this.TextBlock.Inlines;
                this.ContentEnd = this.TextBlock.ContentEnd;
                this.ContentStart = this.TextBlock.ContentStart;
            }
        }
        #endregion

        #region Private Utilities
        private System.Windows.Controls.TextBlock TextBlock { get; set; }
        #endregion

        #region Event Handlers
        #endregion

        #region Fields

        private const string partName = "PART_RibbonTextBlock_Text";
        #endregion

        #region Events
        #endregion
    }
}
