﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Masterpiece.Controls.Ribbon2010
{
   public class RibbonTextBox:System.Windows.Controls.TextBox
   {
       #region Constructors

       static RibbonTextBox() 
       {
           System.Type ownerType=typeof(RibbonTextBox);
           RibbonTextBox.DefaultStyleKeyProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(ownerType));
       }

       #endregion

       #region Properties and Depenency Properties

       public System.Windows.CornerRadius CornerRadius
       {
           get { return (System.Windows.CornerRadius)GetValue(CornerRadiusProperty); }
           set { SetValue(CornerRadiusProperty, value); }
       }

       // Using a DependencyProperty as the backing store for CornerRadius.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty CornerRadiusProperty = System.Windows.Controls.Border.CornerRadiusProperty.AddOwner(typeof(RibbonTextBox));


       public System.Windows.Media.ImageSource Image
       {
           get { return (System.Windows.Media.ImageSource)GetValue(ImageProperty); }
           set { SetValue(ImageProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Image.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageProperty = RibbonTextBlock.ImageProperty.AddOwner(typeof(RibbonTextBox));


       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true),
       System.ComponentModel.ReadOnly(false)]
       public double ImageHeight
       {
           get { return (double)GetValue(ImageHeightProperty); }
           set { SetValue(ImageHeightProperty, value); }
       }

       // Using a DependencyProperty as the backing store for ImageHeight.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageHeightProperty = RibbonTextBlock.ImageHeightProperty.AddOwner(typeof(RibbonTextBox));


       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true),
       System.ComponentModel.ReadOnly(false)]
       public double ImageWidth
       {
           get { return (double)GetValue(ImageWidthProperty); }
           set { SetValue(ImageWidthProperty, value); }
       }

       // Using a DependencyProperty as the backing store for ImageWidth.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageWidthProperty = RibbonTextBlock.ImageWidthProperty.AddOwner(typeof(RibbonTextBox));

       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true)]
       public System.Windows.HorizontalAlignment ImageHorizontalAlignment
       {
           get { return (System.Windows.HorizontalAlignment)GetValue(ImageHorizontalAlignmentProperty); }
           set { SetValue(ImageHorizontalAlignmentProperty, value); }
       }

       // Using a DependencyProperty as the backing store for ImageHorizontalAlignment.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageHorizontalAlignmentProperty = RibbonTextBlock.ImageHorizontalAlignmentProperty.AddOwner(typeof(RibbonTextBox));

       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true)]
       public System.Windows.VerticalAlignment ImageVerticalAlignment
       {
           get { return (System.Windows.VerticalAlignment)GetValue(ImageVerticalAlignmentProperty); }
           set { SetValue(ImageVerticalAlignmentProperty, value); }
       }

       // Using a DependencyProperty as the backing store for ImageVerticalAlignment.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty ImageVerticalAlignmentProperty = RibbonTextBlock.ImageVerticalAlignmentProperty.AddOwner(typeof(RibbonTextBox));

       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true),
       System.ComponentModel.ReadOnly(false)]
       public string Title
       {
           get { return (string)GetValue(TitleProperty); }
           set { SetValue(TitleProperty, value); }
       }

       // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty TitleProperty = RibbonButton.TitleProperty.AddOwner(typeof(RibbonTextBox));

       [System.ComponentModel.Browsable(false),
       System.ComponentModel.Bindable(true),
       System.ComponentModel.ReadOnly(false)]
       public bool AnimatesOnGotKeyboardFocus
       {
           get { return (bool)GetValue(AnimatesOnGotKeyboardFocusProperty); }
           set { SetValue(AnimatesOnGotKeyboardFocusProperty, value); }
       }

       // Using a DependencyProperty as the backing store for AnimatesOnGotKeyboardFocus.  This enables animation, styling, binding, etc...
       public static readonly System.Windows.DependencyProperty AnimatesOnGotKeyboardFocusProperty =
           System.Windows.DependencyProperty.Register("AnimatesOnGotKeyboardFocus", typeof(bool), typeof(RibbonTextBox), new System.Windows.PropertyMetadata(true));

       
       #endregion

       #region Depenency Property Changed Callbacks
       #endregion

       #region Overrides

       #endregion

       #region Private Utilities
       #endregion

       #region Event Handlers
       #endregion

       #region Fields
       #endregion

       #region Events
       #endregion
   }
}
