﻿
namespace Masterpiece.Controls.Ribbon2010
{
    [System.Windows.TemplatePart(Name = PART_Content, Type=typeof(System.Windows.Controls.Border))]
    public partial class RibbonWindow : System.Windows.Window, Interfaces.IRibbonControl
    {

        #region Constructors
        /// <summary>
        /// 
        /// </summary>
        static RibbonWindow()
        {
            System.Type ownerType = typeof(RibbonWindow);
            DefaultStyleKeyProperty.OverrideMetadata(ownerType,
                new System.Windows.FrameworkPropertyMetadata(ownerType)
                );

            RibbonWindow.WindowStyleProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(System.Windows.WindowStyle.None, new System.Windows.PropertyChangedCallback(OnRibbonWindowStyleChanged)));
            RibbonWindow.MinWidthProperty.OverrideMetadata(ownerType, new System.Windows.FrameworkPropertyMetadata(3 * System.Windows.SystemParameters.WindowCaptionButtonWidth + 32));
            RibbonWindow.WindowStateProperty.OverrideMetadata
                (
                    ownerType,
                    new System.Windows.FrameworkPropertyMetadata
                        (
                            System.Windows.WindowState.Normal,
                            new System.Windows.PropertyChangedCallback(RibbonWindow.OnWindowStatePropertyChanged)
                        )
                );
            
            //System.Diagnostics.PresentationTraceSources.DataBindingSource.Switch.Level =  System.Diagnostics.SourceLevels.Critical;
        }

        /// <summary>
        /// 
        /// </summary>
        public RibbonWindow()
        {
            this.SizeChanged += this.RibbonWindow_SizeChanged;
            //this.LocationChanged+=new System.EventHandler(this.RibbonWindow_LocationChanged);
            this.SetHook();
            this.RegisterCommands();
            
            System.Windows.ResourceDictionary resource = System.Windows.Application.LoadComponent(new System.Uri("/Masterpiece;component/Themes/Ribbon2010/InternalResources.xaml", System.UriKind.Relative)) as System.Windows.ResourceDictionary;
            if (resource != null)
            {
                System.Windows.Application.Current.Resources.MergedDictionaries.Add(resource);
            }
            System.ComponentModel.DependencyPropertyDescriptor descriptor = System.ComponentModel.DependencyPropertyDescriptor.FromProperty(RibbonWindow.IsActiveProperty, typeof(RibbonWindow));
            descriptor.AddValueChanged(this, new System.EventHandler(this.OnIsActivePropertyChanged));
            Common.PopupService.RibbonWindow = this;
        }

        #endregion
       
        #region Properties and Depenency Properties


        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        public object FooterContent
        {
            get { return (object)GetValue(FooterContentProperty); }
            set { SetValue(FooterContentProperty, value); }
        }

        // Using a DependencyProperty as the backing store for FooterContent.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty FooterContentProperty =
            System.Windows.DependencyProperty.Register("FooterContent", typeof(object), typeof(RibbonWindow));

        [System.ComponentModel.Bindable(true),
        System.ComponentModel.Browsable(true),
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Category("Appearance")]
        public bool IsMinimizeButtonEnabled
        {
            get { return (bool)GetValue(IsMinimizeButtonEnabledProperty); }
            set { SetValue(IsMinimizeButtonEnabledProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsMinimizeButtonEnabled.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsMinimizeButtonEnabledProperty =
            System.Windows.DependencyProperty.Register("IsMinimizeButtonEnabled", typeof(bool), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata(true));

        [System.ComponentModel.Bindable(true),
        System.ComponentModel.Browsable(true),
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Category("Appearance")]
        public bool IsMaximizeButtonEnabled
        {
            get { return (bool)GetValue(IsMaximizeButtonEnabledProperty); }
            set { SetValue(IsMaximizeButtonEnabledProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsMaximizeButtonEnabled.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsMaximizeButtonEnabledProperty =
            System.Windows.DependencyProperty.Register("IsMaximizeButtonEnabled", typeof(bool), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata(true));
        
        /// <summary>
        /// Gets or sets content padding. This is a dependency property.
        /// </summary>
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(true), 
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Category("Appearance")]
        public System.Windows.Thickness ContentPadding
        {
            get { return (System.Windows.Thickness)GetValue(ContentPaddingProperty); }
            set { SetValue(ContentPaddingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentPadding.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ContentPaddingProperty =
            System.Windows.DependencyProperty.Register("ContentPadding", typeof(System.Windows.Thickness), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata(RibbonWindowParameters.ContentPadding));

        /// <summary>
        /// 
        /// </summary>
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(true), 
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Category("Appearance")]
        public bool HasFooter
        {
            get { return (bool)GetValue(HasFooterProperty); }
            set { SetValue(HasFooterProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HasFooter.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty HasFooterProperty =
            System.Windows.DependencyProperty.Register("HasFooter", typeof(bool), typeof(RibbonWindow), new System.Windows.PropertyMetadata(true));
        
        [System.ComponentModel.Browsable(true), 
        System.ComponentModel.Category("Appearance"), 
        System.ComponentModel.ReadOnly(false)]
        public Masterpiece.Controls.Ribbon2010.CornerRadiusMode CornerRadiusMode
        {
            get { return (Masterpiece.Controls.Ribbon2010.CornerRadiusMode)GetValue(CornerRadiusModeProperty); }
            set { SetValue(CornerRadiusModeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CornerRadiusMode.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty CornerRadiusModeProperty =
            System.Windows.DependencyProperty.Register("CornerRadiusMode", typeof(Masterpiece.Controls.Ribbon2010.CornerRadiusMode), typeof(RibbonWindow), new System.Windows.PropertyMetadata(Masterpiece.Controls.Ribbon2010.CornerRadiusMode.All, OnCornerRadiusModeChanged));
        
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        public RibbonBar RibbonBar
        {
            get { return (RibbonBar)GetValue(RibbonBarProperty); }
            set { SetValue(RibbonBarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RibbonBar.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty RibbonBarProperty =
            System.Windows.DependencyProperty.Register("RibbonBar", typeof(RibbonBar), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata((RibbonBar)null, new System.Windows.PropertyChangedCallback(OnRibbonBarPropertyChanged), new System.Windows.CoerceValueCallback(CoerceRibbonBarProperty)));

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        internal Masterpiece.Controls.Ribbon2010.RibbonQuickAccessToolbar RibbonQuickAccessToolbar
        {
            get { return (Masterpiece.Controls.Ribbon2010.RibbonQuickAccessToolbar)GetValue(RibbonQuickAccessToolbarProperty); }
            set { SetValue(RibbonQuickAccessToolbarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RibbonQuickAccessToolbar.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty RibbonQuickAccessToolbarProperty =
            System.Windows.DependencyProperty.Register("RibbonQuickAccessToolbar", typeof(Masterpiece.Controls.Ribbon2010.RibbonQuickAccessToolbar), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata((RibbonQuickAccessToolbar)null, new System.Windows.PropertyChangedCallback(RibbonWindow.OnRibbonQuickAccessToolbarPropertyChanged), new System.Windows.CoerceValueCallback(RibbonWindow.CoerceRibbonQuickAccessToolbarProperty)));

        public bool IsQuickAccessToolBarEnabled
        {
            get { return (bool)GetValue(IsQuickAccessToolBarEnabledProperty); }
            set { SetValue(IsQuickAccessToolBarEnabledProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsQuickAccessToolBarEnabled.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsQuickAccessToolBarEnabledProperty =
            System.Windows.DependencyProperty.Register("IsQuickAccessToolBarEnabled", typeof(bool), typeof(RibbonWindow), new System.Windows.PropertyMetadata(false, new System.Windows.PropertyChangedCallback(RibbonWindow.OnIsQuickAccessToolBarEnabledPropertyChanged)));
        
        [System.ComponentModel.Bindable(true),
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        public bool IsApplicationMenuOpen
        {
            get { return (bool)GetValue(IsApplicationMenuOpenProperty); }
            set { SetValue(IsApplicationMenuOpenProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsApplicationMenuoOpen.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty IsApplicationMenuOpenProperty =
            System.Windows.DependencyProperty.Register("IsApplicationMenuOpen", typeof(bool), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata
                (
                    false,
                    new System.Windows.PropertyChangedCallback(RibbonWindow.OnIsApplicationMenuOpenPropertyChanged)
                ));

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(false)]
        internal double WindowMinWidth
        {
            get { return (double)GetValue(WindowMinWidthProperty); }
            set { SetValue(WindowMinWidthProperty, value); }
        }

        // Using a DependencyProperty as the backing store for WindowMinWidth.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty WindowMinWidthProperty =
            System.Windows.DependencyProperty.Register("WindowMinWidth", typeof(double), typeof(RibbonWindow), new System.Windows.PropertyMetadata(0.0));

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(true)]
        internal bool IsRibbonBarCollapsed
        {
            get { return (bool)GetValue(IsRibbonBarCollapsedProperty); }
            set { SetValue(IsRibbonBarCollapsedProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsRibbonBarCollapsed.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsRibbonBarCollapsedProperty =
            System.Windows.DependencyProperty.Register("IsRibbonBarCollapsed", typeof(bool), typeof(RibbonWindow));


        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false),
        System.ComponentModel.ReadOnly(true)]
        public bool IsGlassEnabled
        {
            get { return (bool)GetValue(IsGlassEnabledProperty); }
        }

        // Using a DependencyProperty as the backing store for IsVistaCore.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyPropertyKey IsGlassEnabledPropertyKey =
            System.Windows.DependencyProperty.RegisterReadOnly("IsGlassEnabled", typeof(bool), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata(false, new System.Windows.PropertyChangedCallback(OnIsGlassEnabledPropertyChanged)));

        internal static readonly System.Windows.DependencyProperty IsGlassEnabledProperty = IsGlassEnabledPropertyKey.DependencyProperty;

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(true)]
        public double CaptionHeight
        {
            get 
            { 
                return Ribbon2010.RibbonWindowParameters.CaptionHeight; 
            }
        }
        
        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(true), 
        System.ComponentModel.ReadOnly(false),
        System.ComponentModel.Category("Brushes")]
        public System.Windows.Media.Brush ContentBrush
        {
            get { return (System.Windows.Media.Brush)GetValue(ContentBrushProperty); }
            set { SetValue(ContentBrushProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentBrush.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ContentBrushProperty =
            System.Windows.DependencyProperty.Register("ContentBrush", typeof(System.Windows.Media.Brush), typeof(RibbonWindow));
        

        [System.ComponentModel.Bindable(true), 
        System.ComponentModel.Browsable(false), 
        System.ComponentModel.ReadOnly(true)]
        public double FooterHeight
        {
            get
            {
                return Ribbon2010.RibbonWindowParameters.FooterHeight;
            }
        }

        internal bool IsRibbonBarBackgoundMode
        {
            get { return (bool)GetValue(IsRibbonBarBackgoundModeProperty); }
            set { SetValue(IsRibbonBarBackgoundModeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsRibbonBarBackgoundMode.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty IsRibbonBarBackgoundModeProperty =
            System.Windows.DependencyProperty.Register("IsRibbonBarBackgoundMode", typeof(bool), typeof(RibbonWindow), new System.Windows.PropertyMetadata(false));
        
        [System.ComponentModel.Bindable(true),
        System.ComponentModel.Browsable(false),
        System.ComponentModel.ReadOnly(false)]
        public System.Collections.Generic.IEnumerable<int> QTItemsSource
        {
            get { return (System.Collections.Generic.IEnumerable<int>)GetValue(QTItemsSourceProperty); }
            set { SetValue(QTItemsSourceProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QTItemsSource.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty QTItemsSourceProperty =
            System.Windows.DependencyProperty.Register("QTItemsSource", typeof(System.Collections.Generic.IEnumerable<int>), typeof(RibbonWindow), new System.Windows.PropertyMetadata((System.Collections.Generic.IEnumerable<int>)null, new System.Windows.PropertyChangedCallback(RibbonWindow.OnQTItemsSourcePropertyChanged)));

         [System.ComponentModel.Bindable(true),
        System.ComponentModel.Browsable(false),
        System.ComponentModel.ReadOnly(false)]
        public QACommanItemCollection QACommandItems
        {
            get { return (QACommanItemCollection)GetValue(QACommandItemsProperty); }
            set { SetValue(QACommandItemsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QACommandItems.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty QACommandItemsProperty =
            System.Windows.DependencyProperty.Register("QACommandItems", typeof(QACommanItemCollection), typeof(RibbonWindow), new System.Windows.PropertyMetadata((QACommanItemCollection)null));

        public OutlookBar.OutlookBar LeftOutlookBar
        {
            get { return (OutlookBar.OutlookBar)GetValue(LeftOutlookBarProperty); }
            set { SetValue(LeftOutlookBarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for LeftOutlookBar.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty LeftOutlookBarProperty =
            System.Windows.DependencyProperty.Register("LeftOutlookBar", typeof(OutlookBar.OutlookBar), typeof(RibbonWindow), new System.Windows.PropertyMetadata((OutlookBar.OutlookBar)null));

        public OutlookBar.OutlookBar RightOutlookBar
        {
            get { return (OutlookBar.OutlookBar)GetValue(RightOutlookBarProperty); }
            set { SetValue(RightOutlookBarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RightOutlookBar.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty RightOutlookBarProperty =
            System.Windows.DependencyProperty.Register("RightOutlookBar", typeof(OutlookBar.OutlookBar), typeof(RibbonWindow), new System.Windows.PropertyMetadata((OutlookBar.OutlookBar)null, new System.Windows.PropertyChangedCallback(RibbonWindow.OnRightOutlookBarPropertyChanged)));

        [System.ComponentModel.Browsable(false),
        System.ComponentModel.Bindable(true),
        System.ComponentModel.ReadOnly(false)]
        public string QAHeader
        {
            get { return (string)GetValue(QAHeaderProperty); }
            set { SetValue(QAHeaderProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QAHeader.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty QAHeaderProperty =
            System.Windows.DependencyProperty.Register("QAHeader", typeof(string), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata("Customize Quick Access Toolbar", System.Windows.FrameworkPropertyMetadataOptions.BindsTwoWayByDefault));

        #endregion

        #region Depenency Property Changed Callbacks

        private static void OnRightOutlookBarPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            if (e.NewValue != null) 
            {
                OutlookBar.OutlookBar outlookBar = (OutlookBar.OutlookBar)e.NewValue;
                outlookBar.SetValue(OutlookBar.OutlookBar.DirectionProperty, Masterpiece.Controls.OutlookBar.Direction.Left);
            }
        }

        private static void OnQTItemsSourcePropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonWindow window = (RibbonWindow)d;
            if (window.IsQuickAccessToolBarEnabled)
            {
                System.Collections.Generic.IEnumerable<int> newValue = (System.Collections.Generic.IEnumerable<int>)e.NewValue, oldValue = (System.Collections.Generic.IEnumerable<int>)e.OldValue;
                if (oldValue != null)
                {
                    window.RibbonQuickAccessToolbar.ClearItems();
                    /*here must be logic*/
                }
                if (newValue != null)
                {
                    window.RibbonQuickAccessToolbar.AddRange(window.QTItemsSource);
                    /*here must be logic*/
                }
            }
        }

        private static void OnIsQuickAccessToolBarEnabledPropertyChanged(System.Windows.DependencyObject d, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonWindow window = (RibbonWindow)d;
            bool newValue = (bool)e.NewValue, oldValue=!newValue;
            if (newValue)
            {
                if (window.RibbonQuickAccessToolbar == null)
                {
                    window.RibbonQuickAccessToolbar = new RibbonQuickAccessToolbar();
                    System.Windows.Data.BindingOperations.SetBinding
                        (
                             window.RibbonQuickAccessToolbar,
                             RibbonQuickAccessToolbar.CustomizeQAHeaderProperty,
                             new System.Windows.Data.Binding("QAHeader") {Source=window }
                        );
                    RibbonControlCloningService.InitializeCloningService();
                    if (window.QTItemsSource != null)
                    {
                        window.RibbonQuickAccessToolbar.AddRange(window.QTItemsSource);
                    }
                }
                else 
                {
                    window.RibbonQuickAccessToolbar.Visibility = System.Windows.Visibility.Visible;
                }
            }
            else 
            {
                if (window.RibbonQuickAccessToolbar != null) 
                {
                    window.RibbonQuickAccessToolbar.Visibility = System.Windows.Visibility.Collapsed;
                }
            }
        }

        private static void OnIsApplicationMenuOpenPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonWindow window = o as RibbonWindow;
            bool oldValue = (bool)e.OldValue;
            bool newValue = !oldValue;
            if (newValue)
            {
                window.OnApplicationWindowOpened(window);
            }
            else 
            {
                window.OnApplicationWindowClosed(window);
            }
            if (window.RibbonQuickAccessToolbar != null) 
            {
                window.RibbonQuickAccessToolbar.IsEnabled = !newValue;
            }
        }

        protected virtual void OnApplicationWindowOpened(RibbonWindow window) { }
        protected virtual void OnApplicationWindowClosed(RibbonWindow window) { }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private static void OnWindowStatePropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            System.Windows.WindowState state = (System.Windows.WindowState)e.NewValue;
            RibbonWindow window = o as RibbonWindow;
            if (window.RibbonBar != null) 
            {
                window.RibbonBar.InvalidateMeasure();
                window.RibbonBar.TrySetScrollViewer();
            }
            
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        private static System.Object CoerceRibbonQuickAccessToolbarProperty(System.Windows.DependencyObject o, System.Object value) 
        {
            return value is RibbonQuickAccessToolbar ? value : null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        private static void OnRibbonQuickAccessToolbarPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonQuickAccessToolbar oldValue = (RibbonQuickAccessToolbar)e.OldValue, newValue = (RibbonQuickAccessToolbar)e.NewValue;
            RibbonWindow win = (RibbonWindow)o;
            if (newValue != null) 
            {
                win.QACommandItems = newValue.CommandItems;
                if (Common.PopupService._ContextPopup == null)
                {
                    Common.PopupService._ContextPopup = win.BuildContextMenu();
                }
                RibbonPopupMenu menu = (Common.PopupService._ContextPopup.Child as DropShadowChrome).Content as RibbonPopupMenu;
                if (menu == null)
                {
                    return;
                }
                RibbonPopupMenuItem item = new RibbonPopupMenuItem();
                item.Title = "Разместить панель быстрого доступа под лентой";
                menu.Items.Insert(0, item);
                item = new RibbonPopupMenuItem();
                item.Title = "Настройка панели быстрого доступа";
                menu.Items.Insert(0, item);
                item = new RibbonPopupMenuItem();
                item.Click += new RoutedEventHandler(win.RemoveFromQuickAccessClicked);
                Common.PopupService._removeItem = item;
                item.Title = "Удалить с панели быстрого доступа";
                item.Visibility = System.Windows.Visibility.Collapsed;
                menu.Items.Insert(0, item);
                item = new RibbonPopupMenuItem();
                Common.PopupService._addItem = item;
                item.Title = "Добавить на панель быстрого доступа";
                item.Click += new RoutedEventHandler(win.AddToQuickAccessClicked);
                menu.Items.Insert(0, item);
                Common.PopupService.IsRibbonQAInitialized = true;
            }
        }

        
        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        private static void OnCornerRadiusModeChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonWindow win = o as RibbonWindow;
            win.AttachRegion();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        private static void OnRibbonBarPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            RibbonWindow win = o as RibbonWindow;

            if (e.OldValue == null && e.NewValue != null)
            {
                win.RibbonBar.MainWindow = win;
                System.Windows.Data.BindingOperations.SetBinding
                    (
                    win,
                    RibbonWindow.IsApplicationMenuOpenProperty,
                    new System.Windows.Data.Binding("IsApplicationMenuOpen") { Source = win.RibbonBar, Mode = System.Windows.Data.BindingMode.TwoWay }
                    );
                System.Windows.Data.BindingOperations.SetBinding
                    (
                    win,
                    RibbonWindow.IsRibbonBarBackgoundModeProperty,
                    new System.Windows.Data.Binding("IsBackgoundMode") { Source = win.RibbonBar, Mode = System.Windows.Data.BindingMode.TwoWay }
                    );
                System.Windows.Data.BindingOperations.SetBinding
                    (
                    win,
                    RibbonWindow.IsRibbonBarCollapsedProperty,
                    new System.Windows.Data.Binding("Visibility")
                    {
                        Source = win.RibbonBar,
                        Converter = new Masterpiece.Controls.Ribbon2010.Converters.VisiblityToBooleanConverter()
                    }
                    );
                System.Windows.Data.BindingOperations.SetBinding
                   (
                   win.RibbonBar,
                   RibbonBar.IsGlassEnabledProperty,
                   new System.Windows.Data.Binding("IsGlassEnabled")
                   {
                       Source = win,
                       Mode = System.Windows.Data.BindingMode.OneWay
                   }
                   );
               

                Common.PopupService.RibbonBar = win.RibbonBar;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        private static void OnRibbonWindowStyleChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            System.Windows.WindowStyle newValue = (System.Windows.WindowStyle)e.NewValue;
            RibbonWindow window = (RibbonWindow)o;

            if (System.Environment.OSVersion.Version.Major < 6) 
            {
                o.SetValue(RibbonWindow.WindowStyleProperty, System.Windows.WindowStyle.None);
                
                return;
            }
            o.SetValue(RibbonWindow.WindowStyleProperty, newValue);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="o"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        private static RibbonBar CoerceRibbonBarProperty(System.Windows.DependencyObject o, object value) 
        {
            return value is RibbonBar ? (RibbonBar)value : new RibbonBar();
        }

        /// <summary>
        /// Invoked whenever IsGlassEnabled dependency property changes.
        /// </summary>
        /// <param name="o"></param>
        /// <param name="e"></param>
        private static void OnIsGlassEnabledPropertyChanged(System.Windows.DependencyObject o, System.Windows.DependencyPropertyChangedEventArgs e) 
        {
            bool newValue = (bool)e.NewValue, oldValue = (bool)e.OldValue;
            if (newValue) 
            {
                RibbonWindow w = (RibbonWindow)o;
                w.SetOptionsForGlass();
            }
        }

        #endregion

        #region Overrieds

        /// <summary>
        /// 
        /// </summary>
        /// <param name="availableSize"></param>
        /// <returns></returns>
        protected override System.Windows.Size MeasureOverride(System.Windows.Size availableSize)
        {
         
            VerifyAccess();
            if (this.VisualChildrenCount > 0)
            {
                System.Windows.UIElement child = this.GetVisualChild(0) as System.Windows.UIElement;
                if (child != null) 
                {
                    child.Measure(availableSize);
                    return child.DesiredSize;
                }
            }
            return base.MeasureOverride(availableSize);
        }

        /// <summary>
        /// 
        /// </summary>
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this.mainBorder = this.GetTemplateChild(partOuterBorder);
            this.titleText = this.GetTemplateChild(partTitleText);
            this.ContentBorder = this.GetTemplateChild(PART_Content) as System.Windows.Controls.Border;
            this.icon = (System.Windows.Controls.Image)this.GetTemplateChild("PART_Icon");
            
            if (this.QACommandItems != null && this.QACommandItems.Count > 0)
            {
                if (this.RibbonQuickAccessToolbar != null)
                {
                    foreach (QACommandItem item in this.QACommandItems)
                    {
                        if (item.VisibleOnStartup)
                        {
                            this.RibbonQuickAccessToolbar.AddItemToPanel(item);
                        }
                    }
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="arrangeBounds"></param>
        /// <returns></returns>
        protected override System.Windows.Size ArrangeOverride(System.Windows.Size arrangeBounds)
        {
            VerifyAccess();
            if (this.VisualChildrenCount > 0)
            {
                System.Windows.UIElement child = this.GetVisualChild(0) as System.Windows.UIElement;

                if (child != null)
                {
                    child.Arrange(new System.Windows.Rect(arrangeBounds));
                }
                return arrangeBounds;
            }
            return base.ArrangeOverride(arrangeBounds);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        protected override void OnInitialized(System.EventArgs e)
        {
           base.OnInitialized(e);
           
            if (this.RibbonBar != null)
            {
                if (this.RibbonBar.ApplicationMenu != null)
                {
                    this.RibbonBar.ApplicationMenu.WindowContent = this.Content;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        protected override void OnSourceInitialized(System.EventArgs e)
        {
            base.OnSourceInitialized(e);
            this.SetGlassAvaliability();
            
        }

        
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        #endregion

        #region Private Utilities

        /// <summary>
        /// 
        /// </summary>
        private System.Windows.Controls.Primitives.Popup BuildContextMenu()
        {
            System.Windows.Controls.Primitives.Popup popup = new System.Windows.Controls.Primitives.Popup();
            popup.StaysOpen = false;
            popup.AllowsTransparency = true;
            popup.PopupAnimation = System.Windows.Controls.Primitives.PopupAnimation.None;
            popup.Placement = System.Windows.Controls.Primitives.PlacementMode.MousePoint;
            DropShadowChrome dropShadow = new DropShadowChrome();
            RibbonPopupMenu menu = new RibbonPopupMenu();
            menu.CanResize = false;
            menu.DropDownHeight = double.NaN;
            RibbonPopupMenuItem item = new RibbonPopupMenuItem();
            item = new RibbonPopupMenuItem();
            item.Title = "Настройка ленты";
            menu.Items.Add(item);
            item = new RibbonPopupMenuItem();
            item.Title = "Свернуть ленты";
            item.Click += new RoutedEventHandler(this.Item_Click);
            menu.Items.Add(item);
            dropShadow.Content = menu;
            popup.Child = dropShadow;
            return popup;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="GlassTitleBorderHeight"></param>
        private void SetOptionsForGlass(short GlassTitleBorderHeight = 55) 
        {
            
            System.IntPtr hwnd = new System.Windows.Interop.WindowInteropHelper(this).Handle;
            System.Windows.Interop.HwndSource src = System.Windows.Interop.HwndSource.FromHwnd(hwnd);

            // settings the following value is necassary to have a transparent glass background instead of black:
            src.CompositionTarget.BackgroundColor = System.Windows.Media.Color.FromArgb(0, 0, 0, 0);

            short GlassBorderSize = 8;
            if (this.WindowStyle == System.Windows.WindowStyle.ToolWindow||this.WindowStyle== System.Windows.WindowStyle.ThreeDBorderWindow)
            {
                GlassBorderSize = 10;
            }
            Masterpiece.Common.NativeMethods.MARGINS margins = new Masterpiece.Common.NativeMethods.MARGINS();
            margins.cxLeftWidth = GlassBorderSize;
            margins.cxRightWidth = GlassBorderSize;
            margins.cyTopHeight = GlassTitleBorderHeight;
            margins.cyBottomHeight = GlassBorderSize;
            Masterpiece.Common.NativeMethods.DwmExtendFrameIntoClientArea(hwnd, ref margins);
            this.AttachRegion();
        }

        /// <summary>
        /// 
        /// </summary>
        private void SetGlassAvaliability() 
        {
            bool isGLassEnabled = false;
            
                if (System.Environment.OSVersion.Version.Major >= 6)
                {
                    if (Common.NativeMethods.DwmIsCompositionEnabled())
                    {
                        isGLassEnabled = true;
                        if (System.Environment.OSVersion.Version.Minor >= 2) 
                        {
                            this.SetValue(RibbonWindow.BorderBrushProperty, System.Windows.Media.Brushes.Transparent);
                        }
                    }
                }
                
            this.SetValue(RibbonWindow.IsGlassEnabledPropertyKey, isGLassEnabled);
        }


        /// <summary>
        /// Sets window procedure.
        /// </summary>
        private void SetHook() 
        {
            System.EventHandler handler = delegate(object sender, System.EventArgs e) 
            {
                System.Windows.Interop.HwndSource source = (System.Windows.Interop.HwndSource)System.Windows.PresentationSource.FromVisual(this);
                source.AddHook(new System.Windows.Interop.HwndSourceHook(this.Handler));
            };
            base.SourceInitialized += handler;
        }
        
        /// <summary>
        /// 
        /// </summary>
        /// <param name="hwnd"></param>
        /// <param name="lParam"></param>
        /// <param name="handled"></param>
        /// <param name="result"></param>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private void WndProcHitTest(System.IntPtr hwnd, System.IntPtr lParam, ref bool handled, ref System.IntPtr result) 
        {
            int xy = lParam.ToInt32();
            System.Windows.Point point = new System.Windows.Point(Masterpiece.Common.NativeMethods.SignedLoWord(xy), Masterpiece.Common.NativeMethods.SignedHiWord(xy));
            Masterpiece.Common.NativeMethods.RECT rect = new Common.NativeMethods.RECT();
            Masterpiece.Common.NativeMethods.GetWindowRect(hwnd, out rect);
            System.Windows.Rect wndRect = new System.Windows.Rect(rect.Left, rect.Top, rect.Right-rect.Left, rect.Bottom-rect.Top);
            Masterpiece.Common.NativeMethods.HT ht = this.NCHITTEST(point, wndRect);
            result = new System.IntPtr((int)ht);
            handled = ht != Masterpiece.Common.NativeMethods.HT.NOWHERE;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="point"></param>
        /// <param name="wndRect"></param>
        /// <returns></returns>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private Masterpiece.Common.NativeMethods.HT NCHITTEST(System.Windows.Point point, System.Windows.Rect wndRect)
        {
            const double borderSize = 6.0;
            const double titleHeight = 34.0;

            if (point.Y < wndRect.Top + borderSize)
            {
                if (point.X < wndRect.Left + borderSize) return Masterpiece.Common.NativeMethods.HT.TOPLEFT;
                if (point.X > wndRect.Right - borderSize) return Masterpiece.Common.NativeMethods.HT.TOPRIGHT;
                return Masterpiece.Common.NativeMethods.HT.TOP;
            }
            if (point.Y > wndRect.Bottom - borderSize)
            {
                if (point.X < wndRect.Left + borderSize) return Masterpiece.Common.NativeMethods.HT.BOTTOMLEFT;
                if (point.X > wndRect.Right - borderSize) return Masterpiece.Common.NativeMethods.HT.BOTTOMRIGHT;
                return Masterpiece.Common.NativeMethods.HT.BOTTOM;
            }
            if (point.X < wndRect.Left + borderSize) 
            {
                return Masterpiece.Common.NativeMethods.HT.LEFT; 
            }
            if (point.X > wndRect.Right - borderSize) return Masterpiece.Common.NativeMethods.HT.RIGHT;
            if (point.Y < wndRect.Top + titleHeight)
            {
                System.Windows.Point localPoint = this.ScreenToLocal(point);
                System.Windows.IInputElement e = this.InputHitTest(localPoint);
                if (e == null)
                {
                    return Masterpiece.Common.NativeMethods.HT.CAPTION;

                }
                else
                {
                    if (e == mainBorder) {
                        
                        return Masterpiece.Common.NativeMethods.HT.CAPTION; }
                    System.Windows.UIElement ue = e as System.Windows.UIElement;
                    if (ue == null || !ue.IsHitTestVisible || ue == this.titleText||this.RibbonBar!=null&&ue==this.RibbonBar.TabItemsScroller)
                    {
                        return Masterpiece.Common.NativeMethods.HT.CAPTION;
                    }
                }
            }
            return Common.NativeMethods.HT.NOWHERE;

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="point"></param>
        /// <returns></returns>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private System.Windows.Point ScreenToLocal(System.Windows.Point point)
        {
            Masterpiece.Common.NativeMethods.RECT rect;
            Masterpiece.Common.NativeMethods.GetWindowRect(new System.Windows.Interop.WindowInteropHelper(this).Handle, out rect);
            System.Windows.Media.Matrix matrix = System.Windows.PresentationSource.FromVisual(this).CompositionTarget.TransformFromDevice;
            point.Offset((double)(-1 * rect.Left), (double)(-1 * rect.Top));
            point.X *= matrix.M11;
            point.Y *= matrix.M22;
            return point;
        }

        /// <summary>
        /// 
        /// </summary>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private void AttachRegion() 
        {
            if (!this.IsGlassEnabled)
            {
                Masterpiece.Common.NativeMethods.RECT rect;
                System.IntPtr hwnd = (new System.Windows.Interop.WindowInteropHelper(this)).Handle;
                Masterpiece.Common.NativeMethods.GetWindowRect(hwnd, out rect);

                int w = rect.Width + 1;
                int h = rect.Height + 1;

                if (this.WindowState != System.Windows.WindowState.Maximized)
                {
                    System.IntPtr rgn = Masterpiece.Common.NativeMethods.CreateRoundRectRgn(0, 0, w, h, 12, 12);
                    switch (this.CornerRadiusMode)
                    {
                        case CornerRadiusMode.Top:
                            System.IntPtr rgn2 = Masterpiece.Common.NativeMethods.CreateRectRgn(0, 6, w, h);
                            Masterpiece.Common.NativeMethods.CombineRgn(rgn, rgn2, rgn, 2);
                            break;
                        case CornerRadiusMode.None:
                            rgn = Masterpiece.Common.NativeMethods.CreateRectRgn(0, 0, w, h);
                            break;
                    }
                    Masterpiece.Common.NativeMethods.SetWindowRgn(hwnd, rgn, Masterpiece.Common.NativeMethods.IsWindowVisible(hwnd));

                }
                else
                {
                    System.IntPtr rgn = Masterpiece.Common.NativeMethods.CreateRectRgn(0, 0, w, h);
                    Masterpiece.Common.NativeMethods.SetWindowRgn(hwnd, rgn, Masterpiece.Common.NativeMethods.IsWindowVisible(hwnd));
                }
            }
            else 
            {
                System.IntPtr hwnd = new System.Windows.Interop.WindowInteropHelper(this).Handle;
                Masterpiece.Common.NativeMethods.SetWindowRgn(hwnd, System.IntPtr.Zero, Masterpiece.Common.NativeMethods.IsWindowVisible(hwnd));
            }

        }

        /// <summary>
        /// 
        /// </summary>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private void RegisterCommands() 
        {
            this.CommandBindings.Add(new System.Windows.Input.CommandBinding(MinimizeCommand, new System.Windows.Input.ExecutedRoutedEventHandler(this.PerformMinimize)));
            this.CommandBindings.Add(new System.Windows.Input.CommandBinding(MaximizeCommand, new System.Windows.Input.ExecutedRoutedEventHandler(this.PerformMaximize)));
            this.CommandBindings.Add(new System.Windows.Input.CommandBinding(CloseCommand, new System.Windows.Input.ExecutedRoutedEventHandler(this.PerformClose)));
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="index"></param>
        internal void TryMaximizeGroupItems(int index) 
        {
            if (!this.IsRibbonBarValid())
            {
                return;
            }
            
            try
            {
                double extent = 0;
                RibbonGroup group = null;
                extent = this.CalculateSelectedTabExtent();
                if (extent >= this.RibbonBar.ActualWidth || extent == 0)
                {
                    return;
                }
                for (int i = index; i < this.RibbonBar.SelectedItem.ItemsCollection.Count; i++)
                {
                    group = this.RibbonBar.SelectedItem.ItemsCollection[i];
                    extent -= group.DesiredSize.Width;
                    if (group.Minimized) 
                    {
                        group.SetValue(RibbonGroup.MinimizedPropertyKey, false);
                    }
                    extent += group.DesiredSize.Width;
                    if (extent >= this.RibbonBar.ActualWidth) 
                    {
                        group.SetValue(RibbonGroup.MinimizedPropertyKey, true);
                        return;
                    }
                }
            }
            catch 
            {
                System.Diagnostics.Debug.WriteLine("Couldn't maximize group items: Method:TryMaximizeGroupItems; return: (void*)");
            }
        }

        ///// <summary>
        ///// 
        ///// </summary>
        ///// <param name="index"></param>
        //internal void TryMinimizeGroupItems(int index) 
        //{
        //    if (!this.IsRibbonBarValid())
        //    {
        //        return;
        //    }
        //    try
        //    {
        //        double extent = 0;
        //        RibbonGroup group = null;
        //        extent = this.CalculateSelectedTabExtent();
        //        if (extent >= this.RibbonBar.ActualWidth || extent == 0)
        //        {
        //            return;
        //        }
        //        for (int i = index; i < this.RibbonBar.SelectedItem.ItemsCollection.Count; i++)
        //        {
        //            group = this.RibbonBar.SelectedItem.ItemsCollection[i];
        //            extent -= group.DesiredSize.Width;
        //            if (group.Minimized)
        //            {
        //                group.SetValue(RibbonGroup.MinimizedPropertyKey, false);
        //            }
        //            extent += group.DesiredSize.Width;
        //            if (extent >= this.RibbonBar.ActualWidth)
        //            {
        //                group.SetValue(RibbonGroup.MinimizedPropertyKey, true);
        //                return;
        //            }
        //        }
        //    }
        //    catch
        //    {
        //        System.Diagnostics.Debug.WriteLine("Couldn't maximize group items: Method:TryMaximizeGroupItems; return: (void*)");
        //    }
        //}

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        private bool IsRibbonBarValid() 
        {
            if (this.RibbonBar == null || this.RibbonBar.SelectedItem == null || this.RibbonBar.SelectedItem.ItemsCollection.Count == 0)
            {
                return false;
            }
            return true;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        private double CalculateSelectedTabExtent() 
        {
            double extent = 0;
            RibbonGroup group = null;
            for (int i = 0; i < this.RibbonBar.SelectedItem.ItemsCollection.Count; i++)
            {
                group = this.RibbonBar.SelectedItem.ItemsCollection[i];
                extent += group.DesiredSize.Width;
            }
            return extent;
        }

        #endregion

        #region Event Handlers
        private void OnIsActivePropertyChanged(object sender, System.EventArgs e) 
        {
            if (!this.IsActive)
            {
                if (this.RibbonBar != null && this.RibbonBar.IsBackgroundMode && this.RibbonBar.IsDropDownOpen)
                {
                    this.RibbonBar.IsDropDownOpen = false;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RemoveFromQuickAccessClicked(object sender, RoutedEventArgs e)
        {
            if (this.RibbonQuickAccessToolbar == null) 
            {
                return;
            }
            if (Common.PopupService._ContextOwner != null)
            {
                Interfaces.IRibbonControl control = Common.PopupService._ContextOwner;
                if (Common.PopupService.RibbonBar == null)
                {
                    return;
                }
                this.RibbonQuickAccessToolbar.RemoveItemFromPanel(control);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void AddToQuickAccessClicked(object sender, RoutedEventArgs e)
        {
            RibbonPopupMenuItem menuItem = sender as RibbonPopupMenuItem;
            e.Handled = true;
            if (!menuItem.IsEnabled)
            {
                return;
            }
            if (Common.PopupService._ContextOwner != null)
            {
                Interfaces.IRibbonControl control = Common.PopupService._ContextOwner;
                this.RibbonQuickAccessToolbar.AddItemToPanel(control);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private static void ApplicationMenuChanged(object sender, System.EventArgs e) 
        {
            RibbonWindow win = (sender as RibbonBar).MainWindow;
            win.ApplicationMenu = win.RibbonBar.ApplicationMenu;
            
        }
                
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Item_Click(object sender, RoutedEventArgs e)
        {
            e.Handled = true;
            try
            {
                this.RibbonBar.AnimateGridLength();
            }
            catch { }
        }
        /// <summary>
        /// Called when window size changes
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        private void RibbonWindow_SizeChanged(object sender, System.Windows.SizeChangedEventArgs e)
        {
            this.AttachRegion();
            if (e.WidthChanged)
            {
                double width = 0;
                if (this.RibbonQuickAccessToolbar != null) 
                {
                    width = this.RibbonQuickAccessToolbar.GetLastItemWidth();
                }
                width += 3;
                if (this.RibbonQuickAccessToolbar != null && e.NewSize.Width - 2 * RibbonWindowParameters.BorderWidth - 3 * RibbonWindowParameters.WindowCaptionButtonWidth - 22 - this.Title.Length - this.RibbonQuickAccessToolbar.ActualWidth < 0 && this.RibbonQuickAccessToolbar.CanShorten)
                {
                    this.RibbonQuickAccessToolbar.AddToHiddenPanel();
                }
                else if (this.RibbonQuickAccessToolbar != null &&
                    this.RibbonQuickAccessToolbar.CanExpand &&
                        e.NewSize.Width - 2 * RibbonWindowParameters.BorderWidth - 3 * RibbonWindowParameters.WindowCaptionButtonWidth - 22 - this.Title.Length - this.RibbonQuickAccessToolbar.ActualWidth >= width)
                {
                    this.RibbonQuickAccessToolbar.RemoveFromHiddenPanel();
                }
                width = this.RibbonQuickAccessToolbar != null ? this.RibbonQuickAccessToolbar.MinWidth : 0.0D;
                if (e.NewSize.Width < System.Windows.SystemParameters.MinimizedWindowWidth + width)
                {
                    if (this.RibbonBar != null && this.RibbonBar.Visibility == System.Windows.Visibility.Visible)
                    {
                        this.RibbonBar.Visibility = System.Windows.Visibility.Collapsed;
                        if (this.IsGlassEnabled)
                        {
                            this.SetOptionsForGlass(31);
                        }
                    }
                }
                else
                {
                    if (this.RibbonBar != null)
                    {
                        if (this.RibbonBar.Visibility == System.Windows.Visibility.Collapsed && e.NewSize.Height > 200)
                        {
                            this.RibbonBar.Visibility = System.Windows.Visibility.Visible;
                            if (this.IsGlassEnabled)
                            {
                                this.SetOptionsForGlass();
                            }
                        }
                    }
                }
            }
            else if (e.HeightChanged)
            {
                if (e.NewSize.Height <= 200)
                {
                    if (this.RibbonBar != null)
                    {
                        if (this.RibbonBar.Visibility == System.Windows.Visibility.Visible)
                        {
                            this.RibbonBar.Visibility = System.Windows.Visibility.Collapsed;
                            if (this.IsGlassEnabled)
                            {
                                this.SetOptionsForGlass(31);
                            }
                        }
                    }
                }
                else
                {
                    if (this.RibbonBar != null)
                    {
                        if (this.RibbonBar.Visibility == System.Windows.Visibility.Collapsed)
                        {
                            if (e.NewSize.Width > this.WindowMinWidth + 8)
                            {
                                this.RibbonBar.Visibility = System.Windows.Visibility.Visible;
                                if (this.IsGlassEnabled)
                                {
                                    this.SetOptionsForGlass();
                                }
                            }
                        }
                    }
                }

            }
        }
        
        /// <summary>
        /// Main window procedure WndProc
        /// </summary>
        /// <param name="hwnd"></param>
        /// <param name="msg"></param>
        /// <param name="wParam"></param>
        /// <param name="lParam"></param>
        /// <param name="handled"></param>
        /// <returns></returns>
        [System.Security.SecurityCritical, System.Security.SecurityTreatAsSafe]
        protected virtual System.IntPtr Handler(System.IntPtr hwnd, int msg, System.IntPtr wParam, System.IntPtr lParam, ref bool handled) 
        {
            System.IntPtr result = System.IntPtr.Zero;

            Masterpiece.Common.NativeMethods.WM wm = (Masterpiece.Common.NativeMethods.WM)msg;
            if (System.Environment.OSVersion.Version.Major >= 6) 
            {
                handled = Masterpiece.Common.NativeMethods.DwmDefWindowProc(hwnd, msg, wParam, lParam, out result);
            }
            if (!handled) 
            {
                switch (wm) 
                {
                    case Masterpiece.Common.NativeMethods.WM.NCCALCSIZE:
                        handled = true;
                        break;
                    case Common.NativeMethods.WM.SIZE:
                        handled = false;
                        break;
                    case Masterpiece.Common.NativeMethods.WM.SETICON:
                        handled = true;
                        return System.IntPtr.Zero;
                    case Common.NativeMethods.WM.SETTEXT:
                        handled = true;
                        this.InvalidateArrange();
                        break;

                    case Common.NativeMethods.WM.NCHITTEST:
                        if (result == System.IntPtr.Zero) 
                        {
                            this.WndProcHitTest(hwnd, lParam, ref handled, ref result);
                        }
                        break;
                    case Masterpiece.Common.NativeMethods.WM.DWMCOMPOSITIONCHANGED:
                        this.SetGlassAvaliability();
                        this.InvalidateVisual();
                        this.AttachRegion();
                        handled = true;
                        result = System.IntPtr.Zero;
                        break;
                }
            }
            
            return result;
        }
        
        #endregion

        #region Fields
        private const string partOuterBorder = "PART_OuterBorder";
        private const string partTitleText = "PART_TitleText";
        private const string PART_Content="PART_Content";
        private System.Windows.DependencyObject mainBorder, titleText;
        public System.Windows.Controls.Border ContentBorder { get; set; }
        private RibbonApplicationMenu ApplicationMenu { get; set; }
        //private System.Windows.Point CurrentLocation = new System.Windows.Point();
        internal System.Windows.Controls.Image icon;
        #endregion

        #region Internal Properties

        [System.ComponentModel.Bindable(true), System.ComponentModel.Browsable(false), System.ComponentModel.ReadOnly(true)]
        internal System.Windows.Thickness ContentMargin
        {
            get { return (System.Windows.Thickness)GetValue(ContentMarginProperty); }
            set { SetValue(ContentMarginProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ContentMargin.  This enables animation, styling, binding, etc...
        internal static readonly System.Windows.DependencyProperty ContentMarginProperty =
            System.Windows.DependencyProperty.Register("ContentMargin", typeof(System.Windows.Thickness), typeof(RibbonWindow), new System.Windows.FrameworkPropertyMetadata(RibbonWindowParameters.ContentMargin));
       
        #endregion

        #region IRibbonControl Implementation
        public Interfaces.IRibbonControl Clone()
        {
            throw new System.InvalidOperationException("RibbonWindow cannot be cloned. Note this operation never ends. Create a new insnace instead.");
        }

        public bool IsLarge
        {
            get { return true; }
        }

        public bool IsClonedItem
        {
            get { return false; }
        }

        public bool IsCloneable
        {
            get { return false; }
        }


        public void DisposeControl()
        {
           // throw new System.NotImplementedException();
        }

        public Interfaces.IRibbonControl ParentControl
        {
            get { return null; }
        }
        #endregion
    }
}
