﻿

namespace Masterpiece.Controls.Ribbon2010
{
    public partial class RibbonTabItemsPanel
    {
        
        #region IScrollInfo Implementaion

        public bool CanHorizontallyScroll
        {
            get
            {
                return this.canHScroll;
            }
            set
            {
                this.canHScroll = value;
            }
        }

        public bool CanVerticallyScroll
        {
            get
            {
                return this.canVScroll;
            }
            set
            {
                this.canVScroll = value;
            }
        }

        public double ExtentHeight
        {
            get { return this._extent.Height; }
        }

        public double ExtentWidth
        {
            get { return this._extent.Width; }
        }

        public double HorizontalOffset
        {
            get { return this.offset.X; }
            set { this.offset.X = value; }
        }
        
        public double VerticalOffset
        {
            get { return this.offset.Y; }
        }

        public double ViewportHeight
        {
            get { return this._viewport.Height; }
        }

        public double ViewportWidth
        {
            get { return this._viewport.Width; }
        }
        public void LineDown()
        {
            
        }

        public void LineLeft()
        {
            this.SetHorizontalOffset(this.HorizontalOffset-this.ScrollBy);   
        }

        public void LineRight()
        {
            this.SetHorizontalOffset(this.HorizontalOffset + this.ScrollBy);   
        }

        public void LineUp()
        {
            
        }

        public System.Windows.Rect MakeVisible(System.Windows.Media.Visual visual, System.Windows.Rect rectangle)
        {
            return rectangle;
        }

        public void MouseWheelDown()
        {
        }

        public void MouseWheelLeft()
        {
        }

        public void MouseWheelRight()
        {
        }

        public void MouseWheelUp()
        {
        }

        public void PageDown()
        {
        }

        public void PageLeft()
        {
        }

        public void PageRight()
        {
        }

        public void PageUp()
        {
        }

        public System.Windows.Controls.ScrollViewer ScrollOwner
        {
            get
            {
                return this.scrollViewer;
            }
            set
            {
                this.scrollViewer = value;
            }
        }

        public void SetHorizontalOffset(double offset)
        {
            offset = this.ValidateHorizontalOffset(offset);
            this.offset.X = offset;
            if (this.ScrollOwner != null) 
            {
                this.ScrollOwner.InvalidateScrollInfo();
                this.Scroll(this.HorizontalOffset, this.VerticalOffset);
                this.InvalidateMeasure();
            }
        }

        public void SetVerticalOffset(double offset)
        {
        }

        #endregion

        private double ValidateHorizontalOffset(double offset) 
        {
            if (offset < 0 || this.ViewportWidth >= this.ExtentWidth)
            {
                offset = 0;
            }
            else
            {
                if (offset > this.ExtentWidth - this.ViewportWidth)
                {
                    offset = this.ExtentWidth - this.ViewportWidth;
                }
            }
            return offset;
        }

        private void Scroll(double xOffset, double yOffset) 
        {
            if (this.AnimatedScroll)
            {
                System.Windows.Media.Animation.Storyboard sb = new System.Windows.Media.Animation.Storyboard();
                System.Windows.Media.Animation.DoubleAnimation anim = new System.Windows.Media.Animation.DoubleAnimation();
                System.Windows.Media.Animation.Storyboard.SetTargetProperty(anim,new System.Windows.PropertyPath("(0).(1)", RenderTransformProperty, System.Windows.Media.TranslateTransform.XProperty));
                anim.To = (-1) * xOffset;
                anim.Duration = new System.Windows.Duration(System.TimeSpan.FromMilliseconds(300));
                sb.Children.Add(anim);
                System.EventHandler handler=null;
                handler = delegate 
                {
                    sb.Completed -= handler;
                    sb.Remove(this);
                    this._translate.X = (-1) * xOffset;
                };
                sb.Completed += handler;
                sb.Begin(this);
            }
            else
            {
                this._translate.X = (-1) * xOffset;
            }
        }
        private void UpdateScrollInfo(System.Windows.Size size) 
        {
            bool extentChanged = false, viewportChanged=false;
            double extent = this.CalculateExtent();

            if (this._extent.Width != extent) 
            {
                this._extent.Width = extent;
                extentChanged = true;
            }
            if (this._viewport.Width != size.Width) 
            {
                this._viewport.Width = size.Width;
                viewportChanged = true;
            }

            if ((extentChanged || viewportChanged)&&this.ScrollOwner!=null) 
            {
                this.offset.X = this.ValidateHorizontalOffset(this.HorizontalOffset);
                this.ScrollOwner.InvalidateScrollInfo();
                this.Scroll(this.HorizontalOffset,this.VerticalOffset);
            }
        }

        private double CalculateExtent() 
        {
            System.ComponentModel.DependencyPropertyDescriptor desc = System.ComponentModel.DependencyPropertyDescriptor.FromProperty(RibbonTabItemsPanel.ActualHeightProperty, typeof(RibbonTabItemsPanel));
            
            double size=0;
            foreach (System.Windows.UIElement item in this.InternalChildren)
            {
                size += item.DesiredSize.Width;
            }
            return size;
        }

        
    }
}
