﻿
#region Copyright
/*
 Copyright. Uzbekistan, Tashkent. Ravshan Egashov
 */
#endregion
namespace Masterpiece.Controls.Ribbon2010
{
    public partial class RibbonTabItemsPanel : System.Windows.Controls.Panel, System.Windows.Controls.Primitives.IScrollInfo
    {
        #region Constructors
        static RibbonTabItemsPanel() 
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(RibbonTabItemsPanel), 
                           
                new System.Windows.FrameworkPropertyMetadata(typeof(RibbonTabItemsPanel)));

        }
        public RibbonTabItemsPanel() 
        {
            this._translate = new System.Windows.Media.TranslateTransform();
            this.RenderTransform = this._translate;
            this.canHScroll = false;
            this.canVScroll = false;

            
        }
        #endregion

        #region Properties and Depenency Properties



        public bool AnimatedScroll
        {
            get { return (bool)GetValue(AnimatedScrollProperty); }
            set { SetValue(AnimatedScrollProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AnimatedScroll.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty AnimatedScrollProperty =
            System.Windows.DependencyProperty.Register("AnimatedScroll", typeof(bool), typeof(RibbonTabItemsPanel), new System.Windows.PropertyMetadata(true));



        public double ScrollBy
        {
            get { return (double)GetValue(ScrollByProperty); }
            set { SetValue(ScrollByProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ScrollBy.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty ScrollByProperty =
            System.Windows.DependencyProperty.Register("ScrollBy", typeof(double), typeof(RibbonTabItemsPanel), new System.Windows.PropertyMetadata(3.0D));



        public bool HasScroller
        {
            get { return (bool)GetValue(HasScrollerProperty); }
            set { SetValue(HasScrollerProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HasScroller.  This enables animation, styling, binding, etc...
        public static readonly System.Windows.DependencyProperty HasScrollerProperty =
            System.Windows.DependencyProperty.Register("HasScroller", typeof(bool), typeof(RibbonTabItemsPanel), new System.Windows.PropertyMetadata(true));

        
        
        #endregion

        #region Depenency Property Changed Callbacks

        #endregion

        #region Overrieds

        protected override System.Windows.Size ArrangeOverride(System.Windows.Size finalSize)
        {
            double sum = 0, y=0;
            foreach (System.Windows.UIElement item in this.InternalChildren)
            {
                System.Windows.Size size = item.DesiredSize;
                y = System.Math.Max(y, item.DesiredSize.Height);
                item.Arrange(new System.Windows.Rect(sum + 1, 0, size.Width, size.Height));
                sum += size.Width + 1;
            }
           
            return finalSize;
        }

        protected override System.Windows.Size MeasureOverride(System.Windows.Size availableSize)
        {
            double sum = 0;

            foreach (System.Windows.UIElement item in this.InternalChildren)
            {
                item.Measure(availableSize);
                sum += item.DesiredSize.Width+1;                
            }
            if (this.HasScroller)
            {
                this.UpdateScrollInfo(availableSize);
            }
            return new System.Windows.Size(sum, availableSize.Height);
        }

        #endregion

        #region Private Utilities
        #endregion

        #region Fields
        private bool canVScroll, canHScroll;
        private System.Windows.Media.TranslateTransform _translate;
        private System.Windows.Controls.ScrollViewer scrollViewer;
        private System.Windows.Size _extent=new System.Windows.Size(), _viewport=new System.Windows.Size();
        private System.Windows.Point offset = new System.Windows.Point(0,0);
        #endregion

        


    }
}
